/* A Bison parser, made by GNU Bison 3.7.6.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30706

/* Bison version string.  */
#define YYBISON_VERSION "3.7.6"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* First part of user prologue.  */
#line 9 "src/asm/parser.y"

#include <ctype.h>
#include <errno.h>
#include <inttypes.h>
#include <stdbool.h>
#include <stdint.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "asm/charmap.h"
#include "asm/fixpoint.h"
#include "asm/format.h"
#include "asm/fstack.h"
#include "asm/lexer.h"
#include "asm/macro.h"
#include "asm/main.h"
#include "asm/opt.h"
#include "asm/output.h"
#include "asm/rpn.h"
#include "asm/section.h"
#include "asm/symbol.h"
#include "asm/util.h"
#include "asm/warning.h"

#include "extern/utf8decoder.h"

#include "linkdefs.h"
#include "platform.h" // strncasecmp, strdup

static struct CaptureBody captureBody; /* Captures a REPT/FOR or MACRO */

static void upperstring(char *dest, char const *src)
{
	while (*src)
		*dest++ = toupper(*src++);
	*dest = '\0';
}

static void lowerstring(char *dest, char const *src)
{
	while (*src)
		*dest++ = tolower(*src++);
	*dest = '\0';
}

static uint32_t str2int2(uint8_t *s, int32_t length)
{
	int32_t i;
	uint32_t r = 0;

	i = length < 4 ? 0 : length - 4;
	while (i < length) {
		r <<= 8;
		r |= s[i];
		i++;
	}

	return r;
}

static char *strrstr(char *s1, char *s2)
{
	size_t len1 = strlen(s1);
	size_t len2 = strlen(s2);

	if (len2 > len1)
		return NULL;

	for (char *p = s1 + len1 - len2; p >= s1; p--)
		if (!strncmp(p, s2, len2))
			return p;

	return NULL;
}

static void errorInvalidUTF8Byte(uint8_t byte, char const *functionName)
{
	error("%s: Invalid UTF-8 byte 0x%02hhX\n", functionName, byte);
}

static size_t strlenUTF8(char const *s)
{
	size_t len = 0;
	uint32_t state = 0;

	for (uint32_t codep = 0; *s; s++) {
		uint8_t byte = *s;

		switch (decode(&state, &codep, byte)) {
		case 1:
			errorInvalidUTF8Byte(byte, "STRLEN");
			state = 0;
			/* fallthrough */
		case 0:
			len++;
			break;
		}
	}

	/* Check for partial code point. */
	if (state != 0)
		error("STRLEN: Incomplete UTF-8 character\n");

	return len;
}

static void strsubUTF8(char *dest, size_t destLen, char const *src, uint32_t pos, uint32_t len)
{
	size_t srcIndex = 0;
	size_t destIndex = 0;
	uint32_t state = 0;
	uint32_t codep = 0;
	uint32_t curLen = 0;
	uint32_t curPos = 1;

	/* Advance to starting position in source string. */
	while (src[srcIndex] && curPos < pos) {
		switch (decode(&state, &codep, src[srcIndex])) {
		case 1:
			errorInvalidUTF8Byte(src[srcIndex], "STRSUB");
			state = 0;
			/* fallthrough */
		case 0:
			curPos++;
			break;
		}
		srcIndex++;
	}

	/*
	 * A position 1 past the end of the string is allowed, but will trigger the
	 * "Length too big" warning below if the length is nonzero.
	 */
	if (!src[srcIndex] && pos > curPos)
		warning(WARNING_BUILTIN_ARG,
			"STRSUB: Position %" PRIu32 " is past the end of the string\n", pos);

	/* Copy from source to destination. */
	while (src[srcIndex] && destIndex < destLen - 1 && curLen < len) {
		switch (decode(&state, &codep, src[srcIndex])) {
		case 1:
			errorInvalidUTF8Byte(src[srcIndex], "STRSUB");
			state = 0;
			/* fallthrough */
		case 0:
			curLen++;
			break;
		}
		dest[destIndex++] = src[srcIndex++];
	}

	if (curLen < len)
		warning(WARNING_BUILTIN_ARG, "STRSUB: Length too big: %" PRIu32 "\n", len);

	/* Check for partial code point. */
	if (state != 0)
		error("STRSUB: Incomplete UTF-8 character\n");

	dest[destIndex] = '\0';
}

static size_t charlenUTF8(char const *s)
{
	size_t len;

	for (len = 0; charmap_ConvertNext(&s, NULL); len++)
		;

	return len;
}

static void charsubUTF8(char *dest, char const *src, uint32_t pos)
{
	size_t charLen = 1;

	/* Advance to starting position in source string. */
	for (uint32_t curPos = 1; charLen && curPos < pos; curPos++)
		charLen = charmap_ConvertNext(&src, NULL);

	char const *start = src;

	if (!charmap_ConvertNext(&src, NULL))
		warning(WARNING_BUILTIN_ARG,
			"CHARSUB: Position %" PRIu32 " is past the end of the string\n", pos);

	/* Copy from source to destination. */
	memcpy(dest, start, src - start);

	dest[src - start] = '\0';
}

static uint32_t adjustNegativePos(int32_t pos, size_t len, char const *functionName)
{
	/*
	 * STRSUB and CHARSUB adjust negative `pos` arguments the same way,
	 * such that position -1 is the last character of a string.
	 */
	if (pos < 0)
		pos += len + 1;
	if (pos < 1) {
		warning(WARNING_BUILTIN_ARG, "%s: Position starts at 1\n", functionName);
		pos = 1;
	}
	return (uint32_t)pos;
}

static void strrpl(char *dest, size_t destLen, char const *src, char const *old, char const *new)
{
	size_t oldLen = strlen(old);
	size_t newLen = strlen(new);
	size_t i = 0;

	if (!oldLen) {
		warning(WARNING_EMPTY_STRRPL, "STRRPL: Cannot replace an empty string\n");
		strcpy(dest, src);
		return;
	}

	for (char const *next = strstr(src, old); next && *next; next = strstr(src, old)) {
		// Copy anything before the substring to replace
		unsigned int lenBefore = next - src;

		memcpy(dest + i, src, lenBefore < destLen - i ? lenBefore : destLen - i);
		i += next - src;
		if (i >= destLen)
			break;

		// Copy the replacement substring
		memcpy(dest + i, new, newLen < destLen - i ? newLen : destLen - i);
		i += newLen;
		if (i >= destLen)
			break;

		src = next + oldLen;
	}

	if (i < destLen) {
		size_t srcLen = strlen(src);

		// Copy anything after the last replaced substring
		memcpy(dest + i, src, srcLen < destLen - i ? srcLen : destLen - i);
		i += srcLen;
	}

	if (i >= destLen) {
		warning(WARNING_LONG_STR, "STRRPL: String too long, got truncated\n");
		i = destLen - 1;
	}
	dest[i] = '\0';
}

static void initStrFmtArgList(struct StrFmtArgList *args)
{
	args->nbArgs = 0;
	args->capacity = INITIAL_STRFMT_ARG_SIZE;
	args->args = malloc(args->capacity * sizeof(*args->args));
	if (!args->args)
		fatalerror("Failed to allocate memory for STRFMT arg list: %s\n",
			   strerror(errno));
}

static size_t nextStrFmtArgListIndex(struct StrFmtArgList *args)
{
	if (args->nbArgs == args->capacity) {
		args->capacity = (args->capacity + 1) * 2;
		args->args = realloc(args->args, args->capacity * sizeof(*args->args));
		if (!args->args)
			fatalerror("realloc error while resizing STRFMT arg list: %s\n",
				   strerror(errno));
	}
	return args->nbArgs++;
}

static void freeStrFmtArgList(struct StrFmtArgList *args)
{
	free(args->format);
	for (size_t i = 0; i < args->nbArgs; i++)
		if (!args->args[i].isNumeric)
			free(args->args[i].string);
	free(args->args);
}

static void strfmt(char *dest, size_t destLen, char const *fmt, size_t nbArgs, struct StrFmtArg *args)
{
	size_t a = 0;
	size_t i = 0;

	while (i < destLen) {
		int c = *fmt++;

		if (c == '\0') {
			break;
		} else if (c != '%') {
			dest[i++] = c;
			continue;
		}

		c = *fmt++;

		if (c == '%') {
			dest[i++] = c;
			continue;
		}

		struct FormatSpec spec = fmt_NewSpec();

		while (c != '\0') {
			fmt_UseCharacter(&spec, c);
			if (fmt_IsFinished(&spec))
				break;
			c = *fmt++;
		}

		if (fmt_IsEmpty(&spec)) {
			error("STRFMT: Illegal '%%' at end of format string\n");
			dest[i++] = '%';
			break;
		} else if (!fmt_IsValid(&spec)) {
			error("STRFMT: Invalid format spec for argument %zu\n", a + 1);
			dest[i++] = '%';
			a++;
			continue;
		} else if (a >= nbArgs) {
			// Will warn after formatting is done.
			dest[i++] = '%';
			a++;
			continue;
		}

		struct StrFmtArg *arg = &args[a++];
		static char buf[MAXSTRLEN + 1];

		if (arg->isNumeric)
			fmt_PrintNumber(buf, sizeof(buf), &spec, arg->number);
		else
			fmt_PrintString(buf, sizeof(buf), &spec, arg->string);

		i += snprintf(&dest[i], destLen - i, "%s", buf);
	}

	if (a < nbArgs)
		error("STRFMT: %zu unformatted argument(s)\n", nbArgs - a);
	else if (a > nbArgs)
		error("STRFMT: Not enough arguments for format spec, got: %zu, need: %zu\n", nbArgs, a);

	if (i > destLen - 1) {
		warning(WARNING_LONG_STR, "STRFMT: String too long, got truncated\n");
		i = destLen - 1;
	}
	dest[i] = '\0';
}

static void initDsArgList(struct DsArgList *args)
{
	args->nbArgs = 0;
	args->capacity = INITIAL_DS_ARG_SIZE;
	args->args = malloc(args->capacity * sizeof(*args->args));
	if (!args->args)
		fatalerror("Failed to allocate memory for ds arg list: %s\n",
			   strerror(errno));
}

static size_t nextDsArgListIndex(struct DsArgList *args)
{
	if (args->nbArgs == args->capacity) {
		args->capacity = (args->capacity + 1) * 2;
		args->args = realloc(args->args, args->capacity * sizeof(*args->args));
		if (!args->args)
			fatalerror("realloc error while resizing ds arg list: %s\n",
				   strerror(errno));
	}
	return args->nbArgs++;
}

static void freeDsArgList(struct DsArgList *args)
{
	free(args->args);
}

static void failAssert(enum AssertionType type)
{
	switch (type) {
		case ASSERT_FATAL:
			fatalerror("Assertion failed\n");
		case ASSERT_ERROR:
			error("Assertion failed\n");
			break;
		case ASSERT_WARN:
			warning(WARNING_ASSERT, "Assertion failed\n");
			break;
	}
}

static void failAssertMsg(enum AssertionType type, char const *msg)
{
	switch (type) {
		case ASSERT_FATAL:
			fatalerror("Assertion failed: %s\n", msg);
		case ASSERT_ERROR:
			error("Assertion failed: %s\n", msg);
			break;
		case ASSERT_WARN:
			warning(WARNING_ASSERT, "Assertion failed: %s\n", msg);
			break;
	}
}

void yyerror(char const *str)
{
	error("%s\n", str);
}

// The CPU encodes instructions in a logical way, so most instructions actually follow patterns.
// These enums thus help with bit twiddling to compute opcodes
enum {
	REG_B = 0,
	REG_C,
	REG_D,
	REG_E,
	REG_H,
	REG_L,
	REG_HL_IND,
	REG_A
};

enum {
	REG_BC_IND = 0,
	REG_DE_IND,
	REG_HL_INDINC,
	REG_HL_INDDEC,
};

enum {
	REG_BC = 0,
	REG_DE = 1,
	REG_HL = 2,
	// LD/INC/ADD/DEC allow SP, PUSH/POP allow AF
	REG_SP = 3,
	REG_AF = 3
};

enum {
	CC_NZ = 0,
	CC_Z,
	CC_NC,
	CC_C
};


#line 522 "src/asm/parser.c"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

#include "parser.h"
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_T_NUMBER = 3,                   /* "number"  */
  YYSYMBOL_T_STRING = 4,                   /* "string"  */
  YYSYMBOL_T_PERIOD = 5,                   /* "."  */
  YYSYMBOL_T_COMMA = 6,                    /* ","  */
  YYSYMBOL_T_COLON = 7,                    /* ":"  */
  YYSYMBOL_T_LBRACK = 8,                   /* "["  */
  YYSYMBOL_T_RBRACK = 9,                   /* "]"  */
  YYSYMBOL_T_LPAREN = 10,                  /* "("  */
  YYSYMBOL_T_RPAREN = 11,                  /* ")"  */
  YYSYMBOL_T_NEWLINE = 12,                 /* "newline"  */
  YYSYMBOL_T_OP_LOGICNOT = 13,             /* "!"  */
  YYSYMBOL_T_OP_LOGICAND = 14,             /* "&&"  */
  YYSYMBOL_T_OP_LOGICOR = 15,              /* "||"  */
  YYSYMBOL_T_OP_LOGICGT = 16,              /* ">"  */
  YYSYMBOL_T_OP_LOGICLT = 17,              /* "<"  */
  YYSYMBOL_T_OP_LOGICGE = 18,              /* ">="  */
  YYSYMBOL_T_OP_LOGICLE = 19,              /* "<="  */
  YYSYMBOL_T_OP_LOGICNE = 20,              /* "!="  */
  YYSYMBOL_T_OP_LOGICEQU = 21,             /* "=="  */
  YYSYMBOL_T_OP_ADD = 22,                  /* "+"  */
  YYSYMBOL_T_OP_SUB = 23,                  /* "-"  */
  YYSYMBOL_T_OP_OR = 24,                   /* "|"  */
  YYSYMBOL_T_OP_XOR = 25,                  /* "^"  */
  YYSYMBOL_T_OP_AND = 26,                  /* "&"  */
  YYSYMBOL_T_OP_SHL = 27,                  /* "<<"  */
  YYSYMBOL_T_OP_SHR = 28,                  /* ">>"  */
  YYSYMBOL_T_OP_MUL = 29,                  /* "*"  */
  YYSYMBOL_T_OP_DIV = 30,                  /* "/"  */
  YYSYMBOL_T_OP_MOD = 31,                  /* "%"  */
  YYSYMBOL_T_OP_NOT = 32,                  /* "~"  */
  YYSYMBOL_NEG = 33,                       /* NEG  */
  YYSYMBOL_T_OP_EXP = 34,                  /* "**"  */
  YYSYMBOL_T_OP_DEF = 35,                  /* "DEF"  */
  YYSYMBOL_T_OP_BANK = 36,                 /* "BANK"  */
  YYSYMBOL_T_OP_ALIGN = 37,                /* "ALIGN"  */
  YYSYMBOL_T_OP_SIZEOF = 38,               /* "SIZEOF"  */
  YYSYMBOL_T_OP_STARTOF = 39,              /* "STARTOF"  */
  YYSYMBOL_T_OP_SIN = 40,                  /* "SIN"  */
  YYSYMBOL_T_OP_COS = 41,                  /* "COS"  */
  YYSYMBOL_T_OP_TAN = 42,                  /* "TAN"  */
  YYSYMBOL_T_OP_ASIN = 43,                 /* "ASIN"  */
  YYSYMBOL_T_OP_ACOS = 44,                 /* "ACOS"  */
  YYSYMBOL_T_OP_ATAN = 45,                 /* "ATAN"  */
  YYSYMBOL_T_OP_ATAN2 = 46,                /* "ATAN2"  */
  YYSYMBOL_T_OP_FDIV = 47,                 /* "FDIV"  */
  YYSYMBOL_T_OP_FMUL = 48,                 /* "FMUL"  */
  YYSYMBOL_T_OP_POW = 49,                  /* "POW"  */
  YYSYMBOL_T_OP_LOG = 50,                  /* "LOG"  */
  YYSYMBOL_T_OP_ROUND = 51,                /* "ROUND"  */
  YYSYMBOL_T_OP_CEIL = 52,                 /* "CEIL"  */
  YYSYMBOL_T_OP_FLOOR = 53,                /* "FLOOR"  */
  YYSYMBOL_T_OP_HIGH = 54,                 /* "HIGH"  */
  YYSYMBOL_T_OP_LOW = 55,                  /* "LOW"  */
  YYSYMBOL_T_OP_ISCONST = 56,              /* "ISCONST"  */
  YYSYMBOL_T_OP_STRCMP = 57,               /* "STRCMP"  */
  YYSYMBOL_T_OP_STRIN = 58,                /* "STRIN"  */
  YYSYMBOL_T_OP_STRRIN = 59,               /* "STRRIN"  */
  YYSYMBOL_T_OP_STRSUB = 60,               /* "STRSUB"  */
  YYSYMBOL_T_OP_STRLEN = 61,               /* "STRLEN"  */
  YYSYMBOL_T_OP_STRCAT = 62,               /* "STRCAT"  */
  YYSYMBOL_T_OP_STRUPR = 63,               /* "STRUPR"  */
  YYSYMBOL_T_OP_STRLWR = 64,               /* "STRLWR"  */
  YYSYMBOL_T_OP_STRRPL = 65,               /* "STRRPL"  */
  YYSYMBOL_T_OP_STRFMT = 66,               /* "STRFMT"  */
  YYSYMBOL_T_OP_CHARLEN = 67,              /* "CHARLEN"  */
  YYSYMBOL_T_OP_CHARSUB = 68,              /* "CHARSUB"  */
  YYSYMBOL_T_LABEL = 69,                   /* "label"  */
  YYSYMBOL_T_ID = 70,                      /* "identifier"  */
  YYSYMBOL_T_LOCAL_ID = 71,                /* "local identifier"  */
  YYSYMBOL_T_ANON = 72,                    /* "anonymous label"  */
  YYSYMBOL_T_POP_EQU = 73,                 /* "EQU"  */
  YYSYMBOL_T_POP_SET = 74,                 /* "SET"  */
  YYSYMBOL_T_POP_EQUAL = 75,               /* "="  */
  YYSYMBOL_T_POP_EQUS = 76,                /* "EQUS"  */
  YYSYMBOL_T_POP_INCLUDE = 77,             /* "INCLUDE"  */
  YYSYMBOL_T_POP_PRINT = 78,               /* "PRINT"  */
  YYSYMBOL_T_POP_PRINTLN = 79,             /* "PRINTLN"  */
  YYSYMBOL_T_POP_PRINTF = 80,              /* "PRINTF"  */
  YYSYMBOL_T_POP_PRINTT = 81,              /* "PRINTT"  */
  YYSYMBOL_T_POP_PRINTV = 82,              /* "PRINTV"  */
  YYSYMBOL_T_POP_PRINTI = 83,              /* "PRINTI"  */
  YYSYMBOL_T_POP_IF = 84,                  /* "IF"  */
  YYSYMBOL_T_POP_ELIF = 85,                /* "ELIF"  */
  YYSYMBOL_T_POP_ELSE = 86,                /* "ELSE"  */
  YYSYMBOL_T_POP_ENDC = 87,                /* "ENDC"  */
  YYSYMBOL_T_POP_EXPORT = 88,              /* "EXPORT"  */
  YYSYMBOL_T_POP_DB = 89,                  /* "DB"  */
  YYSYMBOL_T_POP_DS = 90,                  /* "DS"  */
  YYSYMBOL_T_POP_DW = 91,                  /* "DW"  */
  YYSYMBOL_T_POP_DL = 92,                  /* "DL"  */
  YYSYMBOL_T_POP_SECTION = 93,             /* "SECTION"  */
  YYSYMBOL_T_POP_FRAGMENT = 94,            /* "FRAGMENT"  */
  YYSYMBOL_T_POP_RB = 95,                  /* "RB"  */
  YYSYMBOL_T_POP_RW = 96,                  /* "RW"  */
  YYSYMBOL_T_POP_MACRO = 97,               /* "MACRO"  */
  YYSYMBOL_T_POP_ENDM = 98,                /* "ENDM"  */
  YYSYMBOL_T_POP_RSRESET = 99,             /* "RSRESET"  */
  YYSYMBOL_T_POP_RSSET = 100,              /* "RSSET"  */
  YYSYMBOL_T_POP_UNION = 101,              /* "UNION"  */
  YYSYMBOL_T_POP_NEXTU = 102,              /* "NEXTU"  */
  YYSYMBOL_T_POP_ENDU = 103,               /* "ENDU"  */
  YYSYMBOL_T_POP_INCBIN = 104,             /* "INCBIN"  */
  YYSYMBOL_T_POP_REPT = 105,               /* "REPT"  */
  YYSYMBOL_T_POP_FOR = 106,                /* "FOR"  */
  YYSYMBOL_T_POP_CHARMAP = 107,            /* "CHARMAP"  */
  YYSYMBOL_T_POP_NEWCHARMAP = 108,         /* "NEWCHARMAP"  */
  YYSYMBOL_T_POP_SETCHARMAP = 109,         /* "SETCHARMAP"  */
  YYSYMBOL_T_POP_PUSHC = 110,              /* "PUSHC"  */
  YYSYMBOL_T_POP_POPC = 111,               /* "POPC"  */
  YYSYMBOL_T_POP_SHIFT = 112,              /* "SHIFT"  */
  YYSYMBOL_T_POP_ENDR = 113,               /* "ENDR"  */
  YYSYMBOL_T_POP_BREAK = 114,              /* "BREAK"  */
  YYSYMBOL_T_POP_LOAD = 115,               /* "LOAD"  */
  YYSYMBOL_T_POP_ENDL = 116,               /* "ENDL"  */
  YYSYMBOL_T_POP_FAIL = 117,               /* "FAIL"  */
  YYSYMBOL_T_POP_WARN = 118,               /* "WARN"  */
  YYSYMBOL_T_POP_FATAL = 119,              /* "FATAL"  */
  YYSYMBOL_T_POP_ASSERT = 120,             /* "ASSERT"  */
  YYSYMBOL_T_POP_STATIC_ASSERT = 121,      /* "STATIC_ASSERT"  */
  YYSYMBOL_T_POP_PURGE = 122,              /* "PURGE"  */
  YYSYMBOL_T_POP_REDEF = 123,              /* "REDEF"  */
  YYSYMBOL_T_POP_POPS = 124,               /* "POPS"  */
  YYSYMBOL_T_POP_PUSHS = 125,              /* "PUSHS"  */
  YYSYMBOL_T_POP_POPO = 126,               /* "POPO"  */
  YYSYMBOL_T_POP_PUSHO = 127,              /* "PUSHO"  */
  YYSYMBOL_T_POP_OPT = 128,                /* "OPT"  */
  YYSYMBOL_T_SECT_ROM0 = 129,              /* "ROM0"  */
  YYSYMBOL_T_SECT_ROMX = 130,              /* "ROMX"  */
  YYSYMBOL_T_SECT_WRAM0 = 131,             /* "WRAM0"  */
  YYSYMBOL_T_SECT_WRAMX = 132,             /* "WRAMX"  */
  YYSYMBOL_T_SECT_HRAM = 133,              /* "HRAM"  */
  YYSYMBOL_T_SECT_VRAM = 134,              /* "VRAM"  */
  YYSYMBOL_T_SECT_SRAM = 135,              /* "SRAM"  */
  YYSYMBOL_T_SECT_OAM = 136,               /* "OAM"  */
  YYSYMBOL_T_Z80_ADC = 137,                /* "adc"  */
  YYSYMBOL_T_Z80_ADD = 138,                /* "add"  */
  YYSYMBOL_T_Z80_AND = 139,                /* "and"  */
  YYSYMBOL_T_Z80_BIT = 140,                /* "bit"  */
  YYSYMBOL_T_Z80_CALL = 141,               /* "call"  */
  YYSYMBOL_T_Z80_CCF = 142,                /* "ccf"  */
  YYSYMBOL_T_Z80_CP = 143,                 /* "cp"  */
  YYSYMBOL_T_Z80_CPL = 144,                /* "cpl"  */
  YYSYMBOL_T_Z80_DAA = 145,                /* "daa"  */
  YYSYMBOL_T_Z80_DEC = 146,                /* "dec"  */
  YYSYMBOL_T_Z80_DI = 147,                 /* "di"  */
  YYSYMBOL_T_Z80_EI = 148,                 /* "ei"  */
  YYSYMBOL_T_Z80_HALT = 149,               /* "halt"  */
  YYSYMBOL_T_Z80_INC = 150,                /* "inc"  */
  YYSYMBOL_T_Z80_JP = 151,                 /* "jp"  */
  YYSYMBOL_T_Z80_JR = 152,                 /* "jr"  */
  YYSYMBOL_T_Z80_LD = 153,                 /* "ld"  */
  YYSYMBOL_T_Z80_LDI = 154,                /* "ldi"  */
  YYSYMBOL_T_Z80_LDD = 155,                /* "ldd"  */
  YYSYMBOL_T_Z80_LDH = 156,                /* "ldh"  */
  YYSYMBOL_T_Z80_NOP = 157,                /* "nop"  */
  YYSYMBOL_T_Z80_OR = 158,                 /* "or"  */
  YYSYMBOL_T_Z80_POP = 159,                /* "pop"  */
  YYSYMBOL_T_Z80_PUSH = 160,               /* "push"  */
  YYSYMBOL_T_Z80_RES = 161,                /* "res"  */
  YYSYMBOL_T_Z80_RET = 162,                /* "ret"  */
  YYSYMBOL_T_Z80_RETI = 163,               /* "reti"  */
  YYSYMBOL_T_Z80_RST = 164,                /* "rst"  */
  YYSYMBOL_T_Z80_RL = 165,                 /* "rl"  */
  YYSYMBOL_T_Z80_RLA = 166,                /* "rla"  */
  YYSYMBOL_T_Z80_RLC = 167,                /* "rlc"  */
  YYSYMBOL_T_Z80_RLCA = 168,               /* "rlca"  */
  YYSYMBOL_T_Z80_RR = 169,                 /* "rr"  */
  YYSYMBOL_T_Z80_RRA = 170,                /* "rra"  */
  YYSYMBOL_T_Z80_RRC = 171,                /* "rrc"  */
  YYSYMBOL_T_Z80_RRCA = 172,               /* "rrca"  */
  YYSYMBOL_T_Z80_SBC = 173,                /* "sbc"  */
  YYSYMBOL_T_Z80_SCF = 174,                /* "scf"  */
  YYSYMBOL_T_Z80_STOP = 175,               /* "stop"  */
  YYSYMBOL_T_Z80_SLA = 176,                /* "sla"  */
  YYSYMBOL_T_Z80_SRA = 177,                /* "sra"  */
  YYSYMBOL_T_Z80_SRL = 178,                /* "srl"  */
  YYSYMBOL_T_Z80_SUB = 179,                /* "sub"  */
  YYSYMBOL_T_Z80_SWAP = 180,               /* "swap"  */
  YYSYMBOL_T_Z80_XOR = 181,                /* "xor"  */
  YYSYMBOL_T_TOKEN_A = 182,                /* "a"  */
  YYSYMBOL_T_TOKEN_B = 183,                /* "b"  */
  YYSYMBOL_T_TOKEN_C = 184,                /* "c"  */
  YYSYMBOL_T_TOKEN_D = 185,                /* "d"  */
  YYSYMBOL_T_TOKEN_E = 186,                /* "e"  */
  YYSYMBOL_T_TOKEN_H = 187,                /* "h"  */
  YYSYMBOL_T_TOKEN_L = 188,                /* "l"  */
  YYSYMBOL_T_MODE_AF = 189,                /* "af"  */
  YYSYMBOL_T_MODE_BC = 190,                /* "bc"  */
  YYSYMBOL_T_MODE_DE = 191,                /* "de"  */
  YYSYMBOL_T_MODE_SP = 192,                /* "sp"  */
  YYSYMBOL_T_MODE_HL = 193,                /* "hl"  */
  YYSYMBOL_T_MODE_HL_DEC = 194,            /* "hld/hl-"  */
  YYSYMBOL_T_MODE_HL_INC = 195,            /* "hli/hl+"  */
  YYSYMBOL_T_CC_NZ = 196,                  /* "nz"  */
  YYSYMBOL_T_CC_Z = 197,                   /* "z"  */
  YYSYMBOL_T_CC_NC = 198,                  /* "nc"  */
  YYSYMBOL_T_EOB = 199,                    /* "end of buffer"  */
  YYSYMBOL_YYACCEPT = 200,                 /* $accept  */
  YYSYMBOL_asmfile = 201,                  /* asmfile  */
  YYSYMBOL_lines = 202,                    /* lines  */
  YYSYMBOL_endofline = 203,                /* endofline  */
  YYSYMBOL_plain_directive = 204,          /* plain_directive  */
  YYSYMBOL_line = 205,                     /* line  */
  YYSYMBOL_line_directive = 206,           /* line_directive  */
  YYSYMBOL_if = 207,                       /* if  */
  YYSYMBOL_elif = 208,                     /* elif  */
  YYSYMBOL_else = 209,                     /* else  */
  YYSYMBOL_endc = 210,                     /* endc  */
  YYSYMBOL_def_id = 211,                   /* def_id  */
  YYSYMBOL_212_1 = 212,                    /* $@1  */
  YYSYMBOL_redef_id = 213,                 /* redef_id  */
  YYSYMBOL_214_2 = 214,                    /* $@2  */
  YYSYMBOL_scoped_id = 215,                /* scoped_id  */
  YYSYMBOL_scoped_anon_id = 216,           /* scoped_anon_id  */
  YYSYMBOL_label = 217,                    /* label  */
  YYSYMBOL_macro = 218,                    /* macro  */
  YYSYMBOL_219_3 = 219,                    /* $@3  */
  YYSYMBOL_macroargs = 220,                /* macroargs  */
  YYSYMBOL_assignment_directive = 221,     /* assignment_directive  */
  YYSYMBOL_directive = 222,                /* directive  */
  YYSYMBOL_trailing_comma = 223,           /* trailing_comma  */
  YYSYMBOL_equ = 224,                      /* equ  */
  YYSYMBOL_set_or_equal = 225,             /* set_or_equal  */
  YYSYMBOL_set = 226,                      /* set  */
  YYSYMBOL_equs = 227,                     /* equs  */
  YYSYMBOL_rb = 228,                       /* rb  */
  YYSYMBOL_rw = 229,                       /* rw  */
  YYSYMBOL_rl = 230,                       /* rl  */
  YYSYMBOL_align = 231,                    /* align  */
  YYSYMBOL_opt = 232,                      /* opt  */
  YYSYMBOL_233_4 = 233,                    /* $@4  */
  YYSYMBOL_opt_list = 234,                 /* opt_list  */
  YYSYMBOL_opt_list_entry = 235,           /* opt_list_entry  */
  YYSYMBOL_popo = 236,                     /* popo  */
  YYSYMBOL_pusho = 237,                    /* pusho  */
  YYSYMBOL_pops = 238,                     /* pops  */
  YYSYMBOL_pushs = 239,                    /* pushs  */
  YYSYMBOL_fail = 240,                     /* fail  */
  YYSYMBOL_warn = 241,                     /* warn  */
  YYSYMBOL_assert_type = 242,              /* assert_type  */
  YYSYMBOL_assert = 243,                   /* assert  */
  YYSYMBOL_shift = 244,                    /* shift  */
  YYSYMBOL_load = 245,                     /* load  */
  YYSYMBOL_rept = 246,                     /* rept  */
  YYSYMBOL_247_5 = 247,                    /* @5  */
  YYSYMBOL_for = 248,                      /* for  */
  YYSYMBOL_249_6 = 249,                    /* $@6  */
  YYSYMBOL_250_7 = 250,                    /* $@7  */
  YYSYMBOL_251_8 = 251,                    /* @8  */
  YYSYMBOL_for_args = 252,                 /* for_args  */
  YYSYMBOL_break = 253,                    /* break  */
  YYSYMBOL_macrodef = 254,                 /* macrodef  */
  YYSYMBOL_255_9 = 255,                    /* $@9  */
  YYSYMBOL_256_10 = 256,                   /* $@10  */
  YYSYMBOL_257_11 = 257,                   /* @11  */
  YYSYMBOL_258_12 = 258,                   /* @12  */
  YYSYMBOL_rsset = 259,                    /* rsset  */
  YYSYMBOL_rsreset = 260,                  /* rsreset  */
  YYSYMBOL_rs_uconst = 261,                /* rs_uconst  */
  YYSYMBOL_union = 262,                    /* union  */
  YYSYMBOL_nextu = 263,                    /* nextu  */
  YYSYMBOL_endu = 264,                     /* endu  */
  YYSYMBOL_ds = 265,                       /* ds  */
  YYSYMBOL_ds_args = 266,                  /* ds_args  */
  YYSYMBOL_db = 267,                       /* db  */
  YYSYMBOL_dw = 268,                       /* dw  */
  YYSYMBOL_dl = 269,                       /* dl  */
  YYSYMBOL_def_equ = 270,                  /* def_equ  */
  YYSYMBOL_redef_equ = 271,                /* redef_equ  */
  YYSYMBOL_def_set = 272,                  /* def_set  */
  YYSYMBOL_def_rb = 273,                   /* def_rb  */
  YYSYMBOL_def_rw = 274,                   /* def_rw  */
  YYSYMBOL_def_rl = 275,                   /* def_rl  */
  YYSYMBOL_def_equs = 276,                 /* def_equs  */
  YYSYMBOL_redef_equs = 277,               /* redef_equs  */
  YYSYMBOL_purge = 278,                    /* purge  */
  YYSYMBOL_279_13 = 279,                   /* $@13  */
  YYSYMBOL_purge_list = 280,               /* purge_list  */
  YYSYMBOL_purge_list_entry = 281,         /* purge_list_entry  */
  YYSYMBOL_export = 282,                   /* export  */
  YYSYMBOL_export_list = 283,              /* export_list  */
  YYSYMBOL_export_list_entry = 284,        /* export_list_entry  */
  YYSYMBOL_include = 285,                  /* include  */
  YYSYMBOL_incbin = 286,                   /* incbin  */
  YYSYMBOL_charmap = 287,                  /* charmap  */
  YYSYMBOL_newcharmap = 288,               /* newcharmap  */
  YYSYMBOL_setcharmap = 289,               /* setcharmap  */
  YYSYMBOL_pushc = 290,                    /* pushc  */
  YYSYMBOL_popc = 291,                     /* popc  */
  YYSYMBOL_print = 292,                    /* print  */
  YYSYMBOL_println = 293,                  /* println  */
  YYSYMBOL_print_exprs = 294,              /* print_exprs  */
  YYSYMBOL_print_expr = 295,               /* print_expr  */
  YYSYMBOL_printt = 296,                   /* printt  */
  YYSYMBOL_printv = 297,                   /* printv  */
  YYSYMBOL_printi = 298,                   /* printi  */
  YYSYMBOL_printf = 299,                   /* printf  */
  YYSYMBOL_const_3bit = 300,               /* const_3bit  */
  YYSYMBOL_constlist_8bit = 301,           /* constlist_8bit  */
  YYSYMBOL_constlist_8bit_entry = 302,     /* constlist_8bit_entry  */
  YYSYMBOL_constlist_16bit = 303,          /* constlist_16bit  */
  YYSYMBOL_constlist_16bit_entry = 304,    /* constlist_16bit_entry  */
  YYSYMBOL_constlist_32bit = 305,          /* constlist_32bit  */
  YYSYMBOL_constlist_32bit_entry = 306,    /* constlist_32bit_entry  */
  YYSYMBOL_reloc_8bit = 307,               /* reloc_8bit  */
  YYSYMBOL_reloc_8bit_no_str = 308,        /* reloc_8bit_no_str  */
  YYSYMBOL_reloc_8bit_offset = 309,        /* reloc_8bit_offset  */
  YYSYMBOL_reloc_16bit = 310,              /* reloc_16bit  */
  YYSYMBOL_reloc_16bit_no_str = 311,       /* reloc_16bit_no_str  */
  YYSYMBOL_relocexpr = 312,                /* relocexpr  */
  YYSYMBOL_relocexpr_no_str = 313,         /* relocexpr_no_str  */
  YYSYMBOL_314_14 = 314,                   /* $@14  */
  YYSYMBOL_uconst = 315,                   /* uconst  */
  YYSYMBOL_const = 316,                    /* const  */
  YYSYMBOL_const_no_str = 317,             /* const_no_str  */
  YYSYMBOL_const_8bit = 318,               /* const_8bit  */
  YYSYMBOL_string = 319,                   /* string  */
  YYSYMBOL_strcat_args = 320,              /* strcat_args  */
  YYSYMBOL_strfmt_args = 321,              /* strfmt_args  */
  YYSYMBOL_strfmt_va_args = 322,           /* strfmt_va_args  */
  YYSYMBOL_section = 323,                  /* section  */
  YYSYMBOL_sectmod = 324,                  /* sectmod  */
  YYSYMBOL_sectiontype = 325,              /* sectiontype  */
  YYSYMBOL_sectorg = 326,                  /* sectorg  */
  YYSYMBOL_sectattrs = 327,                /* sectattrs  */
  YYSYMBOL_cpu_command = 328,              /* cpu_command  */
  YYSYMBOL_z80_adc = 329,                  /* z80_adc  */
  YYSYMBOL_z80_add = 330,                  /* z80_add  */
  YYSYMBOL_z80_and = 331,                  /* z80_and  */
  YYSYMBOL_z80_bit = 332,                  /* z80_bit  */
  YYSYMBOL_z80_call = 333,                 /* z80_call  */
  YYSYMBOL_z80_ccf = 334,                  /* z80_ccf  */
  YYSYMBOL_z80_cp = 335,                   /* z80_cp  */
  YYSYMBOL_z80_cpl = 336,                  /* z80_cpl  */
  YYSYMBOL_z80_daa = 337,                  /* z80_daa  */
  YYSYMBOL_z80_dec = 338,                  /* z80_dec  */
  YYSYMBOL_z80_di = 339,                   /* z80_di  */
  YYSYMBOL_z80_ei = 340,                   /* z80_ei  */
  YYSYMBOL_z80_halt = 341,                 /* z80_halt  */
  YYSYMBOL_z80_inc = 342,                  /* z80_inc  */
  YYSYMBOL_z80_jp = 343,                   /* z80_jp  */
  YYSYMBOL_z80_jr = 344,                   /* z80_jr  */
  YYSYMBOL_z80_ldi = 345,                  /* z80_ldi  */
  YYSYMBOL_z80_ldd = 346,                  /* z80_ldd  */
  YYSYMBOL_z80_ldio = 347,                 /* z80_ldio  */
  YYSYMBOL_c_ind = 348,                    /* c_ind  */
  YYSYMBOL_z80_ld = 349,                   /* z80_ld  */
  YYSYMBOL_z80_ld_hl = 350,                /* z80_ld_hl  */
  YYSYMBOL_z80_ld_sp = 351,                /* z80_ld_sp  */
  YYSYMBOL_z80_ld_mem = 352,               /* z80_ld_mem  */
  YYSYMBOL_z80_ld_cind = 353,              /* z80_ld_cind  */
  YYSYMBOL_z80_ld_rr = 354,                /* z80_ld_rr  */
  YYSYMBOL_z80_ld_r = 355,                 /* z80_ld_r  */
  YYSYMBOL_z80_ld_a = 356,                 /* z80_ld_a  */
  YYSYMBOL_z80_ld_ss = 357,                /* z80_ld_ss  */
  YYSYMBOL_z80_nop = 358,                  /* z80_nop  */
  YYSYMBOL_z80_or = 359,                   /* z80_or  */
  YYSYMBOL_z80_pop = 360,                  /* z80_pop  */
  YYSYMBOL_z80_push = 361,                 /* z80_push  */
  YYSYMBOL_z80_res = 362,                  /* z80_res  */
  YYSYMBOL_z80_ret = 363,                  /* z80_ret  */
  YYSYMBOL_z80_reti = 364,                 /* z80_reti  */
  YYSYMBOL_z80_rl = 365,                   /* z80_rl  */
  YYSYMBOL_z80_rla = 366,                  /* z80_rla  */
  YYSYMBOL_z80_rlc = 367,                  /* z80_rlc  */
  YYSYMBOL_z80_rlca = 368,                 /* z80_rlca  */
  YYSYMBOL_z80_rr = 369,                   /* z80_rr  */
  YYSYMBOL_z80_rra = 370,                  /* z80_rra  */
  YYSYMBOL_z80_rrc = 371,                  /* z80_rrc  */
  YYSYMBOL_z80_rrca = 372,                 /* z80_rrca  */
  YYSYMBOL_z80_rst = 373,                  /* z80_rst  */
  YYSYMBOL_z80_sbc = 374,                  /* z80_sbc  */
  YYSYMBOL_z80_scf = 375,                  /* z80_scf  */
  YYSYMBOL_z80_set = 376,                  /* z80_set  */
  YYSYMBOL_z80_sla = 377,                  /* z80_sla  */
  YYSYMBOL_z80_sra = 378,                  /* z80_sra  */
  YYSYMBOL_z80_srl = 379,                  /* z80_srl  */
  YYSYMBOL_z80_stop = 380,                 /* z80_stop  */
  YYSYMBOL_z80_sub = 381,                  /* z80_sub  */
  YYSYMBOL_z80_swap = 382,                 /* z80_swap  */
  YYSYMBOL_z80_xor = 383,                  /* z80_xor  */
  YYSYMBOL_op_mem_ind = 384,               /* op_mem_ind  */
  YYSYMBOL_op_a_r = 385,                   /* op_a_r  */
  YYSYMBOL_op_a_n = 386,                   /* op_a_n  */
  YYSYMBOL_T_MODE_A = 387,                 /* T_MODE_A  */
  YYSYMBOL_T_MODE_B = 388,                 /* T_MODE_B  */
  YYSYMBOL_T_MODE_C = 389,                 /* T_MODE_C  */
  YYSYMBOL_T_MODE_D = 390,                 /* T_MODE_D  */
  YYSYMBOL_T_MODE_E = 391,                 /* T_MODE_E  */
  YYSYMBOL_T_MODE_H = 392,                 /* T_MODE_H  */
  YYSYMBOL_T_MODE_L = 393,                 /* T_MODE_L  */
  YYSYMBOL_ccode = 394,                    /* ccode  */
  YYSYMBOL_reg_r = 395,                    /* reg_r  */
  YYSYMBOL_reg_tt = 396,                   /* reg_tt  */
  YYSYMBOL_reg_ss = 397,                   /* reg_ss  */
  YYSYMBOL_reg_rr = 398,                   /* reg_rr  */
  YYSYMBOL_hl_ind_inc = 399,               /* hl_ind_inc  */
  YYSYMBOL_hl_ind_dec = 400                /* hl_ind_dec  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int16 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

#if defined __GNUC__ && ! defined __ICC && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                            \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if 1

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
# define YYCOPY_NEEDED 1
#endif /* 1 */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  3
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   2157

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  200
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  201
/* YYNRULES -- Number of rules.  */
#define YYNRULES  501
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  889

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   454


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX) YY_CAST (yysymbol_kind_t, YYX)

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   668,   668,   671,   672,   675,   675,   678,   679,   680,
     681,   682,   685,   686,   687,   698,   699,   700,   701,   702,
     703,   705,   706,   709,   719,   736,   752,   757,   757,   765,
     765,   773,   773,   774,   774,   776,   777,   780,   783,   786,
     789,   793,   799,   799,   807,   810,   816,   817,   818,   819,
     820,   821,   824,   825,   826,   827,   828,   829,   830,   831,
     832,   833,   834,   835,   836,   837,   838,   839,   840,   841,
     842,   843,   844,   845,   846,   847,   848,   849,   850,   851,
     852,   853,   854,   855,   856,   857,   858,   859,   860,   861,
     862,   863,   864,   865,   866,   867,   870,   870,   873,   876,
     876,   879,   882,   885,   891,   897,   903,   909,   920,   920,
     926,   927,   930,   933,   936,   939,   942,   945,   948,   951,
     952,   953,   954,   957,   968,   979,   983,   989,   990,   993,
     996,   999,   999,  1008,  1010,  1012,  1008,  1020,  1025,  1030,
    1037,  1043,  1045,  1047,  1043,  1054,  1054,  1063,  1066,  1069,
    1072,  1075,  1078,  1081,  1084,  1085,  1091,  1097,  1105,  1106,
    1109,  1110,  1113,  1114,  1117,  1122,  1127,  1130,  1135,  1141,
    1147,  1153,  1158,  1163,  1163,  1170,  1171,  1174,  1177,  1180,
    1181,  1184,  1187,  1194,  1199,  1204,  1211,  1216,  1217,  1220,
    1223,  1226,  1229,  1232,  1236,  1242,  1243,  1246,  1247,  1250,
    1256,  1262,  1268,  1274,  1286,  1287,  1290,  1293,  1302,  1303,
    1306,  1309,  1318,  1319,  1322,  1325,  1335,  1341,  1347,  1351,
    1357,  1363,  1370,  1371,  1382,  1383,  1384,  1387,  1390,  1393,
    1396,  1399,  1402,  1405,  1408,  1411,  1414,  1417,  1420,  1423,
    1426,  1429,  1432,  1435,  1438,  1441,  1444,  1445,  1446,  1447,
    1448,  1449,  1450,  1454,  1455,  1456,  1457,  1457,  1466,  1469,
    1472,  1475,  1478,  1481,  1484,  1487,  1490,  1493,  1496,  1499,
    1502,  1505,  1508,  1511,  1516,  1521,  1524,  1527,  1530,  1537,
    1540,  1543,  1546,  1547,  1553,  1559,  1565,  1568,  1571,  1574,
    1577,  1580,  1586,  1587,  1598,  1606,  1609,  1616,  1625,  1630,
    1631,  1632,  1635,  1636,  1637,  1638,  1639,  1640,  1641,  1642,
    1645,  1646,  1656,  1661,  1664,  1668,  1675,  1676,  1677,  1678,
    1679,  1680,  1681,  1682,  1683,  1684,  1685,  1686,  1687,  1688,
    1689,  1690,  1691,  1692,  1693,  1694,  1695,  1696,  1697,  1698,
    1699,  1700,  1701,  1702,  1703,  1704,  1705,  1706,  1707,  1708,
    1709,  1710,  1711,  1712,  1713,  1714,  1715,  1716,  1717,  1718,
    1719,  1720,  1723,  1727,  1730,  1734,  1735,  1736,  1743,  1747,
    1750,  1756,  1760,  1766,  1769,  1773,  1776,  1779,  1782,  1783,
    1786,  1789,  1792,  1799,  1800,  1803,  1807,  1811,  1816,  1820,
    1826,  1829,  1834,  1837,  1842,  1848,  1854,  1857,  1862,  1863,
    1869,  1870,  1871,  1872,  1873,  1874,  1875,  1876,  1879,  1883,
    1889,  1890,  1896,  1900,  1913,  1918,  1923,  1927,  1935,  1941,
    1947,  1965,  1969,  1979,  1982,  1986,  1989,  1992,  1995,  2001,
    2002,  2005,  2008,  2014,  2017,  2023,  2026,  2032,  2035,  2041,
    2044,  2054,  2058,  2061,  2064,  2070,  2076,  2082,  2088,  2092,
    2098,  2102,  2105,  2111,  2115,  2118,  2121,  2122,  2125,  2126,
    2129,  2130,  2133,  2134,  2137,  2138,  2141,  2142,  2145,  2146,
    2149,  2150,  2153,  2154,  2157,  2158,  2159,  2160,  2163,  2164,
    2165,  2166,  2167,  2168,  2169,  2170,  2173,  2174,  2175,  2176,
    2179,  2180,  2181,  2182,  2185,  2186,  2187,  2188,  2191,  2192,
    2195,  2196
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if 1
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  static const char *const yy_sname[] =
  {
  "end of file", "error", "invalid token", "number", "string", ".", ",",
  ":", "[", "]", "(", ")", "newline", "!", "&&", "||", ">", "<", ">=",
  "<=", "!=", "==", "+", "-", "|", "^", "&", "<<", ">>", "*", "/", "%",
  "~", "NEG", "**", "DEF", "BANK", "ALIGN", "SIZEOF", "STARTOF", "SIN",
  "COS", "TAN", "ASIN", "ACOS", "ATAN", "ATAN2", "FDIV", "FMUL", "POW",
  "LOG", "ROUND", "CEIL", "FLOOR", "HIGH", "LOW", "ISCONST", "STRCMP",
  "STRIN", "STRRIN", "STRSUB", "STRLEN", "STRCAT", "STRUPR", "STRLWR",
  "STRRPL", "STRFMT", "CHARLEN", "CHARSUB", "label", "identifier",
  "local identifier", "anonymous label", "EQU", "SET", "=", "EQUS",
  "INCLUDE", "PRINT", "PRINTLN", "PRINTF", "PRINTT", "PRINTV", "PRINTI",
  "IF", "ELIF", "ELSE", "ENDC", "EXPORT", "DB", "DS", "DW", "DL",
  "SECTION", "FRAGMENT", "RB", "RW", "MACRO", "ENDM", "RSRESET", "RSSET",
  "UNION", "NEXTU", "ENDU", "INCBIN", "REPT", "FOR", "CHARMAP",
  "NEWCHARMAP", "SETCHARMAP", "PUSHC", "POPC", "SHIFT", "ENDR", "BREAK",
  "LOAD", "ENDL", "FAIL", "WARN", "FATAL", "ASSERT", "STATIC_ASSERT",
  "PURGE", "REDEF", "POPS", "PUSHS", "POPO", "PUSHO", "OPT", "ROM0",
  "ROMX", "WRAM0", "WRAMX", "HRAM", "VRAM", "SRAM", "OAM", "adc", "add",
  "and", "bit", "call", "ccf", "cp", "cpl", "daa", "dec", "di", "ei",
  "halt", "inc", "jp", "jr", "ld", "ldi", "ldd", "ldh", "nop", "or", "pop",
  "push", "res", "ret", "reti", "rst", "rl", "rla", "rlc", "rlca", "rr",
  "rra", "rrc", "rrca", "sbc", "scf", "stop", "sla", "sra", "srl", "sub",
  "swap", "xor", "a", "b", "c", "d", "e", "h", "l", "af", "bc", "de", "sp",
  "hl", "hld/hl-", "hli/hl+", "nz", "z", "nc", "end of buffer", "$accept",
  "asmfile", "lines", "endofline", "plain_directive", "line",
  "line_directive", "if", "elif", "else", "endc", "def_id", "$@1",
  "redef_id", "$@2", "scoped_id", "scoped_anon_id", "label", "macro",
  "$@3", "macroargs", "assignment_directive", "directive",
  "trailing_comma", "equ", "set_or_equal", "set", "equs", "rb", "rw", "rl",
  "align", "opt", "$@4", "opt_list", "opt_list_entry", "popo", "pusho",
  "pops", "pushs", "fail", "warn", "assert_type", "assert", "shift",
  "load", "rept", "@5", "for", "$@6", "$@7", "@8", "for_args", "break",
  "macrodef", "$@9", "$@10", "@11", "@12", "rsset", "rsreset", "rs_uconst",
  "union", "nextu", "endu", "ds", "ds_args", "db", "dw", "dl", "def_equ",
  "redef_equ", "def_set", "def_rb", "def_rw", "def_rl", "def_equs",
  "redef_equs", "purge", "$@13", "purge_list", "purge_list_entry",
  "export", "export_list", "export_list_entry", "include", "incbin",
  "charmap", "newcharmap", "setcharmap", "pushc", "popc", "print",
  "println", "print_exprs", "print_expr", "printt", "printv", "printi",
  "printf", "const_3bit", "constlist_8bit", "constlist_8bit_entry",
  "constlist_16bit", "constlist_16bit_entry", "constlist_32bit",
  "constlist_32bit_entry", "reloc_8bit", "reloc_8bit_no_str",
  "reloc_8bit_offset", "reloc_16bit", "reloc_16bit_no_str", "relocexpr",
  "relocexpr_no_str", "$@14", "uconst", "const", "const_no_str",
  "const_8bit", "string", "strcat_args", "strfmt_args", "strfmt_va_args",
  "section", "sectmod", "sectiontype", "sectorg", "sectattrs",
  "cpu_command", "z80_adc", "z80_add", "z80_and", "z80_bit", "z80_call",
  "z80_ccf", "z80_cp", "z80_cpl", "z80_daa", "z80_dec", "z80_di", "z80_ei",
  "z80_halt", "z80_inc", "z80_jp", "z80_jr", "z80_ldi", "z80_ldd",
  "z80_ldio", "c_ind", "z80_ld", "z80_ld_hl", "z80_ld_sp", "z80_ld_mem",
  "z80_ld_cind", "z80_ld_rr", "z80_ld_r", "z80_ld_a", "z80_ld_ss",
  "z80_nop", "z80_or", "z80_pop", "z80_push", "z80_res", "z80_ret",
  "z80_reti", "z80_rl", "z80_rla", "z80_rlc", "z80_rlca", "z80_rr",
  "z80_rra", "z80_rrc", "z80_rrca", "z80_rst", "z80_sbc", "z80_scf",
  "z80_set", "z80_sla", "z80_sra", "z80_srl", "z80_stop", "z80_sub",
  "z80_swap", "z80_xor", "op_mem_ind", "op_a_r", "op_a_n", "T_MODE_A",
  "T_MODE_B", "T_MODE_C", "T_MODE_D", "T_MODE_E", "T_MODE_H", "T_MODE_L",
  "ccode", "reg_r", "reg_tt", "reg_ss", "reg_rr", "hl_ind_inc",
  "hl_ind_dec", YY_NULLPTR
  };
  return yy_sname[yysymbol];
}
#endif

#ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_int16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454
};
#endif

#define YYPACT_NINF (-430)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-298)

#define yytable_value_is_error(Yyn) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
    -430,    70,   855,  -430,     9,  -430,   258,    99,  2064,  2064,
     101,  -430,  2064,  -430,     9,  -430,  -430,  -430,  -430,  -430,
    1885,  -430,  -430,  -430,  -430,  -430,  -430,  -430,  -430,  -430,
    -430,  -430,  -430,  -430,  -430,  -430,     2,  2064,  -430,  -430,
     491,  2064,  2064,  2064,  2064,   108,  -430,  -430,  2064,  2064,
    2064,  2064,  2064,  -430,   120,   122,   147,   148,   153,   154,
     160,   192,   208,   211,   213,   219,   231,   232,   237,   241,
     246,   256,   257,   262,   263,   273,   314,   315,   317,   318,
     320,   329,   330,   338,   345,   346,  -430,  -430,  -430,  -430,
    -430,  1330,  -430,   126,  -430,   347,  -430,   287,   348,  -430,
     291,  -430,  -430,  2064,  -430,  2064,   491,  2064,  2064,  2064,
     491,  2064,  2064,  -430,   -54,  2064,  2064,  2064,  2064,    -5,
    -430,  2064,  -430,  -430,  -430,   491,   491,   292,   299,  -430,
    -430,  2064,     9,    -5,  -430,   491,   491,   118,   118,  -430,
    -430,  -430,  -430,  -430,  -430,  -430,  1680,  1271,  1680,  2064,
    1104,  -430,  1680,  -430,  -430,   159,  -430,  -430,  -430,   159,
    1034,  1104,   203,    57,    58,    64,  -430,  1680,    37,    37,
    2064,   -37,  -430,  2064,   216,  -430,   216,  -430,   216,  -430,
     216,  -430,  1680,  -430,  2064,   216,   216,   216,  1680,   216,
    1680,  -430,   344,   220,  -430,  -430,  -430,  -430,  -430,  -430,
    -430,  -430,  -430,  -430,  -430,  -430,  -430,  -430,  -430,  -430,
    -430,  -430,  -430,  -430,  -430,  -430,  -430,  -430,  -430,  -430,
    -430,  -430,  -430,  -430,  -430,  -430,  -430,  -430,  -430,  -430,
    -430,  -430,  -430,  -430,  -430,  -430,  -430,  -430,  -430,  -430,
    -430,  -430,  -430,  -430,  -430,  -430,  -430,  -430,  -430,  -430,
    -430,  -430,  -430,  -430,  -430,  -430,  -430,  -430,  -430,  -430,
    -430,  -430,  -430,  -430,  -430,  -430,  -430,  -430,  -430,  -430,
    -430,  -430,  -430,  -430,  -430,  -430,  -430,  -430,  -430,  -430,
    -430,  -430,  -430,  -430,  -430,  -430,  -430,  -430,  -430,  -430,
    -430,  -430,  -430,  -430,  -430,   362,  -430,  -430,  -430,  -430,
    -430,  -430,  -430,  -430,   751,   341,   341,   341,   341,   366,
     417,   491,   491,  2064,  2064,  2064,  2064,  2064,  2064,  2064,
    2064,  2064,  2064,  2064,  2064,  2064,  2064,  2064,  2064,  2064,
     491,   491,   491,   491,   491,    60,   491,   491,   491,   491,
     491,   491,  2064,  2064,  2064,  2064,  2064,  2064,  2064,  2064,
    2064,  2064,  2064,  2064,  2064,  2064,  2064,  2064,  2064,  2064,
    2064,  -430,  -430,  -430,  -430,  -430,   309,   374,  -430,   375,
    -430,     9,   376,  -430,  1330,     8,  -430,    23,   376,  -430,
    -430,  -430,  -430,  -430,   377,  -430,   378,  -430,  -430,    26,
      33,   391,   399,  -430,  -430,    44,    45,   400,  -430,    46,
      56,  -430,  -430,   491,  -430,   402,   403,   404,  -430,  -430,
    -430,   491,  -430,  -430,   405,   406,   410,  2064,  2064,   -54,
     352,   420,   233,   415,   418,  -430,  -430,  -430,  -430,  -430,
    -430,  -430,  -430,  1330,  -430,  -430,   421,  -430,  -430,  -430,
    -430,  -430,  -430,  -430,   426,   427,  -430,  -430,  -430,  -430,
     428,  -430,  -430,  -430,  -430,  -430,  1330,   429,  -430,  -430,
     431,   432,  -430,  -430,  -430,  -430,  -430,  -430,  -430,  -430,
    -430,  -430,  -430,   430,  -430,   437,  1201,   457,   458,   459,
     460,   461,   463,   464,   465,  -430,  -430,   244,   462,   467,
     245,   468,  1837,   470,   478,   480,  -430,  -430,  -430,  -430,
    -430,  -430,  -430,  -430,   485,  -430,  -430,  -430,  -430,  -430,
    -430,  -430,  -430,  -430,  -430,  -430,  -430,  -430,  -430,  -430,
    -430,  -430,  2064,   491,  2064,  2064,  2064,  2064,  2064,   491,
    2064,  -430,  -430,   189,   487,   490,   499,   500,   502,   503,
     504,   505,   509,   510,   516,   519,   521,   522,   523,   526,
     527,   530,   773,   799,  1166,   528,   536,   537,   538,   534,
    -430,  -430,    77,   541,   547,   554,  -430,   550,   551,   557,
    1496,   889,   573,   573,   573,   573,   573,   573,   585,   585,
     337,   337,   337,   251,   251,   341,   341,   341,  -430,   553,
       9,   560,  -430,  2064,   563,   216,  -430,  2064,  -430,  -430,
     -54,  -430,  2064,  -430,  2064,  2064,  -430,  2064,  -430,   562,
    2064,  2064,   501,   564,  -430,  -430,  -430,   622,   567,  -430,
     569,  -430,  -430,  -430,   420,  -430,   570,  1365,  1438,  1680,
    2064,   145,   216,  2064,    98,   -93,  2064,  2064,   566,   571,
     574,    72,   576,   577,   579,  2123,   580,  2064,  2064,   133,
    1525,   -20,    24,  1751,   -20,   581,   393,   583,   584,   597,
     -20,   -20,   609,   216,  -430,  -430,  -430,  -430,  -430,  -430,
    -430,  -430,  -430,     9,   610,  -430,  -430,  -430,  -430,  -430,
    -430,  -430,  -430,  -430,  -430,  2064,  2064,  2064,  2064,  2064,
    -430,  -430,  -430,  -430,  -430,  -430,   491,   491,   491,  2064,
    -430,   491,  -430,  -430,  -430,   491,   586,  -430,  -430,  2064,
    -430,  -430,  2064,  -430,  -430,  -430,  -430,  -430,  -430,   614,
    -430,  -430,  -430,   544,   616,  -430,  -430,  -430,   544,   491,
     491,   -54,  -430,  -430,  -430,   612,   613,   615,   618,   619,
     620,   621,  -430,  -430,  -430,  -430,  -430,  -430,  -430,  -430,
    1598,  -430,  -430,   624,   625,  -430,  -430,  -430,  1837,  -430,
    -430,  -430,  -430,  -430,    31,  -430,  -430,  -430,  -430,  -430,
    -430,  -430,  -430,  -430,  -430,   648,   434,   649,   466,  -430,
    -430,  -430,  -430,  -430,  -430,  -430,   646,   647,   650,   651,
     656,   658,   659,   660,   110,  -430,   680,  2064,   676,     9,
     677,   682,  2064,  -430,  -430,  -430,  -430,  -430,  -430,  -430,
    -430,  -430,   617,  2064,   617,  -430,  -430,  -430,  -430,  -430,
    -430,  -430,  -430,  -430,  -430,  -430,  -430,   681,  2064,  2064,
    -430,   -20,   684,   -20,   685,  -430,  -430,  -430,  -430,  -430,
    -430,  -430,  -430,  2064,  -430,   491,  -430,   128,  -430,  -430,
    -430,  2064,  -430,  2064,  -430,  -430,  -430,  -430,  1330,  1330,
    -430,  -430,  -430,  -430,   687,   689,     9,   695,   693,   697,
     697,  -430,  -430,  -430,  2064,  -430,    50,  -430,   683,   703,
    2064,  2064,   705,   206,  -430,  2064,  -430,   706,  -430
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_int16 yydefact[] =
{
       3,     0,     0,     1,     0,    36,     0,    37,     0,     0,
       0,   141,     0,   133,     0,     4,    13,    20,    21,    22,
       7,    11,    46,    47,    51,    48,    49,    50,    16,    17,
      18,    15,    19,     5,     6,    14,    39,     0,    99,   100,
       0,   149,   149,   149,     0,    38,   225,   282,     0,     0,
       0,     0,     0,   256,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    31,    32,    34,    33,
     224,   279,   222,     0,   223,     0,    25,     0,     0,   278,
       0,    12,    27,     0,    42,     0,     0,     0,   193,     0,
       0,     0,     0,    26,     0,   158,     0,   160,   162,   299,
     148,     0,   151,   152,   153,     0,     0,     0,     0,   190,
     191,   127,     0,   299,   130,     0,     0,   119,   119,   173,
      29,   115,   116,   113,   114,   108,     0,     0,     0,     0,
       0,   373,     0,   376,   377,     0,   380,   381,   382,     0,
       0,     0,     0,     0,     0,     0,   423,     0,     0,     0,
       0,   429,   431,     0,     0,   433,     0,   435,     0,   437,
       0,   439,     0,   443,   448,     0,     0,     0,     0,     0,
       0,    52,     0,     0,     9,    10,    95,    94,    92,    93,
      90,    91,    78,    79,    80,    77,    76,    66,    65,    67,
      68,    69,    63,    60,    61,    62,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    59,    70,    71,    72,    73,
      74,    75,    53,    54,    56,    57,    58,    55,    64,     8,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   334,   333,   335,   332,
     404,   405,   400,   401,   402,   406,   407,   403,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,    41,     0,    98,   102,   103,   150,
     104,   105,   101,    40,     0,   226,   246,   247,   248,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    23,    24,   142,   131,   134,     0,   106,    44,     0,
     203,     0,    96,   195,     0,   222,   197,   223,    96,   202,
     199,   200,   201,   181,    96,   179,    96,   204,   206,   222,
     223,   154,    96,   208,   210,   222,   223,    96,   212,   222,
     223,   301,   300,     0,   147,   183,     0,   187,   189,   128,
     140,     0,   117,   118,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   460,   462,   464,   466,   468,
     470,   472,   458,   216,   363,   362,   485,   478,   479,   480,
     481,   482,   483,   456,     0,     0,   365,   364,   369,   368,
       0,   477,   474,   475,   476,   371,   220,     0,   375,   374,
       0,     0,   490,   491,   493,   492,   485,   378,   379,   383,
     384,   387,   385,     0,   388,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   496,   497,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   425,   424,   489,   486,
     487,   488,   426,   427,     0,   430,   440,   432,   434,   436,
     438,   442,   441,   449,   445,   446,   447,   451,   450,   452,
     454,   453,     0,     0,   149,   149,   149,     0,     0,     0,
       0,   145,   277,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     286,   292,     0,     0,     0,     0,   295,     0,     0,     0,
     228,   227,   230,   231,   232,   233,   234,   229,   235,   236,
     238,   237,   239,   240,   241,   242,   243,   244,   245,     0,
       0,     0,    28,     0,    43,     0,   182,    97,   192,   194,
      97,   178,    97,   159,     0,    97,   161,    97,   163,     0,
       0,     0,     0,     0,   121,   120,   122,   123,   125,   177,
      96,   175,    30,   112,   109,   110,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   220,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   164,   171,   168,   169,   170,   166,
     165,   172,   167,     0,     0,   252,   253,   254,   255,   265,
     266,   267,   268,   269,   270,     0,     0,     0,     0,     0,
     258,   259,   260,   249,   250,   251,     0,     0,     0,     0,
     275,     0,   287,   288,   289,     0,   294,   291,   276,     0,
     143,   132,     0,   107,    45,   444,   196,   180,   205,    96,
     156,   209,   213,     0,   184,   281,   186,   188,     0,     0,
       0,    97,   174,   111,   484,     0,     0,     0,     0,     0,
       0,     0,   459,   457,   367,   366,   370,   372,   386,   389,
       0,   494,   495,     0,     0,   500,   498,   455,     0,   398,
     421,   422,   410,   411,     0,   409,   414,   412,   413,   416,
     418,   420,   417,   419,   415,     0,     0,     0,     0,   397,
     395,   396,   394,   428,   146,   257,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   293,     0,     0,     0,     0,
       0,   137,    97,   155,   305,   304,   302,   307,   306,   303,
     308,   309,   310,     0,   310,   124,   126,   176,   461,   463,
     467,   471,   465,   469,   473,   499,   501,     0,     0,     0,
     408,     0,     0,     0,     0,   271,   261,   262,   263,   264,
     272,   273,   274,     0,   284,     0,   296,   223,   285,   144,
     135,     0,   157,     0,   312,   185,   312,   399,   218,   219,
     390,   391,   392,   393,     0,     0,     0,   138,     0,   298,
     129,   283,   290,   136,     0,   311,     0,   139,     0,     0,
       0,     0,     0,     0,   315,     0,   313,     0,   314
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -430,  -430,  -430,   -13,  -430,  -430,  -430,  -430,  -430,  -430,
    -430,  -430,  -430,  -430,  -430,   -96,  -302,  -430,  -430,  -430,
    -430,  -430,  -430,  -356,  -430,   -44,  -430,  -430,  -430,  -430,
    -430,  -430,  -430,  -430,  -430,    92,  -430,  -430,  -430,  -430,
    -430,  -430,   582,  -430,  -430,  -430,  -430,  -430,  -430,  -430,
    -430,  -430,  -430,  -430,  -430,  -430,  -430,  -430,  -430,  -430,
    -430,   -19,  -430,  -430,  -430,  -430,  -430,  -430,  -430,  -430,
    -430,  -430,  -430,  -430,  -430,  -430,  -430,  -430,  -430,  -430,
    -430,   -14,  -430,  -430,   119,  -430,  -430,  -430,  -430,  -430,
    -430,  -430,  -430,  -430,   626,   121,  -430,  -430,  -430,  -430,
     -94,  -430,   123,  -430,   116,  -430,   115,  -136,  -430,  -430,
    -101,  -430,   102,  -105,  -430,   -12,    -4,   -74,  -430,   -33,
    -430,  -430,  -430,  -430,   591,    -2,   -87,  -128,  -430,  -430,
    -430,  -430,  -430,  -430,  -430,  -430,  -430,  -430,  -430,  -430,
    -430,  -430,  -430,  -430,  -430,  -430,  -430,  -430,  -154,  -430,
    -430,  -430,  -430,  -430,  -430,  -430,  -430,  -430,  -430,  -430,
    -430,  -430,  -430,  -430,  -430,  -430,  -430,  -430,  -430,  -430,
    -430,  -430,  -430,  -430,  -430,  -430,  -430,  -430,  -430,  -430,
    -430,  -430,  -430,  -430,  -150,    86,   225,  -121,  -430,  -429,
    -430,  -430,  -430,  -430,   -81,   -45,   568,  -153,    80,  -430,
    -430
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
       0,     1,     2,    35,    14,    15,    16,    17,    18,    19,
     191,   192,   366,   193,   420,    89,    90,    20,   194,   368,
     594,    21,   195,   598,    22,    44,    23,    24,    25,    26,
      27,   196,   197,   421,   624,   625,   198,   199,   200,   201,
     202,   203,   417,   204,   205,   206,    28,   590,    29,   100,
     591,   866,   800,    30,    31,    97,   589,   799,   673,   207,
     208,   298,   209,   210,   211,   212,   719,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   419,
     620,   621,   225,   384,   385,    32,   226,   227,   228,   229,
     230,   231,   232,   233,   372,   373,   234,   235,   236,   237,
     369,   386,   387,   392,   393,   397,   398,   432,   388,   830,
     644,   394,    91,    92,   309,   299,    99,   376,   726,    94,
     562,   567,   706,   238,   403,   812,   854,   869,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   481,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,   293,   482,   434,   435,   466,   437,   438,
     439,   440,   441,   442,   457,   443,   502,   468,   484,   485,
     486
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
      98,   101,   375,   375,    93,    95,   470,   297,   534,   294,
     389,   493,   395,   399,  -280,   494,    86,    87,   383,  -280,
    -280,    33,   599,   300,   301,   436,   436,   436,   601,  -198,
     603,   436,  -217,   296,   488,  -198,   606,   506,  -217,  -207,
     302,   608,   489,   491,   495,  -207,   436,   646,   513,   455,
    -221,  -211,  -214,   828,   829,   450,  -221,  -211,  -214,   472,
     474,   436,  -215,   646,    47,   487,   490,   436,  -215,   436,
       3,   560,   492,   371,   377,   377,   504,   380,   488,   473,
     475,   734,   390,   701,   396,   400,   878,   879,   702,   401,
     505,   367,   405,   406,   753,   754,   402,   739,   740,   295,
     741,   370,   412,   413,   391,   379,    45,   381,   382,   404,
     467,   488,   488,    96,   469,   303,   843,   483,   488,   410,
      77,   844,    79,    80,    81,    82,    83,   409,    85,   507,
     310,   508,   311,   509,  -297,   510,    46,    47,   361,  -297,
     514,   515,   516,    48,   519,   370,    49,   451,   527,   530,
     304,   305,   306,   307,   308,    50,    51,   312,   313,   452,
     453,   454,   425,   314,   315,    52,   370,   422,    53,    54,
     316,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,   317,    86,    87,    88,   425,  -280,    34,   374,
     374,   476,   885,   460,   461,   886,   767,   374,   318,   374,
     374,   319,  -198,   320,   422,  -217,   498,   499,   500,   321,
     501,   674,  -207,   446,   448,   414,   415,   416,   458,   425,
     425,   322,   323,  -221,  -211,  -214,   425,   324,   433,   433,
     433,   325,   456,   496,   433,  -215,   326,   460,   461,    86,
      87,    88,   456,   456,   732,    36,   327,   328,   511,   433,
     460,   461,   329,   330,   517,   433,   520,   535,   536,   537,
     357,   358,   359,   331,   433,   360,   433,   735,   736,   737,
     433,   738,   433,   528,    38,    39,   529,   555,   556,   557,
     558,   559,   561,   563,   564,   565,   566,   568,   569,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   619,   332,   333,   762,   334,   335,   827,
     336,    37,    38,    39,    40,   462,   463,   464,   465,   337,
     338,   425,   426,   427,   428,   429,   430,   431,   339,   462,
     463,   464,   465,    41,    42,   340,   341,   363,   596,   362,
     364,   365,   407,   803,   355,   356,   357,   358,   359,   408,
     609,   360,   447,   449,   531,   360,   533,   459,   613,   592,
     593,   595,   597,   600,   602,   425,   426,   427,   428,   429,
     430,   431,   497,   477,   478,   479,   480,   604,   425,   426,
     427,   428,   429,   430,   431,   605,   607,   512,   610,   611,
     612,   614,   615,   518,   618,   521,   616,   522,    38,    39,
     523,    47,   622,    43,   623,   627,   626,   629,   628,   552,
     553,   554,   630,   631,   632,   633,   636,   655,   658,   524,
     525,   634,   635,   637,   570,   571,   572,   573,   574,   575,
     576,   577,   578,   579,   580,   581,   582,   583,   584,   585,
     586,   587,   588,   647,   648,   649,   650,   651,   720,   652,
     653,   654,   656,   657,   659,   725,   660,    77,   745,    79,
      80,    81,    82,    83,   661,    85,   662,    86,    87,    88,
     665,   663,   375,   742,   744,    47,   671,   389,   675,   770,
     395,   676,   399,   771,   383,   666,   667,   668,   781,   526,
     677,   678,   782,   679,   680,   681,   682,   769,   664,   617,
     683,   684,   685,   669,   670,   686,   672,   687,   688,   689,
     766,   768,   747,   774,   696,   748,   749,   690,   691,   779,
     780,   692,   697,   698,   699,   700,   760,   761,   763,   765,
     715,    77,   703,    79,    80,    81,    82,    83,   704,    85,
     705,   707,   708,   709,   377,   710,   712,   714,   723,   390,
     728,   727,   396,   730,   400,   731,   750,   711,   645,   734,
     751,   713,   735,   752,   743,   755,   756,   746,   757,   759,
     775,   776,   797,   777,   645,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   778,   724,   360,   772,   352,
     353,   354,   355,   356,   357,   358,   359,   492,   783,   360,
     802,   785,   813,   818,   819,   853,   820,   832,   729,   821,
     822,   823,   824,   825,   826,   619,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   831,   833,   360,   835,   836,   834,
     784,   837,   838,   791,   792,   793,   852,   839,   795,   840,
     841,   842,   796,   804,   805,   806,   807,   808,   809,   810,
     811,   786,   787,   788,   789,   790,   845,   848,   851,   850,
     857,   880,   375,   861,   863,   794,   815,   816,   871,   374,
     872,   874,   875,   876,   374,   798,   433,   374,   801,   374,
     860,   881,   862,   433,   884,   888,   733,   817,   716,   717,
     418,   721,   722,   846,   411,   718,   814,   856,   870,   552,
     553,   433,   433,   773,   378,   456,     0,   503,   456,   456,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   456,
     456,   456,   456,     0,     0,   433,     0,     0,     0,     0,
       0,     0,   532,     0,   847,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,     0,   693,   360,   849,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,     0,     0,   360,     0,   855,
     694,     0,   865,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   864,     0,   360,     0,     0,     0,     0,     0,     0,
       0,   868,     0,     0,     0,     0,     0,   867,     0,     0,
       0,     0,   553,   873,     0,    -2,     4,     0,     0,     0,
     578,     0,     5,     0,     0,     0,     0,   -35,   882,   883,
     877,     0,     0,   887,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     -35,     0,   -35,     0,     0,     0,     0,     0,     0,   374,
       0,     0,     0,   342,   433,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,     0,     0,   360,     6,   -35,     7,     0,     0,   -35,
     858,   859,   -35,   -35,   -35,   -35,   -35,   -35,   -35,     8,
       9,    10,   -35,   -35,   -35,   -35,   -35,   -35,   -35,     0,
       0,     0,    11,     0,   -35,   -35,   -35,   -35,   -35,   -35,
      12,    13,   -35,   -35,   -35,   -35,   -35,   -35,     0,   -35,
     -35,   -35,   -35,   -35,     0,   -35,   -35,   -35,   -35,   -35,
     -35,   -35,   -35,   -35,     0,     0,     0,     0,     0,     0,
       0,     0,   -35,   -35,   -35,   -35,   -35,   -35,   -35,   -35,
     -35,   -35,   -35,   -35,   -35,   -35,   -35,   -35,   -35,   -35,
     -35,   -35,   -35,   -35,   -35,   -35,   -35,   -35,   -35,   -35,
     -35,   -35,   -35,   -35,   -35,   -35,   -35,   -35,   -35,   -35,
     -35,   -35,   -35,   -35,   -35,   -35,   -35,    46,    47,     0,
       0,     0,     0,     0,    48,     0,     0,    49,     0,     0,
       0,     0,     0,     0,   -35,     0,    50,    51,     0,     0,
       0,     0,     0,     0,     0,     0,    52,     0,     0,    53,
      54,     0,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,     0,    86,    87,    88,    46,    47,     0,
       0,     0,     0,     0,    48,     0,     0,    49,     0,     0,
       0,     0,     0,     0,     0,     0,    50,    51,     0,     0,
       0,     0,     0,     0,     0,     0,    52,     0,     0,    53,
      54,     0,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,     0,    86,    87,    88,   695,     0,     0,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,     0,     0,
     360,     0,     0,     0,    46,    47,     0,     0,     0,     0,
       0,    48,     0,     0,    49,     0,     0,     0,   451,     0,
       0,     0,     0,    50,    51,     0,     0,   471,     0,     0,
     452,   453,   454,    52,     0,     0,    53,    54,     0,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,   638,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
       0,    86,    87,    88,    46,    47,     0,     0,     0,   422,
       0,    48,     0,     0,    49,     0,     0,     0,   451,     0,
       0,     0,     0,    50,    51,     0,     0,     0,     0,     0,
     452,   453,   454,    52,     0,     0,    53,    54,     0,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,   423,   424,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
       0,    86,    87,    88,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,     0,     0,   360,     0,     0,     0,    46,    47,
       0,     0,     0,     0,     0,    48,     0,     0,    49,     0,
       0,     0,     0,     0,     0,   427,     0,    50,    51,     0,
       0,   639,   640,     0,   641,   642,   643,    52,     0,     0,
      53,    54,     0,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,     0,    86,    87,    88,     0,     0,
       0,    46,    47,     0,     0,     0,     0,     0,    48,     0,
       0,    49,     0,   425,   426,   427,   428,   429,   430,   431,
      50,    51,     0,   444,   445,     0,     0,     0,     0,     0,
      52,     0,     0,    53,    54,     0,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,     0,    86,    87,
      88,     0,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,    46,    47,
     360,     0,     0,     0,     0,    48,     0,     0,    49,     0,
       0,     0,     0,     0,     0,     0,     0,    50,    51,     0,
       0,     0,     0,     0,   735,   736,   737,    52,   738,     0,
      53,    54,     0,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,     0,    86,    87,    88,     0,     0,
       0,    46,    47,     0,     0,     0,     0,     0,    48,     0,
       0,    49,     0,     0,     0,     0,     0,     0,     0,     0,
      50,    51,     0,     0,     0,     0,     0,     0,   739,   740,
      52,   741,     0,    53,    54,     0,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,     0,    86,    87,
      88,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    46,    47,     0,     0,     0,   422,     0,
      48,     0,     0,    49,     0,     0,     0,     0,     0,     0,
       0,     0,    50,    51,     0,     0,     0,     0,     0,     0,
       0,     0,    52,     0,     0,    53,    54,   764,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,   423,   424,    73,    74,    75,    76,
      77,    78,    79,    80,    81,    82,    83,    84,    85,     0,
      86,    87,    88,     0,    46,    47,     0,     0,     0,   476,
       0,    48,     0,     0,    49,     0,     0,     0,     0,     0,
       0,     0,     0,    50,    51,     0,     0,     0,     0,     0,
       0,     0,     0,    52,     0,     0,    53,    54,   739,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,   423,   424,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
       0,    86,    87,    88,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      46,    47,     0,     0,     0,     0,     0,    48,     0,     0,
      49,     0,     0,     0,     0,     0,     0,     0,     0,    50,
      51,     0,   425,   426,   427,   428,   429,   430,   431,    52,
       0,     0,    53,    54,     0,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,   638,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,     0,    86,    87,    88,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     102,     0,   103,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   425,   426,   427,   428,   429,   430,   431,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   104,     0,     0,     0,   105,
       0,     0,   106,   107,   108,   109,   110,   111,   112,     0,
       0,     0,   113,   114,   115,   116,   117,   118,   119,     0,
       0,     0,     0,     0,   120,   121,   122,   123,   124,   125,
       0,     0,   126,   127,   128,   129,   130,   131,     0,   132,
     133,   134,   135,   136,     0,   137,   138,   139,   140,   141,
     142,   143,   144,   145,     0,     0,     0,     0,     0,     0,
       0,   427,   146,   147,   148,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   159,   160,   161,   162,   163,
     164,   165,   166,   167,   168,   169,   170,   171,   172,   173,
     174,   175,   176,   177,   178,   179,   180,   181,   182,   183,
     184,   185,   186,   187,   188,   189,   190,    46,    47,     0,
       0,     0,     0,     0,    48,     0,     0,    49,     0,     0,
       0,     0,     0,     0,     0,     0,    50,    51,     0,     0,
       0,     0,     0,     0,     0,     0,    52,     0,     0,    53,
      54,     0,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,     0,    86,    87,    88,   342,   343,   344,
     345,   346,   347,   348,   349,   758,   351,   352,   353,   354,
     355,   356,   357,   358,   359,     0,     0,   360
};

static const yytype_int16 yycheck[] =
{
      12,    14,   107,   108,     8,     9,   159,    40,   310,     7,
     115,   165,   117,   118,     6,   165,    70,    71,   114,    11,
      12,    12,   378,    42,    43,   146,   147,   148,   384,     6,
     386,   152,     6,    37,    54,    12,   392,   173,    12,     6,
      44,   397,   163,   164,   165,    12,   167,   476,   184,   150,
       6,     6,     6,    22,    23,   149,    12,    12,    12,   160,
     161,   182,     6,   492,     4,     8,     8,   188,    12,   190,
       0,    11,     8,   106,   107,   108,   170,   110,    54,   160,
     161,     9,   115,     6,   117,   118,    36,    37,    11,    94,
     171,   103,   125,   126,    22,    23,   101,   190,   191,    97,
     193,   105,   135,   136,   116,   109,     7,   111,   112,   121,
     155,    54,    54,    12,   159,     7,     6,   162,    54,   132,
      60,    11,    62,    63,    64,    65,    66,   131,    68,   174,
      10,   176,    10,   178,     6,   180,     3,     4,    12,    11,
     185,   186,   187,    10,   189,   149,    13,   184,   192,   193,
      48,    49,    50,    51,    52,    22,    23,    10,    10,   196,
     197,   198,   182,    10,    10,    32,   170,     8,    35,    36,
      10,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    10,    70,    71,    72,   182,   199,   199,   107,
     108,     8,     6,    54,    55,     9,   192,   115,    10,   117,
     118,    10,   199,    10,     8,   199,   189,   190,   191,    10,
     193,   533,   199,   147,   148,   117,   118,   119,   152,   182,
     182,    10,    10,   199,   199,   199,   182,    10,   146,   147,
     148,    10,   150,   167,   152,   199,    10,    54,    55,    70,
      71,    72,   160,   161,   620,     7,    10,    10,   182,   167,
      54,    55,    10,    10,   188,   173,   190,   310,   311,   312,
      29,    30,    31,    10,   182,    34,   184,   189,   190,   191,
     188,   193,   190,    73,    74,    75,    76,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   419,    10,    10,   193,    10,    10,   758,
      10,    73,    74,    75,    76,   190,   191,   192,   193,    10,
      10,   182,   183,   184,   185,   186,   187,   188,    10,   190,
     191,   192,   193,    95,    96,    10,    10,    70,   371,    12,
      12,    70,    70,   719,    27,    28,    29,    30,    31,    70,
     403,    34,   147,   148,    12,    34,    10,   152,   411,    70,
       6,     6,     6,     6,     6,   182,   183,   184,   185,   186,
     187,   188,   167,   190,   191,   192,   193,     6,   182,   183,
     184,   185,   186,   187,   188,     6,     6,   182,     6,     6,
       6,     6,     6,   188,   418,   190,     6,    73,    74,    75,
      76,     4,    70,   165,     4,    10,   193,     6,    10,   327,
     328,   329,     6,     6,     6,     6,     6,   193,   193,    95,
      96,    10,    10,     6,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,     6,     6,     6,     6,     6,   604,     6,
       6,     6,    10,     6,     6,   611,     6,    60,   631,    62,
      63,    64,    65,    66,     6,    68,     6,    70,    71,    72,
     523,     6,   597,   629,   630,     4,   529,   602,    11,   653,
     605,    11,   607,   653,   600,   524,   525,   526,   662,   165,
      11,    11,   662,    11,    11,    11,    11,   653,   522,   417,
      11,    11,     6,   527,   528,     6,   530,     6,     6,     6,
     651,   652,   633,   654,     6,   636,   637,    11,    11,   660,
     661,    11,     6,     6,     6,    11,   647,   648,   649,   650,
     595,    60,    11,    62,    63,    64,    65,    66,    11,    68,
       6,    11,    11,     6,   597,    12,     6,     4,     6,   602,
       6,    70,   605,     6,   607,     6,    10,   590,   476,     9,
       9,   593,   189,     9,   629,     9,     9,   632,     9,     9,
       9,     8,     6,     9,   492,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,     8,   610,    34,   653,    24,
      25,    26,    27,    28,    29,    30,    31,     8,   663,    34,
       6,    11,     6,    11,    11,     8,    11,   193,     6,    11,
      11,    11,    11,     9,     9,   731,    14,    15,    16,    17,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,     6,     6,    34,    11,    11,   193,
     673,    11,    11,   696,   697,   698,   802,    11,   701,    11,
      11,    11,   705,   129,   130,   131,   132,   133,   134,   135,
     136,   685,   686,   687,   688,   689,     6,    11,     6,    12,
       9,     8,   797,     9,     9,   699,   729,   730,    11,   597,
      11,     6,     9,     6,   602,   709,   604,   605,   712,   607,
     831,     8,   833,   611,     9,     9,   624,   731,   597,   600,
     138,   605,   607,   797,   133,   602,   728,   814,   856,   627,
     628,   629,   630,   653,   108,   633,    -1,   169,   636,   637,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   647,
     648,   649,   650,    -1,    -1,   653,    -1,    -1,    -1,    -1,
      -1,    -1,    11,    -1,   797,    14,    15,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    -1,    11,    34,   799,    14,    15,    16,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    -1,    -1,    34,    -1,   813,
      11,    -1,   845,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,   843,    -1,    34,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   853,    -1,    -1,    -1,    -1,    -1,   851,    -1,    -1,
      -1,    -1,   750,   866,    -1,     0,     1,    -1,    -1,    -1,
     758,    -1,     7,    -1,    -1,    -1,    -1,    12,   880,   881,
     874,    -1,    -1,   885,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      35,    -1,    37,    -1,    -1,    -1,    -1,    -1,    -1,   797,
      -1,    -1,    -1,    14,   802,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    -1,    -1,    34,    69,    70,    71,    -1,    -1,    74,
     828,   829,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    -1,
      -1,    -1,    97,    -1,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,    -1,   114,
     115,   116,   117,   118,    -1,   120,   121,   122,   123,   124,
     125,   126,   127,   128,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,     3,     4,    -1,
      -1,    -1,    -1,    -1,    10,    -1,    -1,    13,    -1,    -1,
      -1,    -1,    -1,    -1,   199,    -1,    22,    23,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    32,    -1,    -1,    35,
      36,    -1,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    -1,    70,    71,    72,     3,     4,    -1,
      -1,    -1,    -1,    -1,    10,    -1,    -1,    13,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    32,    -1,    -1,    35,
      36,    -1,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    -1,    70,    71,    72,    11,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    -1,    -1,
      34,    -1,    -1,    -1,     3,     4,    -1,    -1,    -1,    -1,
      -1,    10,    -1,    -1,    13,    -1,    -1,    -1,   184,    -1,
      -1,    -1,    -1,    22,    23,    -1,    -1,   193,    -1,    -1,
     196,   197,   198,    32,    -1,    -1,    35,    36,    -1,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      -1,    70,    71,    72,     3,     4,    -1,    -1,    -1,     8,
      -1,    10,    -1,    -1,    13,    -1,    -1,    -1,   184,    -1,
      -1,    -1,    -1,    22,    23,    -1,    -1,    -1,    -1,    -1,
     196,   197,   198,    32,    -1,    -1,    35,    36,    -1,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      -1,    70,    71,    72,    14,    15,    16,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    -1,    -1,    34,    -1,    -1,    -1,     3,     4,
      -1,    -1,    -1,    -1,    -1,    10,    -1,    -1,    13,    -1,
      -1,    -1,    -1,    -1,    -1,   184,    -1,    22,    23,    -1,
      -1,   190,   191,    -1,   193,   194,   195,    32,    -1,    -1,
      35,    36,    -1,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    -1,    70,    71,    72,    -1,    -1,
      -1,     3,     4,    -1,    -1,    -1,    -1,    -1,    10,    -1,
      -1,    13,    -1,   182,   183,   184,   185,   186,   187,   188,
      22,    23,    -1,   192,   193,    -1,    -1,    -1,    -1,    -1,
      32,    -1,    -1,    35,    36,    -1,    38,    39,    40,    41,
      42,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    -1,    70,    71,
      72,    -1,    16,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,     3,     4,
      34,    -1,    -1,    -1,    -1,    10,    -1,    -1,    13,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    -1,
      -1,    -1,    -1,    -1,   189,   190,   191,    32,   193,    -1,
      35,    36,    -1,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    -1,    70,    71,    72,    -1,    -1,
      -1,     3,     4,    -1,    -1,    -1,    -1,    -1,    10,    -1,
      -1,    13,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      22,    23,    -1,    -1,    -1,    -1,    -1,    -1,   190,   191,
      32,   193,    -1,    35,    36,    -1,    38,    39,    40,    41,
      42,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    -1,    70,    71,
      72,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,     3,     4,    -1,    -1,    -1,     8,    -1,
      10,    -1,    -1,    13,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    22,    23,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    32,    -1,    -1,    35,    36,   192,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    -1,
      70,    71,    72,    -1,     3,     4,    -1,    -1,    -1,     8,
      -1,    10,    -1,    -1,    13,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    22,    23,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    32,    -1,    -1,    35,    36,   190,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      -1,    70,    71,    72,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
       3,     4,    -1,    -1,    -1,    -1,    -1,    10,    -1,    -1,
      13,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,
      23,    -1,   182,   183,   184,   185,   186,   187,   188,    32,
      -1,    -1,    35,    36,    -1,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    -1,    70,    71,    72,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      35,    -1,    37,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   182,   183,   184,   185,   186,   187,   188,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    70,    -1,    -1,    -1,    74,
      -1,    -1,    77,    78,    79,    80,    81,    82,    83,    -1,
      -1,    -1,    87,    88,    89,    90,    91,    92,    93,    -1,
      -1,    -1,    -1,    -1,    99,   100,   101,   102,   103,   104,
      -1,    -1,   107,   108,   109,   110,   111,   112,    -1,   114,
     115,   116,   117,   118,    -1,   120,   121,   122,   123,   124,
     125,   126,   127,   128,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   184,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,     3,     4,    -1,
      -1,    -1,    -1,    -1,    10,    -1,    -1,    13,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    32,    -1,    -1,    35,
      36,    -1,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    -1,    70,    71,    72,    14,    15,    16,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    -1,    -1,    34
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_int16 yystos[] =
{
       0,   201,   202,     0,     1,     7,    69,    71,    84,    85,
      86,    97,   105,   106,   204,   205,   206,   207,   208,   209,
     217,   221,   224,   226,   227,   228,   229,   230,   246,   248,
     253,   254,   285,    12,   199,   203,     7,    73,    74,    75,
      76,    95,    96,   165,   225,     7,     3,     4,    10,    13,
      22,    23,    32,    35,    36,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    70,    71,    72,   215,
     216,   312,   313,   316,   319,   316,    12,   255,   315,   316,
     249,   203,    35,    37,    70,    74,    77,    78,    79,    80,
      81,    82,    83,    87,    88,    89,    90,    91,    92,    93,
      99,   100,   101,   102,   103,   104,   107,   108,   109,   110,
     111,   112,   114,   115,   116,   117,   118,   120,   121,   122,
     123,   124,   125,   126,   127,   128,   137,   138,   139,   140,
     141,   142,   143,   144,   145,   146,   147,   148,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,   163,   164,   165,   166,   167,   168,   169,   170,
     171,   172,   173,   174,   175,   176,   177,   178,   179,   180,
     181,   210,   211,   213,   218,   222,   231,   232,   236,   237,
     238,   239,   240,   241,   243,   244,   245,   259,   260,   262,
     263,   264,   265,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   282,   286,   287,   288,   289,
     290,   291,   292,   293,   296,   297,   298,   299,   323,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,   346,   347,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,     7,    97,   316,   319,   261,   315,
     261,   261,   316,     7,   312,   312,   312,   312,   312,   314,
      10,    10,    10,    10,    10,    10,    10,    10,    10,    10,
      10,    10,    10,    10,    10,    10,    10,    10,    10,    10,
      10,    10,    10,    10,    10,    10,    10,    10,    10,    10,
      10,    10,    14,    15,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      34,    12,    12,    70,    12,    70,   212,   315,   219,   300,
     316,   319,   294,   295,   312,   313,   317,   319,   294,   316,
     319,   316,   316,   215,   283,   284,   301,   302,   308,   313,
     319,   315,   303,   304,   311,   313,   319,   305,   306,   313,
     319,    94,   101,   324,   315,   319,   319,    70,    70,   316,
     203,   324,   319,   319,   117,   118,   119,   242,   242,   279,
     214,   233,     8,    54,    55,   182,   183,   184,   185,   186,
     187,   188,   307,   312,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   395,   192,   193,   385,   386,   385,   386,
     300,   184,   196,   197,   198,   310,   312,   394,   385,   386,
      54,    55,   190,   191,   192,   193,   387,   395,   397,   395,
     397,   193,   310,   394,   310,   394,     8,   190,   191,   192,
     193,   348,   384,   395,   398,   399,   400,     8,    54,   387,
       8,   387,     8,   348,   384,   387,   385,   386,   189,   190,
     191,   193,   396,   396,   300,   394,   307,   395,   395,   395,
     395,   385,   386,   307,   395,   395,   395,   385,   386,   395,
     385,   386,    73,    76,    95,    96,   165,   225,    73,    76,
     225,    12,    11,    10,   216,   319,   319,   319,   316,   316,
     316,   316,   316,   316,   316,   316,   316,   316,   316,   316,
     316,   316,   312,   312,   312,   319,   319,   319,   319,   319,
      11,   319,   320,   319,   319,   319,   319,   321,   319,   319,
     312,   312,   312,   312,   312,   312,   312,   312,   312,   312,
     312,   312,   312,   312,   312,   312,   312,   312,   312,   256,
     247,   250,    70,     6,   220,     6,   203,     6,   223,   223,
       6,   223,     6,   223,     6,     6,   223,     6,   223,   319,
       6,     6,     6,   319,     6,     6,     6,   312,   316,   215,
     280,   281,    70,     4,   234,   235,   193,    10,    10,     6,
       6,     6,     6,     6,    10,    10,     6,     6,    55,   190,
     191,   193,   194,   195,   310,   312,   389,     6,     6,     6,
       6,     6,     6,     6,     6,   193,    10,     6,   193,     6,
       6,     6,     6,     6,   316,   319,   261,   261,   261,   316,
     316,   319,   316,   258,   216,    11,    11,    11,    11,    11,
      11,    11,    11,    11,    11,     6,     6,     6,     6,     6,
      11,    11,    11,    11,    11,    11,     6,     6,     6,     6,
      11,     6,    11,    11,    11,     6,   322,    11,    11,     6,
      12,   203,     6,   315,     4,   395,   295,   284,   302,   266,
     307,   304,   306,     6,   316,   307,   318,    70,     6,     6,
       6,     6,   223,   235,     9,   189,   190,   191,   193,   190,
     191,   193,   307,   395,   307,   397,   395,   310,   310,   310,
      10,     9,     9,    22,    23,     9,     9,     9,    22,     9,
     310,   310,   193,   310,   192,   310,   387,   192,   387,   307,
     348,   384,   395,   398,   387,     9,     8,     9,     8,   387,
     387,   348,   384,   395,   203,    11,   316,   316,   316,   316,
     316,   319,   319,   319,   316,   319,   319,     6,   316,   257,
     252,   316,     6,   223,   129,   130,   131,   132,   133,   134,
     135,   136,   325,     6,   325,   319,   319,   281,    11,    11,
      11,    11,    11,    11,    11,     9,     9,   389,    22,    23,
     309,     6,   193,     6,   193,    11,    11,    11,    11,    11,
      11,    11,    11,     6,    11,     6,   317,   319,    11,   203,
      12,     6,   307,     8,   326,   316,   326,     9,   312,   312,
     387,     9,   387,     9,   315,   319,   251,   316,   315,   327,
     327,    11,    11,   203,     6,     9,     6,   316,    36,    37,
       8,     8,   315,   315,     9,     6,     9,   315,     9
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_int16 yyr1[] =
{
       0,   200,   201,   202,   202,   203,   203,   204,   204,   204,
     204,   204,   205,   205,   205,   206,   206,   206,   206,   206,
     206,   206,   206,   207,   208,   209,   210,   212,   211,   214,
     213,   215,   215,   216,   216,   217,   217,   217,   217,   217,
     217,   217,   219,   218,   220,   220,   221,   221,   221,   221,
     221,   221,   222,   222,   222,   222,   222,   222,   222,   222,
     222,   222,   222,   222,   222,   222,   222,   222,   222,   222,
     222,   222,   222,   222,   222,   222,   222,   222,   222,   222,
     222,   222,   222,   222,   222,   222,   222,   222,   222,   222,
     222,   222,   222,   222,   222,   222,   223,   223,   224,   225,
     225,   226,   227,   228,   229,   230,   231,   231,   233,   232,
     234,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     242,   242,   242,   243,   243,   243,   243,   244,   244,   245,
     245,   247,   246,   249,   250,   251,   248,   252,   252,   252,
     253,   255,   256,   257,   254,   258,   254,   259,   260,   261,
     261,   262,   263,   264,   265,   265,   266,   266,   267,   267,
     268,   268,   269,   269,   270,   271,   272,   272,   273,   274,
     275,   276,   277,   279,   278,   280,   280,   281,   282,   283,
     283,   284,   285,   286,   286,   286,   287,   288,   288,   289,
     290,   291,   292,   293,   293,   294,   294,   295,   295,   296,
     297,   298,   299,   300,   301,   301,   302,   302,   303,   303,
     304,   304,   305,   305,   306,   306,   307,   308,   309,   309,
     310,   311,   312,   312,   313,   313,   313,   313,   313,   313,
     313,   313,   313,   313,   313,   313,   313,   313,   313,   313,
     313,   313,   313,   313,   313,   313,   313,   313,   313,   313,
     313,   313,   313,   313,   313,   313,   314,   313,   313,   313,
     313,   313,   313,   313,   313,   313,   313,   313,   313,   313,
     313,   313,   313,   313,   313,   313,   313,   313,   315,   316,
     317,   318,   319,   319,   319,   319,   319,   319,   319,   319,
     319,   319,   320,   320,   321,   322,   322,   322,   323,   324,
     324,   324,   325,   325,   325,   325,   325,   325,   325,   325,
     326,   326,   327,   327,   327,   327,   328,   328,   328,   328,
     328,   328,   328,   328,   328,   328,   328,   328,   328,   328,
     328,   328,   328,   328,   328,   328,   328,   328,   328,   328,
     328,   328,   328,   328,   328,   328,   328,   328,   328,   328,
     328,   328,   328,   328,   328,   328,   328,   328,   328,   328,
     328,   328,   329,   329,   330,   330,   330,   330,   331,   331,
     332,   333,   333,   334,   335,   335,   336,   337,   338,   338,
     339,   340,   341,   342,   342,   343,   343,   343,   344,   344,
     345,   345,   346,   346,   347,   347,   347,   347,   348,   348,
     349,   349,   349,   349,   349,   349,   349,   349,   350,   350,
     351,   351,   352,   352,   353,   354,   355,   355,   356,   356,
     356,   357,   357,   358,   359,   359,   360,   361,   362,   363,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   374,   375,   376,   377,   378,   379,   380,   380,
     381,   381,   382,   383,   383,   384,   385,   385,   386,   386,
     387,   387,   388,   388,   389,   389,   390,   390,   391,   391,
     392,   392,   393,   393,   394,   394,   394,   394,   395,   395,
     395,   395,   395,   395,   395,   395,   396,   396,   396,   396,
     397,   397,   397,   397,   398,   398,   398,   398,   399,   399,
     400,   400
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     1,     0,     2,     1,     1,     1,     2,     2,
       2,     1,     2,     1,     2,     1,     1,     1,     1,     1,
       1,     1,     1,     3,     3,     2,     1,     0,     3,     0,
       3,     1,     1,     1,     1,     0,     1,     1,     2,     2,
       3,     3,     0,     3,     0,     2,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     0,     1,     3,     1,
       1,     3,     3,     3,     3,     3,     2,     4,     0,     3,
       1,     2,     1,     1,     1,     1,     1,     2,     2,     0,
       2,     2,     2,     3,     5,     3,     5,     1,     2,     7,
       1,     0,     5,     0,     0,     0,     9,     1,     3,     5,
       3,     0,     0,     0,     7,     0,     6,     2,     1,     0,
       1,     1,     1,     1,     2,     5,     1,     3,     1,     3,
       1,     3,     1,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     0,     4,     1,     3,     1,     3,     1,
       3,     1,     4,     2,     4,     6,     4,     2,     4,     2,
       1,     1,     3,     1,     3,     1,     3,     1,     1,     2,
       2,     2,     2,     1,     1,     3,     1,     1,     1,     3,
       1,     1,     1,     3,     1,     1,     1,     1,     2,     2,
       1,     1,     1,     1,     1,     1,     2,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     2,     2,     2,     4,
       4,     4,     4,     4,     4,     4,     0,     5,     4,     4,
       4,     6,     6,     6,     6,     4,     4,     4,     4,     4,
       4,     6,     6,     6,     6,     4,     4,     3,     1,     1,
       1,     1,     1,     8,     6,     6,     3,     4,     4,     4,
       8,     4,     1,     3,     2,     0,     3,     3,     7,     0,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       0,     3,     0,     6,     8,     6,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     2,     2,     2,     2,     4,     4,     2,     2,
       4,     2,     4,     1,     2,     2,     1,     1,     2,     2,
       1,     1,     1,     2,     2,     2,     4,     2,     2,     4,
       6,     6,     6,     6,     4,     4,     4,     4,     3,     5,
       1,     1,     1,     1,     1,     1,     1,     1,     5,     4,
       4,     4,     4,     4,     4,     4,     4,     4,     4,     4,
       4,     4,     4,     1,     2,     2,     2,     2,     4,     1,
       2,     1,     2,     1,     2,     1,     2,     1,     2,     1,
       2,     2,     2,     1,     4,     2,     2,     2,     1,     2,
       2,     2,     2,     2,     2,     3,     1,     3,     1,     3,
       1,     4,     1,     4,     1,     4,     1,     4,     1,     4,
       1,     4,     1,     4,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     3,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     3,     3,     1,     1,     3,     4,
       3,     4
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        YY_LAC_DISCARD ("YYBACKUP");                              \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
# ifndef YY_LOCATION_PRINT
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif


# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yykind < YYNTOKENS)
    YYPRINT (yyo, yytoknum[yykind], *yyvaluep);
# endif
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  yy_symbol_value_print (yyo, yykind, yyvaluep);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp,
                 int yyrule)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)]);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


/* Given a state stack such that *YYBOTTOM is its bottom, such that
   *YYTOP is either its top or is YYTOP_EMPTY to indicate an empty
   stack, and such that *YYCAPACITY is the maximum number of elements it
   can hold without a reallocation, make sure there is enough room to
   store YYADD more elements.  If not, allocate a new stack using
   YYSTACK_ALLOC, copy the existing elements, and adjust *YYBOTTOM,
   *YYTOP, and *YYCAPACITY to reflect the new capacity and memory
   location.  If *YYBOTTOM != YYBOTTOM_NO_FREE, then free the old stack
   using YYSTACK_FREE.  Return 0 if successful or if no reallocation is
   required.  Return YYENOMEM if memory is exhausted.  */
static int
yy_lac_stack_realloc (YYPTRDIFF_T *yycapacity, YYPTRDIFF_T yyadd,
#if YYDEBUG
                      char const *yydebug_prefix,
                      char const *yydebug_suffix,
#endif
                      yy_state_t **yybottom,
                      yy_state_t *yybottom_no_free,
                      yy_state_t **yytop, yy_state_t *yytop_empty)
{
  YYPTRDIFF_T yysize_old =
    *yytop == yytop_empty ? 0 : *yytop - *yybottom + 1;
  YYPTRDIFF_T yysize_new = yysize_old + yyadd;
  if (*yycapacity < yysize_new)
    {
      YYPTRDIFF_T yyalloc = 2 * yysize_new;
      yy_state_t *yybottom_new;
      /* Use YYMAXDEPTH for maximum stack size given that the stack
         should never need to grow larger than the main state stack
         needs to grow without LAC.  */
      if (YYMAXDEPTH < yysize_new)
        {
          YYDPRINTF ((stderr, "%smax size exceeded%s", yydebug_prefix,
                      yydebug_suffix));
          return YYENOMEM;
        }
      if (YYMAXDEPTH < yyalloc)
        yyalloc = YYMAXDEPTH;
      yybottom_new =
        YY_CAST (yy_state_t *,
                 YYSTACK_ALLOC (YY_CAST (YYSIZE_T,
                                         yyalloc * YYSIZEOF (*yybottom_new))));
      if (!yybottom_new)
        {
          YYDPRINTF ((stderr, "%srealloc failed%s", yydebug_prefix,
                      yydebug_suffix));
          return YYENOMEM;
        }
      if (*yytop != yytop_empty)
        {
          YYCOPY (yybottom_new, *yybottom, yysize_old);
          *yytop = yybottom_new + (yysize_old - 1);
        }
      if (*yybottom != yybottom_no_free)
        YYSTACK_FREE (*yybottom);
      *yybottom = yybottom_new;
      *yycapacity = yyalloc;
    }
  return 0;
}

/* Establish the initial context for the current lookahead if no initial
   context is currently established.

   We define a context as a snapshot of the parser stacks.  We define
   the initial context for a lookahead as the context in which the
   parser initially examines that lookahead in order to select a
   syntactic action.  Thus, if the lookahead eventually proves
   syntactically unacceptable (possibly in a later context reached via a
   series of reductions), the initial context can be used to determine
   the exact set of tokens that would be syntactically acceptable in the
   lookahead's place.  Moreover, it is the context after which any
   further semantic actions would be erroneous because they would be
   determined by a syntactically unacceptable token.

   YY_LAC_ESTABLISH should be invoked when a reduction is about to be
   performed in an inconsistent state (which, for the purposes of LAC,
   includes consistent states that don't know they're consistent because
   their default reductions have been disabled).  Iff there is a
   lookahead token, it should also be invoked before reporting a syntax
   error.  This latter case is for the sake of the debugging output.

   For parse.lac=full, the implementation of YY_LAC_ESTABLISH is as
   follows.  If no initial context is currently established for the
   current lookahead, then check if that lookahead can eventually be
   shifted if syntactic actions continue from the current context.
   Report a syntax error if it cannot.  */
#define YY_LAC_ESTABLISH                                                \
do {                                                                    \
  if (!yy_lac_established)                                              \
    {                                                                   \
      YYDPRINTF ((stderr,                                               \
                  "LAC: initial context established for %s\n",          \
                  yysymbol_name (yytoken)));                            \
      yy_lac_established = 1;                                           \
      switch (yy_lac (yyesa, &yyes, &yyes_capacity, yyssp, yytoken))    \
        {                                                               \
        case YYENOMEM:                                                  \
          goto yyexhaustedlab;                                          \
        case 1:                                                         \
          goto yyerrlab;                                                \
        }                                                               \
    }                                                                   \
} while (0)

/* Discard any previous initial lookahead context because of Event,
   which may be a lookahead change or an invalidation of the currently
   established initial context for the current lookahead.

   The most common example of a lookahead change is a shift.  An example
   of both cases is syntax error recovery.  That is, a syntax error
   occurs when the lookahead is syntactically erroneous for the
   currently established initial context, so error recovery manipulates
   the parser stacks to try to find a new initial context in which the
   current lookahead is syntactically acceptable.  If it fails to find
   such a context, it discards the lookahead.  */
#if YYDEBUG
# define YY_LAC_DISCARD(Event)                                           \
do {                                                                     \
  if (yy_lac_established)                                                \
    {                                                                    \
      YYDPRINTF ((stderr, "LAC: initial context discarded due to "       \
                  Event "\n"));                                          \
      yy_lac_established = 0;                                            \
    }                                                                    \
} while (0)
#else
# define YY_LAC_DISCARD(Event) yy_lac_established = 0
#endif

/* Given the stack whose top is *YYSSP, return 0 iff YYTOKEN can
   eventually (after perhaps some reductions) be shifted, return 1 if
   not, or return YYENOMEM if memory is exhausted.  As preconditions and
   postconditions: *YYES_CAPACITY is the allocated size of the array to
   which *YYES points, and either *YYES = YYESA or *YYES points to an
   array allocated with YYSTACK_ALLOC.  yy_lac may overwrite the
   contents of either array, alter *YYES and *YYES_CAPACITY, and free
   any old *YYES other than YYESA.  */
static int
yy_lac (yy_state_t *yyesa, yy_state_t **yyes,
        YYPTRDIFF_T *yyes_capacity, yy_state_t *yyssp, yysymbol_kind_t yytoken)
{
  yy_state_t *yyes_prev = yyssp;
  yy_state_t *yyesp = yyes_prev;
  /* Reduce until we encounter a shift and thereby accept the token.  */
  YYDPRINTF ((stderr, "LAC: checking lookahead %s:", yysymbol_name (yytoken)));
  if (yytoken == YYSYMBOL_YYUNDEF)
    {
      YYDPRINTF ((stderr, " Always Err\n"));
      return 1;
    }
  while (1)
    {
      int yyrule = yypact[+*yyesp];
      if (yypact_value_is_default (yyrule)
          || (yyrule += yytoken) < 0 || YYLAST < yyrule
          || yycheck[yyrule] != yytoken)
        {
          /* Use the default action.  */
          yyrule = yydefact[+*yyesp];
          if (yyrule == 0)
            {
              YYDPRINTF ((stderr, " Err\n"));
              return 1;
            }
        }
      else
        {
          /* Use the action from yytable.  */
          yyrule = yytable[yyrule];
          if (yytable_value_is_error (yyrule))
            {
              YYDPRINTF ((stderr, " Err\n"));
              return 1;
            }
          if (0 < yyrule)
            {
              YYDPRINTF ((stderr, " S%d\n", yyrule));
              return 0;
            }
          yyrule = -yyrule;
        }
      /* By now we know we have to simulate a reduce.  */
      YYDPRINTF ((stderr, " R%d", yyrule - 1));
      {
        /* Pop the corresponding number of values from the stack.  */
        YYPTRDIFF_T yylen = yyr2[yyrule];
        /* First pop from the LAC stack as many tokens as possible.  */
        if (yyesp != yyes_prev)
          {
            YYPTRDIFF_T yysize = yyesp - *yyes + 1;
            if (yylen < yysize)
              {
                yyesp -= yylen;
                yylen = 0;
              }
            else
              {
                yyesp = yyes_prev;
                yylen -= yysize;
              }
          }
        /* Only afterwards look at the main stack.  */
        if (yylen)
          yyesp = yyes_prev -= yylen;
      }
      /* Push the resulting state of the reduction.  */
      {
        yy_state_fast_t yystate;
        {
          const int yylhs = yyr1[yyrule] - YYNTOKENS;
          const int yyi = yypgoto[yylhs] + *yyesp;
          yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyesp
                     ? yytable[yyi]
                     : yydefgoto[yylhs]);
        }
        if (yyesp == yyes_prev)
          {
            yyesp = *yyes;
            YY_IGNORE_USELESS_CAST_BEGIN
            *yyesp = YY_CAST (yy_state_t, yystate);
            YY_IGNORE_USELESS_CAST_END
          }
        else
          {
            if (yy_lac_stack_realloc (yyes_capacity, 1,
#if YYDEBUG
                                      " (", ")",
#endif
                                      yyes, yyesa, &yyesp, yyes_prev))
              {
                YYDPRINTF ((stderr, "\n"));
                return YYENOMEM;
              }
            YY_IGNORE_USELESS_CAST_BEGIN
            *++yyesp = YY_CAST (yy_state_t, yystate);
            YY_IGNORE_USELESS_CAST_END
          }
        YYDPRINTF ((stderr, " G%d", yystate));
      }
    }
}

/* Context of a parse error.  */
typedef struct
{
  yy_state_t *yyssp;
  yy_state_t *yyesa;
  yy_state_t **yyes;
  YYPTRDIFF_T *yyes_capacity;
  yysymbol_kind_t yytoken;
} yypcontext_t;

/* Put in YYARG at most YYARGN of the expected tokens given the
   current YYCTX, and return the number of tokens stored in YYARG.  If
   YYARG is null, return the number of expected tokens (guaranteed to
   be less than YYNTOKENS).  Return YYENOMEM on memory exhaustion.
   Return 0 if there are more than YYARGN expected tokens, yet fill
   YYARG up to YYARGN. */
static int
yypcontext_expected_tokens (const yypcontext_t *yyctx,
                            yysymbol_kind_t yyarg[], int yyargn)
{
  /* Actual size of YYARG. */
  int yycount = 0;

  int yyx;
  for (yyx = 0; yyx < YYNTOKENS; ++yyx)
    {
      yysymbol_kind_t yysym = YY_CAST (yysymbol_kind_t, yyx);
      if (yysym != YYSYMBOL_YYerror && yysym != YYSYMBOL_YYUNDEF)
        switch (yy_lac (yyctx->yyesa, yyctx->yyes, yyctx->yyes_capacity, yyctx->yyssp, yysym))
          {
          case YYENOMEM:
            return YYENOMEM;
          case 1:
            continue;
          default:
            if (!yyarg)
              ++yycount;
            else if (yycount == yyargn)
              return 0;
            else
              yyarg[yycount++] = yysym;
          }
    }
  if (yyarg && yycount == 0 && 0 < yyargn)
    yyarg[0] = YYSYMBOL_YYEMPTY;
  return yycount;
}




#ifndef yystrlen
# if defined __GLIBC__ && defined _STRING_H
#  define yystrlen(S) (YY_CAST (YYPTRDIFF_T, strlen (S)))
# else
/* Return the length of YYSTR.  */
static YYPTRDIFF_T
yystrlen (const char *yystr)
{
  YYPTRDIFF_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
# endif
#endif

#ifndef yystpcpy
# if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#  define yystpcpy stpcpy
# else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
# endif
#endif



static int
yy_syntax_error_arguments (const yypcontext_t *yyctx,
                           yysymbol_kind_t yyarg[], int yyargn)
{
  /* Actual size of YYARG. */
  int yycount = 0;
  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
       In the first two cases, it might appear that the current syntax
       error should have been detected in the previous state when yy_lac
       was invoked.  However, at that time, there might have been a
       different syntax error that discarded a different initial context
       during error recovery, leaving behind the current lookahead.
  */
  if (yyctx->yytoken != YYSYMBOL_YYEMPTY)
    {
      int yyn;
      YYDPRINTF ((stderr, "Constructing syntax error message\n"));
      if (yyarg)
        yyarg[yycount] = yyctx->yytoken;
      ++yycount;
      yyn = yypcontext_expected_tokens (yyctx,
                                        yyarg ? yyarg + 1 : yyarg, yyargn - 1);
      if (yyn == YYENOMEM)
        return YYENOMEM;
      else if (yyn == 0)
        YYDPRINTF ((stderr, "No expected tokens.\n"));
      else
        yycount += yyn;
    }
  return yycount;
}

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.  In order to see if a particular token T is a
   valid looakhead, invoke yy_lac (YYESA, YYES, YYES_CAPACITY, YYSSP, T).

   Return 0 if *YYMSG was successfully written.  Return -1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return YYENOMEM if the
   required number of bytes is too large to store or if
   yy_lac returned YYENOMEM.  */
static int
yysyntax_error (YYPTRDIFF_T *yymsg_alloc, char **yymsg,
                const yypcontext_t *yyctx)
{
  enum { YYARGS_MAX = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat: reported tokens (one for the "unexpected",
     one per "expected"). */
  yysymbol_kind_t yyarg[YYARGS_MAX];
  /* Cumulated lengths of YYARG.  */
  YYPTRDIFF_T yysize = 0;

  /* Actual size of YYARG. */
  int yycount = yy_syntax_error_arguments (yyctx, yyarg, YYARGS_MAX);
  if (yycount == YYENOMEM)
    return YYENOMEM;

  switch (yycount)
    {
#define YYCASE_(N, S)                       \
      case N:                               \
        yyformat = S;                       \
        break
    default: /* Avoid compiler warnings. */
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
#undef YYCASE_
    }

  /* Compute error message size.  Don't count the "%s"s, but reserve
     room for the terminator.  */
  yysize = yystrlen (yyformat) - 2 * yycount + 1;
  {
    int yyi;
    for (yyi = 0; yyi < yycount; ++yyi)
      {
        YYPTRDIFF_T yysize1
          = yysize + yystrlen (yysymbol_name (yyarg[yyi]));
        if (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM)
          yysize = yysize1;
        else
          return YYENOMEM;
      }
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return -1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp = yystpcpy (yyp, yysymbol_name (yyarg[yyi++]));
          yyformat += 2;
        }
      else
        {
          ++yyp;
          ++yyformat;
        }
  }
  return 0;
}


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep)
{
  YY_USE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;




/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

    yy_state_t yyesa[20];
    yy_state_t *yyes = yyesa;
    YYPTRDIFF_T yyes_capacity = 20 < YYMAXDEPTH ? 20 : YYMAXDEPTH;

  /* Whether LAC context is established.  A Boolean.  */
  int yy_lac_established = 0;
  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYPTRDIFF_T yymsg_alloc = sizeof yymsgbuf;

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    goto yyexhaustedlab;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex ();
    }

  if (yychar <= T_EOF)
    {
      yychar = T_EOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    {
      YY_LAC_ESTABLISH;
      goto yydefault;
    }
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      YY_LAC_ESTABLISH;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  YY_LAC_DISCARD ("shift");
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  {
    int yychar_backup = yychar;
    switch (yyn)
      {
  case 14: /* line: error endofline  */
#line 687 "src/asm/parser.y"
                                  { /* Continue parsing the next line on a syntax error */
			fstk_StopRept();
		}
#line 3283 "src/asm/parser.c"
    break;

  case 23: /* if: "IF" const "newline"  */
#line 709 "src/asm/parser.y"
                                           {
			lexer_IncIFDepth();

			if ((yyvsp[-1].constValue))
				lexer_RunIFBlock();
			else
				lexer_SetMode(LEXER_SKIP_TO_ELIF);
		}
#line 3296 "src/asm/parser.c"
    break;

  case 24: /* elif: "ELIF" const "newline"  */
#line 719 "src/asm/parser.y"
                                             {
			if (lexer_GetIFDepth() == 0)
				fatalerror("Found ELIF outside an IF construct\n");

			if (lexer_RanIFBlock()) {
				if (lexer_ReachedELSEBlock())
					fatalerror("Found ELIF after an ELSE block\n");

				lexer_SetMode(LEXER_SKIP_TO_ENDC);
			} else if ((yyvsp[-1].constValue)) {
				lexer_RunIFBlock();
			} else {
				lexer_SetMode(LEXER_SKIP_TO_ELIF);
			}
		}
#line 3316 "src/asm/parser.c"
    break;

  case 25: /* else: "ELSE" "newline"  */
#line 736 "src/asm/parser.y"
                                       {
			if (lexer_GetIFDepth() == 0)
				fatalerror("Found ELSE outside an IF construct\n");

			if (lexer_RanIFBlock()) {
				if (lexer_ReachedELSEBlock())
					fatalerror("Found ELSE after an ELSE block\n");

				lexer_SetMode(LEXER_SKIP_TO_ENDC);
			} else {
				lexer_RunIFBlock();
				lexer_ReachELSEBlock();
			}
		}
#line 3335 "src/asm/parser.c"
    break;

  case 26: /* endc: "ENDC"  */
#line 752 "src/asm/parser.y"
                             {
			lexer_DecIFDepth();
		}
#line 3343 "src/asm/parser.c"
    break;

  case 27: /* $@1: %empty  */
#line 757 "src/asm/parser.y"
                           {
			lexer_ToggleStringExpansion(false);
		}
#line 3351 "src/asm/parser.c"
    break;

  case 28: /* def_id: "DEF" $@1 "identifier"  */
#line 759 "src/asm/parser.y"
                       {
			lexer_ToggleStringExpansion(true);
			strcpy((yyval.symName), (yyvsp[0].symName));
		}
#line 3360 "src/asm/parser.c"
    break;

  case 29: /* $@2: %empty  */
#line 765 "src/asm/parser.y"
                              {
			lexer_ToggleStringExpansion(false);
		}
#line 3368 "src/asm/parser.c"
    break;

  case 30: /* redef_id: "REDEF" $@2 "identifier"  */
#line 767 "src/asm/parser.y"
                       {
			lexer_ToggleStringExpansion(true);
			strcpy((yyval.symName), (yyvsp[0].symName));
		}
#line 3377 "src/asm/parser.c"
    break;

  case 36: /* label: ":"  */
#line 777 "src/asm/parser.y"
                          {
			sym_AddAnonLabel();
		}
#line 3385 "src/asm/parser.c"
    break;

  case 37: /* label: "local identifier"  */
#line 780 "src/asm/parser.y"
                             {
			sym_AddLocalLabel((yyvsp[0].symName));
		}
#line 3393 "src/asm/parser.c"
    break;

  case 38: /* label: "local identifier" ":"  */
#line 783 "src/asm/parser.y"
                                     {
			sym_AddLocalLabel((yyvsp[-1].symName));
		}
#line 3401 "src/asm/parser.c"
    break;

  case 39: /* label: "label" ":"  */
#line 786 "src/asm/parser.y"
                                  {
			sym_AddLabel((yyvsp[-1].symName));
		}
#line 3409 "src/asm/parser.c"
    break;

  case 40: /* label: "local identifier" ":" ":"  */
#line 789 "src/asm/parser.y"
                                             {
			sym_AddLocalLabel((yyvsp[-2].symName));
			sym_Export((yyvsp[-2].symName));
		}
#line 3418 "src/asm/parser.c"
    break;

  case 41: /* label: "label" ":" ":"  */
#line 793 "src/asm/parser.y"
                                          {
			sym_AddLabel((yyvsp[-2].symName));
			sym_Export((yyvsp[-2].symName));
		}
#line 3427 "src/asm/parser.c"
    break;

  case 42: /* $@3: %empty  */
#line 799 "src/asm/parser.y"
                       {
			// Parsing 'macroargs' will restore the lexer's normal mode
			lexer_SetMode(LEXER_RAW);
		}
#line 3436 "src/asm/parser.c"
    break;

  case 43: /* macro: "identifier" $@3 macroargs  */
#line 802 "src/asm/parser.y"
                            {
			fstk_RunMacro((yyvsp[-2].symName), (yyvsp[0].macroArg));
		}
#line 3444 "src/asm/parser.c"
    break;

  case 44: /* macroargs: %empty  */
#line 807 "src/asm/parser.y"
                         {
			(yyval.macroArg) = macro_NewArgs();
		}
#line 3452 "src/asm/parser.c"
    break;

  case 45: /* macroargs: macroargs "string"  */
#line 810 "src/asm/parser.y"
                                     {
			macro_AppendArg(&((yyval.macroArg)), strdup((yyvsp[0].string)));
		}
#line 3460 "src/asm/parser.c"
    break;

  case 98: /* equ: "label" "EQU" const  */
#line 873 "src/asm/parser.y"
                                          { sym_AddEqu((yyvsp[-2].symName), (yyvsp[0].constValue)); }
#line 3466 "src/asm/parser.c"
    break;

  case 101: /* set: "label" set_or_equal const  */
#line 879 "src/asm/parser.y"
                                             { sym_AddSet((yyvsp[-2].symName), (yyvsp[0].constValue)); }
#line 3472 "src/asm/parser.c"
    break;

  case 102: /* equs: "label" "EQUS" string  */
#line 882 "src/asm/parser.y"
                                            { sym_AddString((yyvsp[-2].symName), (yyvsp[0].string)); }
#line 3478 "src/asm/parser.c"
    break;

  case 103: /* rb: "label" "RB" rs_uconst  */
#line 885 "src/asm/parser.y"
                                             {
			sym_AddEqu((yyvsp[-2].symName), sym_GetConstantValue("_RS"));
			sym_AddSet("_RS", sym_GetConstantValue("_RS") + (yyvsp[0].constValue));
		}
#line 3487 "src/asm/parser.c"
    break;

  case 104: /* rw: "label" "RW" rs_uconst  */
#line 891 "src/asm/parser.y"
                                             {
			sym_AddEqu((yyvsp[-2].symName), sym_GetConstantValue("_RS"));
			sym_AddSet("_RS", sym_GetConstantValue("_RS") + 2 * (yyvsp[0].constValue));
		}
#line 3496 "src/asm/parser.c"
    break;

  case 105: /* rl: "label" "rl" rs_uconst  */
#line 897 "src/asm/parser.y"
                                             {
			sym_AddEqu((yyvsp[-2].symName), sym_GetConstantValue("_RS"));
			sym_AddSet("_RS", sym_GetConstantValue("_RS") + 4 * (yyvsp[0].constValue));
		}
#line 3505 "src/asm/parser.c"
    break;

  case 106: /* align: "ALIGN" uconst  */
#line 903 "src/asm/parser.y"
                                    {
			if ((yyvsp[0].constValue) > 16)
				error("Alignment must be between 0 and 16, not %u\n", (yyvsp[0].constValue));
			else
				sect_AlignPC((yyvsp[0].constValue), 0);
		}
#line 3516 "src/asm/parser.c"
    break;

  case 107: /* align: "ALIGN" uconst "," uconst  */
#line 909 "src/asm/parser.y"
                                                   {
			if ((yyvsp[-2].constValue) > 16)
				error("Alignment must be between 0 and 16, not %u\n", (yyvsp[-2].constValue));
			else if ((yyvsp[0].constValue) >= 1 << (yyvsp[-2].constValue))
				error("Offset must be between 0 and %u, not %u\n",
					(1 << (yyvsp[-2].constValue)) - 1, (yyvsp[0].constValue));
			else
				sect_AlignPC((yyvsp[-2].constValue), (yyvsp[0].constValue));
		}
#line 3530 "src/asm/parser.c"
    break;

  case 108: /* $@4: %empty  */
#line 920 "src/asm/parser.y"
                            {
			// Parsing 'opt_list' will restore the lexer's normal mode
			lexer_SetMode(LEXER_RAW);
		}
#line 3539 "src/asm/parser.c"
    break;

  case 112: /* opt_list_entry: "string"  */
#line 930 "src/asm/parser.y"
                           { opt_Parse((yyvsp[0].string)); }
#line 3545 "src/asm/parser.c"
    break;

  case 113: /* popo: "POPO"  */
#line 933 "src/asm/parser.y"
                             { opt_Pop(); }
#line 3551 "src/asm/parser.c"
    break;

  case 114: /* pusho: "PUSHO"  */
#line 936 "src/asm/parser.y"
                              { opt_Push(); }
#line 3557 "src/asm/parser.c"
    break;

  case 115: /* pops: "POPS"  */
#line 939 "src/asm/parser.y"
                             { sect_PopSection(); }
#line 3563 "src/asm/parser.c"
    break;

  case 116: /* pushs: "PUSHS"  */
#line 942 "src/asm/parser.y"
                              { sect_PushSection(); }
#line 3569 "src/asm/parser.c"
    break;

  case 117: /* fail: "FAIL" string  */
#line 945 "src/asm/parser.y"
                                    { fatalerror("%s\n", (yyvsp[0].string)); }
#line 3575 "src/asm/parser.c"
    break;

  case 118: /* warn: "WARN" string  */
#line 948 "src/asm/parser.y"
                                    { warning(WARNING_USER, "%s\n", (yyvsp[0].string)); }
#line 3581 "src/asm/parser.c"
    break;

  case 119: /* assert_type: %empty  */
#line 951 "src/asm/parser.y"
                         { (yyval.assertType) = ASSERT_ERROR; }
#line 3587 "src/asm/parser.c"
    break;

  case 120: /* assert_type: "WARN" ","  */
#line 952 "src/asm/parser.y"
                                     { (yyval.assertType) = ASSERT_WARN; }
#line 3593 "src/asm/parser.c"
    break;

  case 121: /* assert_type: "FAIL" ","  */
#line 953 "src/asm/parser.y"
                                     { (yyval.assertType) = ASSERT_ERROR; }
#line 3599 "src/asm/parser.c"
    break;

  case 122: /* assert_type: "FATAL" ","  */
#line 954 "src/asm/parser.y"
                                      { (yyval.assertType) = ASSERT_FATAL; }
#line 3605 "src/asm/parser.c"
    break;

  case 123: /* assert: "ASSERT" assert_type relocexpr  */
#line 957 "src/asm/parser.y"
                                                     {
			if (!rpn_isKnown(&(yyvsp[0].expr))) {
				if (!out_CreateAssert((yyvsp[-1].assertType), &(yyvsp[0].expr), "",
						      sect_GetOutputOffset()))
					error("Assertion creation failed: %s\n",
						strerror(errno));
			} else if ((yyvsp[0].expr).val == 0) {
				failAssert((yyvsp[-1].assertType));
			}
			rpn_Free(&(yyvsp[0].expr));
		}
#line 3621 "src/asm/parser.c"
    break;

  case 124: /* assert: "ASSERT" assert_type relocexpr "," string  */
#line 968 "src/asm/parser.y"
                                                                    {
			if (!rpn_isKnown(&(yyvsp[-2].expr))) {
				if (!out_CreateAssert((yyvsp[-3].assertType), &(yyvsp[-2].expr), (yyvsp[0].string),
						      sect_GetOutputOffset()))
					error("Assertion creation failed: %s\n",
						strerror(errno));
			} else if ((yyvsp[-2].expr).val == 0) {
				failAssertMsg((yyvsp[-3].assertType), (yyvsp[0].string));
			}
			rpn_Free(&(yyvsp[-2].expr));
		}
#line 3637 "src/asm/parser.c"
    break;

  case 125: /* assert: "STATIC_ASSERT" assert_type const  */
#line 979 "src/asm/parser.y"
                                                        {
			if ((yyvsp[0].constValue) == 0)
				failAssert((yyvsp[-1].assertType));
		}
#line 3646 "src/asm/parser.c"
    break;

  case 126: /* assert: "STATIC_ASSERT" assert_type const "," string  */
#line 983 "src/asm/parser.y"
                                                                       {
			if ((yyvsp[-2].constValue) == 0)
				failAssertMsg((yyvsp[-3].assertType), (yyvsp[0].string));
		}
#line 3655 "src/asm/parser.c"
    break;

  case 127: /* shift: "SHIFT"  */
#line 989 "src/asm/parser.y"
                              { macro_ShiftCurrentArgs(1); }
#line 3661 "src/asm/parser.c"
    break;

  case 128: /* shift: "SHIFT" const  */
#line 990 "src/asm/parser.y"
                                    { macro_ShiftCurrentArgs((yyvsp[0].constValue)); }
#line 3667 "src/asm/parser.c"
    break;

  case 129: /* load: "LOAD" sectmod string "," sectiontype sectorg sectattrs  */
#line 993 "src/asm/parser.y"
                                                                                  {
			sect_SetLoadSection((yyvsp[-4].string), (yyvsp[-2].constValue), (yyvsp[-1].constValue), &(yyvsp[0].sectSpec), (yyvsp[-5].sectMod));
		}
#line 3675 "src/asm/parser.c"
    break;

  case 130: /* load: "ENDL"  */
#line 996 "src/asm/parser.y"
                             { sect_EndLoadSection(); }
#line 3681 "src/asm/parser.c"
    break;

  case 131: /* @5: %empty  */
#line 999 "src/asm/parser.y"
                                              {
			(yyval.captureTerminated) = lexer_CaptureRept(&captureBody);
		}
#line 3689 "src/asm/parser.c"
    break;

  case 132: /* rept: "REPT" uconst "newline" @5 endofline  */
#line 1001 "src/asm/parser.y"
                            {
			if ((yyvsp[-1].captureTerminated))
				fstk_RunRept((yyvsp[-3].constValue), captureBody.lineNo, captureBody.body,
					     captureBody.size);
		}
#line 3699 "src/asm/parser.c"
    break;

  case 133: /* $@6: %empty  */
#line 1008 "src/asm/parser.y"
                            {
			lexer_ToggleStringExpansion(false);
		}
#line 3707 "src/asm/parser.c"
    break;

  case 134: /* $@7: %empty  */
#line 1010 "src/asm/parser.y"
                       {
			lexer_ToggleStringExpansion(true);
		}
#line 3715 "src/asm/parser.c"
    break;

  case 135: /* @8: %empty  */
#line 1012 "src/asm/parser.y"
                                             {
			(yyval.captureTerminated) = lexer_CaptureRept(&captureBody);
		}
#line 3723 "src/asm/parser.c"
    break;

  case 136: /* for: "FOR" $@6 "identifier" $@7 "," for_args "newline" @8 endofline  */
#line 1014 "src/asm/parser.y"
                            {
			if ((yyvsp[-1].captureTerminated))
				fstk_RunFor((yyvsp[-6].symName), (yyvsp[-3].forArgs).start, (yyvsp[-3].forArgs).stop, (yyvsp[-3].forArgs).step, captureBody.lineNo,
					    captureBody.body, captureBody.size);
		}
#line 3733 "src/asm/parser.c"
    break;

  case 137: /* for_args: const  */
#line 1020 "src/asm/parser.y"
                        {
			(yyval.forArgs).start = 0;
			(yyval.forArgs).stop = (yyvsp[0].constValue);
			(yyval.forArgs).step = 1;
		}
#line 3743 "src/asm/parser.c"
    break;

  case 138: /* for_args: const "," const  */
#line 1025 "src/asm/parser.y"
                                      {
			(yyval.forArgs).start = (yyvsp[-2].constValue);
			(yyval.forArgs).stop = (yyvsp[0].constValue);
			(yyval.forArgs).step = 1;
		}
#line 3753 "src/asm/parser.c"
    break;

  case 139: /* for_args: const "," const "," const  */
#line 1030 "src/asm/parser.y"
                                                    {
			(yyval.forArgs).start = (yyvsp[-4].constValue);
			(yyval.forArgs).stop = (yyvsp[-2].constValue);
			(yyval.forArgs).step = (yyvsp[0].constValue);
		}
#line 3763 "src/asm/parser.c"
    break;

  case 140: /* break: label "BREAK" endofline  */
#line 1037 "src/asm/parser.y"
                                              {
			if (fstk_Break())
				lexer_SetMode(LEXER_SKIP_TO_ENDR);
		}
#line 3772 "src/asm/parser.c"
    break;

  case 141: /* $@9: %empty  */
#line 1043 "src/asm/parser.y"
                              {
			lexer_ToggleStringExpansion(false);
		}
#line 3780 "src/asm/parser.c"
    break;

  case 142: /* $@10: %empty  */
#line 1045 "src/asm/parser.y"
                       {
			lexer_ToggleStringExpansion(true);
		}
#line 3788 "src/asm/parser.c"
    break;

  case 143: /* @11: %empty  */
#line 1047 "src/asm/parser.y"
                            {
			(yyval.captureTerminated) = lexer_CaptureMacroBody(&captureBody);
		}
#line 3796 "src/asm/parser.c"
    break;

  case 144: /* macrodef: "MACRO" $@9 "identifier" $@10 "newline" @11 endofline  */
#line 1049 "src/asm/parser.y"
                            {
			if ((yyvsp[-1].captureTerminated))
				sym_AddMacro((yyvsp[-4].symName), captureBody.lineNo, captureBody.body,
					     captureBody.size);
		}
#line 3806 "src/asm/parser.c"
    break;

  case 145: /* @12: %empty  */
#line 1054 "src/asm/parser.y"
                                                        {
			(yyval.captureTerminated) = lexer_CaptureMacroBody(&captureBody);
		}
#line 3814 "src/asm/parser.c"
    break;

  case 146: /* macrodef: "label" ":" "MACRO" "newline" @12 endofline  */
#line 1056 "src/asm/parser.y"
                            {
			if ((yyvsp[-1].captureTerminated))
				sym_AddMacro((yyvsp[-5].symName), captureBody.lineNo, captureBody.body,
					     captureBody.size);
		}
#line 3824 "src/asm/parser.c"
    break;

  case 147: /* rsset: "RSSET" uconst  */
#line 1063 "src/asm/parser.y"
                                     { sym_AddSet("_RS", (yyvsp[0].constValue)); }
#line 3830 "src/asm/parser.c"
    break;

  case 148: /* rsreset: "RSRESET"  */
#line 1066 "src/asm/parser.y"
                                { sym_AddSet("_RS", 0); }
#line 3836 "src/asm/parser.c"
    break;

  case 149: /* rs_uconst: %empty  */
#line 1069 "src/asm/parser.y"
                         {
			(yyval.constValue) = 1;
		}
#line 3844 "src/asm/parser.c"
    break;

  case 151: /* union: "UNION"  */
#line 1075 "src/asm/parser.y"
                              { sect_StartUnion(); }
#line 3850 "src/asm/parser.c"
    break;

  case 152: /* nextu: "NEXTU"  */
#line 1078 "src/asm/parser.y"
                              { sect_NextUnionMember(); }
#line 3856 "src/asm/parser.c"
    break;

  case 153: /* endu: "ENDU"  */
#line 1081 "src/asm/parser.y"
                             { sect_EndUnion(); }
#line 3862 "src/asm/parser.c"
    break;

  case 154: /* ds: "DS" uconst  */
#line 1084 "src/asm/parser.y"
                                  { sect_Skip((yyvsp[0].constValue), true); }
#line 3868 "src/asm/parser.c"
    break;

  case 155: /* ds: "DS" uconst "," ds_args trailing_comma  */
#line 1085 "src/asm/parser.y"
                                                                 {
			sect_RelBytes((yyvsp[-3].constValue), (yyvsp[-1].dsArgs).args, (yyvsp[-1].dsArgs).nbArgs);
			freeDsArgList(&(yyvsp[-1].dsArgs));
		}
#line 3877 "src/asm/parser.c"
    break;

  case 156: /* ds_args: reloc_8bit  */
#line 1091 "src/asm/parser.y"
                             {
			initDsArgList(&(yyval.dsArgs));
			size_t i = nextDsArgListIndex(&(yyval.dsArgs));

			(yyval.dsArgs).args[i] = (yyvsp[0].expr);
		}
#line 3888 "src/asm/parser.c"
    break;

  case 157: /* ds_args: ds_args "," reloc_8bit  */
#line 1097 "src/asm/parser.y"
                                             {
			size_t i = nextDsArgListIndex(&(yyvsp[-2].dsArgs));

			(yyvsp[-2].dsArgs).args[i] = (yyvsp[0].expr);
			(yyval.dsArgs) = (yyvsp[-2].dsArgs);
		}
#line 3899 "src/asm/parser.c"
    break;

  case 158: /* db: "DB"  */
#line 1105 "src/asm/parser.y"
                           { sect_Skip(1, false); }
#line 3905 "src/asm/parser.c"
    break;

  case 160: /* dw: "DW"  */
#line 1109 "src/asm/parser.y"
                           { sect_Skip(2, false); }
#line 3911 "src/asm/parser.c"
    break;

  case 162: /* dl: "DL"  */
#line 1113 "src/asm/parser.y"
                           { sect_Skip(4, false); }
#line 3917 "src/asm/parser.c"
    break;

  case 164: /* def_equ: def_id "EQU" const  */
#line 1117 "src/asm/parser.y"
                                         {
			sym_AddEqu((yyvsp[-2].symName), (yyvsp[0].constValue));
		}
#line 3925 "src/asm/parser.c"
    break;

  case 165: /* redef_equ: redef_id "EQU" const  */
#line 1122 "src/asm/parser.y"
                                           {
			sym_RedefEqu((yyvsp[-2].symName), (yyvsp[0].constValue));
		}
#line 3933 "src/asm/parser.c"
    break;

  case 166: /* def_set: def_id set_or_equal const  */
#line 1127 "src/asm/parser.y"
                                            {
			sym_AddSet((yyvsp[-2].symName), (yyvsp[0].constValue));
		}
#line 3941 "src/asm/parser.c"
    break;

  case 167: /* def_set: redef_id set_or_equal const  */
#line 1130 "src/asm/parser.y"
                                              {
			sym_AddSet((yyvsp[-2].symName), (yyvsp[0].constValue));
		}
#line 3949 "src/asm/parser.c"
    break;

  case 168: /* def_rb: def_id "RB" rs_uconst  */
#line 1135 "src/asm/parser.y"
                                            {
			sym_AddEqu((yyvsp[-2].symName), sym_GetConstantValue("_RS"));
			sym_AddSet("_RS", sym_GetConstantValue("_RS") + (yyvsp[0].constValue));
		}
#line 3958 "src/asm/parser.c"
    break;

  case 169: /* def_rw: def_id "RW" rs_uconst  */
#line 1141 "src/asm/parser.y"
                                            {
			sym_AddEqu((yyvsp[-2].symName), sym_GetConstantValue("_RS"));
			sym_AddSet("_RS", sym_GetConstantValue("_RS") + 2 * (yyvsp[0].constValue));
		}
#line 3967 "src/asm/parser.c"
    break;

  case 170: /* def_rl: def_id "rl" rs_uconst  */
#line 1147 "src/asm/parser.y"
                                            {
			sym_AddEqu((yyvsp[-2].symName), sym_GetConstantValue("_RS"));
			sym_AddSet("_RS", sym_GetConstantValue("_RS") + 4 * (yyvsp[0].constValue));
		}
#line 3976 "src/asm/parser.c"
    break;

  case 171: /* def_equs: def_id "EQUS" string  */
#line 1153 "src/asm/parser.y"
                                           {
			sym_AddString((yyvsp[-2].symName), (yyvsp[0].string));
		}
#line 3984 "src/asm/parser.c"
    break;

  case 172: /* redef_equs: redef_id "EQUS" string  */
#line 1158 "src/asm/parser.y"
                                             {
			sym_RedefString((yyvsp[-2].symName), (yyvsp[0].string));
		}
#line 3992 "src/asm/parser.c"
    break;

  case 173: /* $@13: %empty  */
#line 1163 "src/asm/parser.y"
                              {
			lexer_ToggleStringExpansion(false);
		}
#line 4000 "src/asm/parser.c"
    break;

  case 174: /* purge: "PURGE" $@13 purge_list trailing_comma  */
#line 1165 "src/asm/parser.y"
                                            {
			lexer_ToggleStringExpansion(true);
		}
#line 4008 "src/asm/parser.c"
    break;

  case 177: /* purge_list_entry: scoped_id  */
#line 1174 "src/asm/parser.y"
                             { sym_Purge((yyvsp[0].symName)); }
#line 4014 "src/asm/parser.c"
    break;

  case 181: /* export_list_entry: scoped_id  */
#line 1184 "src/asm/parser.y"
                              { sym_Export((yyvsp[0].symName)); }
#line 4020 "src/asm/parser.c"
    break;

  case 182: /* include: label "INCLUDE" string endofline  */
#line 1187 "src/asm/parser.y"
                                                       {
			fstk_RunInclude((yyvsp[-1].string));
			if (failedOnMissingInclude)
				YYACCEPT;
		}
#line 4030 "src/asm/parser.c"
    break;

  case 183: /* incbin: "INCBIN" string  */
#line 1194 "src/asm/parser.y"
                                      {
			sect_BinaryFile((yyvsp[0].string), 0);
			if (failedOnMissingInclude)
				YYACCEPT;
		}
#line 4040 "src/asm/parser.c"
    break;

  case 184: /* incbin: "INCBIN" string "," const  */
#line 1199 "src/asm/parser.y"
                                                    {
			sect_BinaryFile((yyvsp[-2].string), (yyvsp[0].constValue));
			if (failedOnMissingInclude)
				YYACCEPT;
		}
#line 4050 "src/asm/parser.c"
    break;

  case 185: /* incbin: "INCBIN" string "," const "," const  */
#line 1204 "src/asm/parser.y"
                                                                  {
			sect_BinaryFileSlice((yyvsp[-4].string), (yyvsp[-2].constValue), (yyvsp[0].constValue));
			if (failedOnMissingInclude)
				YYACCEPT;
		}
#line 4060 "src/asm/parser.c"
    break;

  case 186: /* charmap: "CHARMAP" string "," const_8bit  */
#line 1211 "src/asm/parser.y"
                                                          {
			charmap_Add((yyvsp[-2].string), (uint8_t)(yyvsp[0].constValue));
		}
#line 4068 "src/asm/parser.c"
    break;

  case 187: /* newcharmap: "NEWCHARMAP" "identifier"  */
#line 1216 "src/asm/parser.y"
                                        { charmap_New((yyvsp[0].symName), NULL); }
#line 4074 "src/asm/parser.c"
    break;

  case 188: /* newcharmap: "NEWCHARMAP" "identifier" "," "identifier"  */
#line 1217 "src/asm/parser.y"
                                                     { charmap_New((yyvsp[-2].symName), (yyvsp[0].symName)); }
#line 4080 "src/asm/parser.c"
    break;

  case 189: /* setcharmap: "SETCHARMAP" "identifier"  */
#line 1220 "src/asm/parser.y"
                                        { charmap_Set((yyvsp[0].symName)); }
#line 4086 "src/asm/parser.c"
    break;

  case 190: /* pushc: "PUSHC"  */
#line 1223 "src/asm/parser.y"
                              { charmap_Push(); }
#line 4092 "src/asm/parser.c"
    break;

  case 191: /* popc: "POPC"  */
#line 1226 "src/asm/parser.y"
                             { charmap_Pop(); }
#line 4098 "src/asm/parser.c"
    break;

  case 193: /* println: "PRINTLN"  */
#line 1232 "src/asm/parser.y"
                                {
			putchar('\n');
			fflush(stdout);
		}
#line 4107 "src/asm/parser.c"
    break;

  case 194: /* println: "PRINTLN" print_exprs trailing_comma  */
#line 1236 "src/asm/parser.y"
                                                           {
			putchar('\n');
			fflush(stdout);
		}
#line 4116 "src/asm/parser.c"
    break;

  case 197: /* print_expr: const_no_str  */
#line 1246 "src/asm/parser.y"
                               { printf("$%" PRIX32, (yyvsp[0].constValue)); }
#line 4122 "src/asm/parser.c"
    break;

  case 198: /* print_expr: string  */
#line 1247 "src/asm/parser.y"
                         { printf("%s", (yyvsp[0].string)); }
#line 4128 "src/asm/parser.c"
    break;

  case 199: /* printt: "PRINTT" string  */
#line 1250 "src/asm/parser.y"
                                      {
			warning(WARNING_OBSOLETE, "`PRINTT` is deprecated; use `PRINT`\n");
			printf("%s", (yyvsp[0].string));
		}
#line 4137 "src/asm/parser.c"
    break;

  case 200: /* printv: "PRINTV" const  */
#line 1256 "src/asm/parser.y"
                                     {
			warning(WARNING_OBSOLETE, "`PRINTV` is deprecated; use `PRINT`\n");
			printf("$%" PRIX32, (yyvsp[0].constValue));
		}
#line 4146 "src/asm/parser.c"
    break;

  case 201: /* printi: "PRINTI" const  */
#line 1262 "src/asm/parser.y"
                                     {
			warning(WARNING_OBSOLETE, "`PRINTI` is deprecated; use `PRINT` with `STRFMT`\n");
			printf("%" PRId32, (yyvsp[0].constValue));
		}
#line 4155 "src/asm/parser.c"
    break;

  case 202: /* printf: "PRINTF" const  */
#line 1268 "src/asm/parser.y"
                                     {
			warning(WARNING_OBSOLETE, "`PRINTF` is deprecated; use `PRINT` with `STRFMT`\n");
			fix_Print((yyvsp[0].constValue));
		}
#line 4164 "src/asm/parser.c"
    break;

  case 203: /* const_3bit: const  */
#line 1274 "src/asm/parser.y"
                        {
			int32_t value = (yyvsp[0].constValue);

			if ((value < 0) || (value > 7)) {
				error("Immediate value must be 3-bit\n");
				(yyval.constValue) = 0;
			} else {
				(yyval.constValue) = value & 0x7;
			}
		}
#line 4179 "src/asm/parser.c"
    break;

  case 206: /* constlist_8bit_entry: reloc_8bit_no_str  */
#line 1290 "src/asm/parser.y"
                                         {
			sect_RelByte(&(yyvsp[0].expr), 0);
		}
#line 4187 "src/asm/parser.c"
    break;

  case 207: /* constlist_8bit_entry: string  */
#line 1293 "src/asm/parser.y"
                         {
			uint8_t *output = malloc(strlen((yyvsp[0].string))); /* Cannot be larger than that */
			int32_t length = charmap_Convert((yyvsp[0].string), output);

			sect_AbsByteGroup(output, length);
			free(output);
		}
#line 4199 "src/asm/parser.c"
    break;

  case 210: /* constlist_16bit_entry: reloc_16bit_no_str  */
#line 1306 "src/asm/parser.y"
                                           {
			sect_RelWord(&(yyvsp[0].expr), 0);
		}
#line 4207 "src/asm/parser.c"
    break;

  case 211: /* constlist_16bit_entry: string  */
#line 1309 "src/asm/parser.y"
                         {
			uint8_t *output = malloc(strlen((yyvsp[0].string))); /* Cannot be larger than that */
			int32_t length = charmap_Convert((yyvsp[0].string), output);

			sect_AbsWordGroup(output, length);
			free(output);
		}
#line 4219 "src/asm/parser.c"
    break;

  case 214: /* constlist_32bit_entry: relocexpr_no_str  */
#line 1322 "src/asm/parser.y"
                                         {
			sect_RelLong(&(yyvsp[0].expr), 0);
		}
#line 4227 "src/asm/parser.c"
    break;

  case 215: /* constlist_32bit_entry: string  */
#line 1325 "src/asm/parser.y"
                         {
			// Charmaps cannot increase the length of a string
			uint8_t *output = malloc(strlen((yyvsp[0].string)));
			int32_t length = charmap_Convert((yyvsp[0].string), output);

			sect_AbsLongGroup(output, length);
			free(output);
		}
#line 4240 "src/asm/parser.c"
    break;

  case 216: /* reloc_8bit: relocexpr  */
#line 1335 "src/asm/parser.y"
                            {
			rpn_CheckNBit(&(yyvsp[0].expr), 8);
			(yyval.expr) = (yyvsp[0].expr);
		}
#line 4249 "src/asm/parser.c"
    break;

  case 217: /* reloc_8bit_no_str: relocexpr_no_str  */
#line 1341 "src/asm/parser.y"
                                     {
			rpn_CheckNBit(&(yyvsp[0].expr), 8);
			(yyval.expr) = (yyvsp[0].expr);
		}
#line 4258 "src/asm/parser.c"
    break;

  case 218: /* reloc_8bit_offset: "+" relocexpr  */
#line 1347 "src/asm/parser.y"
                                       {
			rpn_CheckNBit(&(yyvsp[0].expr), 8);
			(yyval.expr) = (yyvsp[0].expr);
		}
#line 4267 "src/asm/parser.c"
    break;

  case 219: /* reloc_8bit_offset: "-" relocexpr  */
#line 1351 "src/asm/parser.y"
                                     {
			rpn_UNNEG(&(yyval.expr), &(yyvsp[0].expr));
			rpn_CheckNBit(&(yyval.expr), 8);
		}
#line 4276 "src/asm/parser.c"
    break;

  case 220: /* reloc_16bit: relocexpr  */
#line 1357 "src/asm/parser.y"
                            {
			rpn_CheckNBit(&(yyvsp[0].expr), 16);
			(yyval.expr) = (yyvsp[0].expr);
		}
#line 4285 "src/asm/parser.c"
    break;

  case 221: /* reloc_16bit_no_str: relocexpr_no_str  */
#line 1363 "src/asm/parser.y"
                                      {
			rpn_CheckNBit(&(yyvsp[0].expr), 16);
			(yyval.expr) = (yyvsp[0].expr);
		}
#line 4294 "src/asm/parser.c"
    break;

  case 223: /* relocexpr: string  */
#line 1371 "src/asm/parser.y"
                         {
			// Charmaps cannot increase the length of a string
			uint8_t *output = malloc(strlen((yyvsp[0].string)));
			int32_t length = charmap_Convert((yyvsp[0].string), output);
			uint32_t r = str2int2(output, length);

			free(output);
			rpn_Number(&(yyval.expr), r);
		}
#line 4308 "src/asm/parser.c"
    break;

  case 224: /* relocexpr_no_str: scoped_anon_id  */
#line 1382 "src/asm/parser.y"
                                  { rpn_Symbol(&(yyval.expr), (yyvsp[0].symName)); }
#line 4314 "src/asm/parser.c"
    break;

  case 225: /* relocexpr_no_str: "number"  */
#line 1383 "src/asm/parser.y"
                           { rpn_Number(&(yyval.expr), (yyvsp[0].constValue)); }
#line 4320 "src/asm/parser.c"
    break;

  case 226: /* relocexpr_no_str: "!" relocexpr  */
#line 1384 "src/asm/parser.y"
                                                    {
			rpn_LOGNOT(&(yyval.expr), &(yyvsp[0].expr));
		}
#line 4328 "src/asm/parser.c"
    break;

  case 227: /* relocexpr_no_str: relocexpr "||" relocexpr  */
#line 1387 "src/asm/parser.y"
                                                   {
			rpn_BinaryOp(RPN_LOGOR, &(yyval.expr), &(yyvsp[-2].expr), &(yyvsp[0].expr));
		}
#line 4336 "src/asm/parser.c"
    break;

  case 228: /* relocexpr_no_str: relocexpr "&&" relocexpr  */
#line 1390 "src/asm/parser.y"
                                                    {
			rpn_BinaryOp(RPN_LOGAND, &(yyval.expr), &(yyvsp[-2].expr), &(yyvsp[0].expr));
		}
#line 4344 "src/asm/parser.c"
    break;

  case 229: /* relocexpr_no_str: relocexpr "==" relocexpr  */
#line 1393 "src/asm/parser.y"
                                                    {
			rpn_BinaryOp(RPN_LOGEQ, &(yyval.expr), &(yyvsp[-2].expr), &(yyvsp[0].expr));
		}
#line 4352 "src/asm/parser.c"
    break;

  case 230: /* relocexpr_no_str: relocexpr ">" relocexpr  */
#line 1396 "src/asm/parser.y"
                                                   {
			rpn_BinaryOp(RPN_LOGGT, &(yyval.expr), &(yyvsp[-2].expr), &(yyvsp[0].expr));
		}
#line 4360 "src/asm/parser.c"
    break;

  case 231: /* relocexpr_no_str: relocexpr "<" relocexpr  */
#line 1399 "src/asm/parser.y"
                                                   {
			rpn_BinaryOp(RPN_LOGLT, &(yyval.expr), &(yyvsp[-2].expr), &(yyvsp[0].expr));
		}
#line 4368 "src/asm/parser.c"
    break;

  case 232: /* relocexpr_no_str: relocexpr ">=" relocexpr  */
#line 1402 "src/asm/parser.y"
                                                   {
			rpn_BinaryOp(RPN_LOGGE, &(yyval.expr), &(yyvsp[-2].expr), &(yyvsp[0].expr));
		}
#line 4376 "src/asm/parser.c"
    break;

  case 233: /* relocexpr_no_str: relocexpr "<=" relocexpr  */
#line 1405 "src/asm/parser.y"
                                                   {
			rpn_BinaryOp(RPN_LOGLE, &(yyval.expr), &(yyvsp[-2].expr), &(yyvsp[0].expr));
		}
#line 4384 "src/asm/parser.c"
    break;

  case 234: /* relocexpr_no_str: relocexpr "!=" relocexpr  */
#line 1408 "src/asm/parser.y"
                                                   {
			rpn_BinaryOp(RPN_LOGNE, &(yyval.expr), &(yyvsp[-2].expr), &(yyvsp[0].expr));
		}
#line 4392 "src/asm/parser.c"
    break;

  case 235: /* relocexpr_no_str: relocexpr "+" relocexpr  */
#line 1411 "src/asm/parser.y"
                                               {
			rpn_BinaryOp(RPN_ADD, &(yyval.expr), &(yyvsp[-2].expr), &(yyvsp[0].expr));
		}
#line 4400 "src/asm/parser.c"
    break;

  case 236: /* relocexpr_no_str: relocexpr "-" relocexpr  */
#line 1414 "src/asm/parser.y"
                                               {
			rpn_BinaryOp(RPN_SUB, &(yyval.expr), &(yyvsp[-2].expr), &(yyvsp[0].expr));
		}
#line 4408 "src/asm/parser.c"
    break;

  case 237: /* relocexpr_no_str: relocexpr "^" relocexpr  */
#line 1417 "src/asm/parser.y"
                                               {
			rpn_BinaryOp(RPN_XOR, &(yyval.expr), &(yyvsp[-2].expr), &(yyvsp[0].expr));
		}
#line 4416 "src/asm/parser.c"
    break;

  case 238: /* relocexpr_no_str: relocexpr "|" relocexpr  */
#line 1420 "src/asm/parser.y"
                                              {
			rpn_BinaryOp(RPN_OR, &(yyval.expr), &(yyvsp[-2].expr), &(yyvsp[0].expr));
		}
#line 4424 "src/asm/parser.c"
    break;

  case 239: /* relocexpr_no_str: relocexpr "&" relocexpr  */
#line 1423 "src/asm/parser.y"
                                               {
			rpn_BinaryOp(RPN_AND, &(yyval.expr), &(yyvsp[-2].expr), &(yyvsp[0].expr));
		}
#line 4432 "src/asm/parser.c"
    break;

  case 240: /* relocexpr_no_str: relocexpr "<<" relocexpr  */
#line 1426 "src/asm/parser.y"
                                               {
			rpn_BinaryOp(RPN_SHL, &(yyval.expr), &(yyvsp[-2].expr), &(yyvsp[0].expr));
		}
#line 4440 "src/asm/parser.c"
    break;

  case 241: /* relocexpr_no_str: relocexpr ">>" relocexpr  */
#line 1429 "src/asm/parser.y"
                                               {
			rpn_BinaryOp(RPN_SHR, &(yyval.expr), &(yyvsp[-2].expr), &(yyvsp[0].expr));
		}
#line 4448 "src/asm/parser.c"
    break;

  case 242: /* relocexpr_no_str: relocexpr "*" relocexpr  */
#line 1432 "src/asm/parser.y"
                                               {
			rpn_BinaryOp(RPN_MUL, &(yyval.expr), &(yyvsp[-2].expr), &(yyvsp[0].expr));
		}
#line 4456 "src/asm/parser.c"
    break;

  case 243: /* relocexpr_no_str: relocexpr "/" relocexpr  */
#line 1435 "src/asm/parser.y"
                                               {
			rpn_BinaryOp(RPN_DIV, &(yyval.expr), &(yyvsp[-2].expr), &(yyvsp[0].expr));
		}
#line 4464 "src/asm/parser.c"
    break;

  case 244: /* relocexpr_no_str: relocexpr "%" relocexpr  */
#line 1438 "src/asm/parser.y"
                                               {
			rpn_BinaryOp(RPN_MOD, &(yyval.expr), &(yyvsp[-2].expr), &(yyvsp[0].expr));
		}
#line 4472 "src/asm/parser.c"
    break;

  case 245: /* relocexpr_no_str: relocexpr "**" relocexpr  */
#line 1441 "src/asm/parser.y"
                                               {
			rpn_BinaryOp(RPN_EXP, &(yyval.expr), &(yyvsp[-2].expr), &(yyvsp[0].expr));
		}
#line 4480 "src/asm/parser.c"
    break;

  case 246: /* relocexpr_no_str: "+" relocexpr  */
#line 1444 "src/asm/parser.y"
                                               { (yyval.expr) = (yyvsp[0].expr); }
#line 4486 "src/asm/parser.c"
    break;

  case 247: /* relocexpr_no_str: "-" relocexpr  */
#line 1445 "src/asm/parser.y"
                                               { rpn_UNNEG(&(yyval.expr), &(yyvsp[0].expr)); }
#line 4492 "src/asm/parser.c"
    break;

  case 248: /* relocexpr_no_str: "~" relocexpr  */
#line 1446 "src/asm/parser.y"
                                               { rpn_UNNOT(&(yyval.expr), &(yyvsp[0].expr)); }
#line 4498 "src/asm/parser.c"
    break;

  case 249: /* relocexpr_no_str: "HIGH" "(" relocexpr ")"  */
#line 1447 "src/asm/parser.y"
                                                        { rpn_HIGH(&(yyval.expr), &(yyvsp[-1].expr)); }
#line 4504 "src/asm/parser.c"
    break;

  case 250: /* relocexpr_no_str: "LOW" "(" relocexpr ")"  */
#line 1448 "src/asm/parser.y"
                                                       { rpn_LOW(&(yyval.expr), &(yyvsp[-1].expr)); }
#line 4510 "src/asm/parser.c"
    break;

  case 251: /* relocexpr_no_str: "ISCONST" "(" relocexpr ")"  */
#line 1449 "src/asm/parser.y"
                                                           { rpn_ISCONST(&(yyval.expr), &(yyvsp[-1].expr)); }
#line 4516 "src/asm/parser.c"
    break;

  case 252: /* relocexpr_no_str: "BANK" "(" scoped_anon_id ")"  */
#line 1450 "src/asm/parser.y"
                                                             {
			// '@' is also a T_ID; it is handled here
			rpn_BankSymbol(&(yyval.expr), (yyvsp[-1].symName));
		}
#line 4525 "src/asm/parser.c"
    break;

  case 253: /* relocexpr_no_str: "BANK" "(" string ")"  */
#line 1454 "src/asm/parser.y"
                                                     { rpn_BankSection(&(yyval.expr), (yyvsp[-1].string)); }
#line 4531 "src/asm/parser.c"
    break;

  case 254: /* relocexpr_no_str: "SIZEOF" "(" string ")"  */
#line 1455 "src/asm/parser.y"
                                                       { rpn_SizeOfSection(&(yyval.expr), (yyvsp[-1].string)); }
#line 4537 "src/asm/parser.c"
    break;

  case 255: /* relocexpr_no_str: "STARTOF" "(" string ")"  */
#line 1456 "src/asm/parser.y"
                                                        { rpn_StartOfSection(&(yyval.expr), (yyvsp[-1].string)); }
#line 4543 "src/asm/parser.c"
    break;

  case 256: /* $@14: %empty  */
#line 1457 "src/asm/parser.y"
                           {
			lexer_ToggleStringExpansion(false);
		}
#line 4551 "src/asm/parser.c"
    break;

  case 257: /* relocexpr_no_str: "DEF" $@14 "(" scoped_anon_id ")"  */
#line 1459 "src/asm/parser.y"
                                                   {
			struct Symbol const *sym = sym_FindScopedSymbol((yyvsp[-1].symName));

			rpn_Number(&(yyval.expr), !!sym);

			lexer_ToggleStringExpansion(true);
		}
#line 4563 "src/asm/parser.c"
    break;

  case 258: /* relocexpr_no_str: "ROUND" "(" const ")"  */
#line 1466 "src/asm/parser.y"
                                                     {
			rpn_Number(&(yyval.expr), fix_Round((yyvsp[-1].constValue)));
		}
#line 4571 "src/asm/parser.c"
    break;

  case 259: /* relocexpr_no_str: "CEIL" "(" const ")"  */
#line 1469 "src/asm/parser.y"
                                                    {
			rpn_Number(&(yyval.expr), fix_Ceil((yyvsp[-1].constValue)));
		}
#line 4579 "src/asm/parser.c"
    break;

  case 260: /* relocexpr_no_str: "FLOOR" "(" const ")"  */
#line 1472 "src/asm/parser.y"
                                                     {
			rpn_Number(&(yyval.expr), fix_Floor((yyvsp[-1].constValue)));
		}
#line 4587 "src/asm/parser.c"
    break;

  case 261: /* relocexpr_no_str: "FDIV" "(" const "," const ")"  */
#line 1475 "src/asm/parser.y"
                                                                  {
			rpn_Number(&(yyval.expr), fix_Div((yyvsp[-3].constValue), (yyvsp[-1].constValue)));
		}
#line 4595 "src/asm/parser.c"
    break;

  case 262: /* relocexpr_no_str: "FMUL" "(" const "," const ")"  */
#line 1478 "src/asm/parser.y"
                                                                  {
			rpn_Number(&(yyval.expr), fix_Mul((yyvsp[-3].constValue), (yyvsp[-1].constValue)));
		}
#line 4603 "src/asm/parser.c"
    break;

  case 263: /* relocexpr_no_str: "POW" "(" const "," const ")"  */
#line 1481 "src/asm/parser.y"
                                                                 {
			rpn_Number(&(yyval.expr), fix_Pow((yyvsp[-3].constValue), (yyvsp[-1].constValue)));
		}
#line 4611 "src/asm/parser.c"
    break;

  case 264: /* relocexpr_no_str: "LOG" "(" const "," const ")"  */
#line 1484 "src/asm/parser.y"
                                                                 {
			rpn_Number(&(yyval.expr), fix_Log((yyvsp[-3].constValue), (yyvsp[-1].constValue)));
		}
#line 4619 "src/asm/parser.c"
    break;

  case 265: /* relocexpr_no_str: "SIN" "(" const ")"  */
#line 1487 "src/asm/parser.y"
                                                   {
			rpn_Number(&(yyval.expr), fix_Sin((yyvsp[-1].constValue)));
		}
#line 4627 "src/asm/parser.c"
    break;

  case 266: /* relocexpr_no_str: "COS" "(" const ")"  */
#line 1490 "src/asm/parser.y"
                                                   {
			rpn_Number(&(yyval.expr), fix_Cos((yyvsp[-1].constValue)));
		}
#line 4635 "src/asm/parser.c"
    break;

  case 267: /* relocexpr_no_str: "TAN" "(" const ")"  */
#line 1493 "src/asm/parser.y"
                                                   {
			rpn_Number(&(yyval.expr), fix_Tan((yyvsp[-1].constValue)));
		}
#line 4643 "src/asm/parser.c"
    break;

  case 268: /* relocexpr_no_str: "ASIN" "(" const ")"  */
#line 1496 "src/asm/parser.y"
                                                    {
			rpn_Number(&(yyval.expr), fix_ASin((yyvsp[-1].constValue)));
		}
#line 4651 "src/asm/parser.c"
    break;

  case 269: /* relocexpr_no_str: "ACOS" "(" const ")"  */
#line 1499 "src/asm/parser.y"
                                                    {
			rpn_Number(&(yyval.expr), fix_ACos((yyvsp[-1].constValue)));
		}
#line 4659 "src/asm/parser.c"
    break;

  case 270: /* relocexpr_no_str: "ATAN" "(" const ")"  */
#line 1502 "src/asm/parser.y"
                                                    {
			rpn_Number(&(yyval.expr), fix_ATan((yyvsp[-1].constValue)));
		}
#line 4667 "src/asm/parser.c"
    break;

  case 271: /* relocexpr_no_str: "ATAN2" "(" const "," const ")"  */
#line 1505 "src/asm/parser.y"
                                                                   {
			rpn_Number(&(yyval.expr), fix_ATan2((yyvsp[-3].constValue), (yyvsp[-1].constValue)));
		}
#line 4675 "src/asm/parser.c"
    break;

  case 272: /* relocexpr_no_str: "STRCMP" "(" string "," string ")"  */
#line 1508 "src/asm/parser.y"
                                                                      {
			rpn_Number(&(yyval.expr), strcmp((yyvsp[-3].string), (yyvsp[-1].string)));
		}
#line 4683 "src/asm/parser.c"
    break;

  case 273: /* relocexpr_no_str: "STRIN" "(" string "," string ")"  */
#line 1511 "src/asm/parser.y"
                                                                     {
			char *p = strstr((yyvsp[-3].string), (yyvsp[-1].string));

			rpn_Number(&(yyval.expr), p ? p - (yyvsp[-3].string) + 1 : 0);
		}
#line 4693 "src/asm/parser.c"
    break;

  case 274: /* relocexpr_no_str: "STRRIN" "(" string "," string ")"  */
#line 1516 "src/asm/parser.y"
                                                                      {
			char *p = strrstr((yyvsp[-3].string), (yyvsp[-1].string));

			rpn_Number(&(yyval.expr), p ? p - (yyvsp[-3].string) + 1 : 0);
		}
#line 4703 "src/asm/parser.c"
    break;

  case 275: /* relocexpr_no_str: "STRLEN" "(" string ")"  */
#line 1521 "src/asm/parser.y"
                                                       {
			rpn_Number(&(yyval.expr), strlenUTF8((yyvsp[-1].string)));
		}
#line 4711 "src/asm/parser.c"
    break;

  case 276: /* relocexpr_no_str: "CHARLEN" "(" string ")"  */
#line 1524 "src/asm/parser.y"
                                                        {
			rpn_Number(&(yyval.expr), charlenUTF8((yyvsp[-1].string)));
		}
#line 4719 "src/asm/parser.c"
    break;

  case 277: /* relocexpr_no_str: "(" relocexpr ")"  */
#line 1527 "src/asm/parser.y"
                                              { (yyval.expr) = (yyvsp[-1].expr); }
#line 4725 "src/asm/parser.c"
    break;

  case 278: /* uconst: const  */
#line 1530 "src/asm/parser.y"
                        {
			(yyval.constValue) = (yyvsp[0].constValue);
			if ((yyval.constValue) < 0)
				fatalerror("Constant mustn't be negative: %d\n", (yyvsp[0].constValue));
		}
#line 4735 "src/asm/parser.c"
    break;

  case 279: /* const: relocexpr  */
#line 1537 "src/asm/parser.y"
                            { (yyval.constValue) = rpn_GetConstVal(&(yyvsp[0].expr)); }
#line 4741 "src/asm/parser.c"
    break;

  case 280: /* const_no_str: relocexpr_no_str  */
#line 1540 "src/asm/parser.y"
                                   { (yyval.constValue) = rpn_GetConstVal(&(yyvsp[0].expr)); }
#line 4747 "src/asm/parser.c"
    break;

  case 281: /* const_8bit: reloc_8bit  */
#line 1543 "src/asm/parser.y"
                             { (yyval.constValue) = rpn_GetConstVal(&(yyvsp[0].expr)); }
#line 4753 "src/asm/parser.c"
    break;

  case 283: /* string: "STRSUB" "(" string "," const "," uconst ")"  */
#line 1547 "src/asm/parser.y"
                                                                                    {
			size_t len = strlenUTF8((yyvsp[-5].string));
			uint32_t pos = adjustNegativePos((yyvsp[-3].constValue), len, "STRSUB");

			strsubUTF8((yyval.string), sizeof((yyval.string)), (yyvsp[-5].string), pos, (yyvsp[-1].constValue));
		}
#line 4764 "src/asm/parser.c"
    break;

  case 284: /* string: "STRSUB" "(" string "," const ")"  */
#line 1553 "src/asm/parser.y"
                                                                     {
			size_t len = strlenUTF8((yyvsp[-3].string));
			uint32_t pos = adjustNegativePos((yyvsp[-1].constValue), len, "STRSUB");

			strsubUTF8((yyval.string), sizeof((yyval.string)), (yyvsp[-3].string), pos, pos > len ? 0 : len + 1 - pos);
		}
#line 4775 "src/asm/parser.c"
    break;

  case 285: /* string: "CHARSUB" "(" string "," const ")"  */
#line 1559 "src/asm/parser.y"
                                                                      {
			size_t len = charlenUTF8((yyvsp[-3].string));
			uint32_t pos = adjustNegativePos((yyvsp[-1].constValue), len, "CHARSUB");

			charsubUTF8((yyval.string), (yyvsp[-3].string), pos);
		}
#line 4786 "src/asm/parser.c"
    break;

  case 286: /* string: "STRCAT" "(" ")"  */
#line 1565 "src/asm/parser.y"
                                                {
			(yyval.string)[0] = '\0';
		}
#line 4794 "src/asm/parser.c"
    break;

  case 287: /* string: "STRCAT" "(" strcat_args ")"  */
#line 1568 "src/asm/parser.y"
                                                            {
			strcpy((yyval.string), (yyvsp[-1].string));
		}
#line 4802 "src/asm/parser.c"
    break;

  case 288: /* string: "STRUPR" "(" string ")"  */
#line 1571 "src/asm/parser.y"
                                                       {
			upperstring((yyval.string), (yyvsp[-1].string));
		}
#line 4810 "src/asm/parser.c"
    break;

  case 289: /* string: "STRLWR" "(" string ")"  */
#line 1574 "src/asm/parser.y"
                                                       {
			lowerstring((yyval.string), (yyvsp[-1].string));
		}
#line 4818 "src/asm/parser.c"
    break;

  case 290: /* string: "STRRPL" "(" string "," string "," string ")"  */
#line 1577 "src/asm/parser.y"
                                                                                     {
			strrpl((yyval.string), sizeof((yyval.string)), (yyvsp[-5].string), (yyvsp[-3].string), (yyvsp[-1].string));
		}
#line 4826 "src/asm/parser.c"
    break;

  case 291: /* string: "STRFMT" "(" strfmt_args ")"  */
#line 1580 "src/asm/parser.y"
                                                            {
			strfmt((yyval.string), sizeof((yyval.string)), (yyvsp[-1].strfmtArgs).format, (yyvsp[-1].strfmtArgs).nbArgs, (yyvsp[-1].strfmtArgs).args);
			freeStrFmtArgList(&(yyvsp[-1].strfmtArgs));
		}
#line 4835 "src/asm/parser.c"
    break;

  case 293: /* strcat_args: strcat_args "," string  */
#line 1587 "src/asm/parser.y"
                                             {
			int ret = snprintf((yyval.string), sizeof((yyval.string)), "%s%s", (yyvsp[-2].string), (yyvsp[0].string));

			if (ret == -1)
				fatalerror("snprintf error in STRCAT: %s\n", strerror(errno));
			else if ((unsigned int)ret >= sizeof((yyval.string)))
				warning(WARNING_LONG_STR, "STRCAT: String too long '%s%s'\n",
					(yyvsp[-2].string), (yyvsp[0].string));
		}
#line 4849 "src/asm/parser.c"
    break;

  case 294: /* strfmt_args: string strfmt_va_args  */
#line 1598 "src/asm/parser.y"
                                        {
			(yyval.strfmtArgs).format = strdup((yyvsp[-1].string));
			(yyval.strfmtArgs).capacity = (yyvsp[0].strfmtArgs).capacity;
			(yyval.strfmtArgs).nbArgs = (yyvsp[0].strfmtArgs).nbArgs;
			(yyval.strfmtArgs).args = (yyvsp[0].strfmtArgs).args;
		}
#line 4860 "src/asm/parser.c"
    break;

  case 295: /* strfmt_va_args: %empty  */
#line 1606 "src/asm/parser.y"
                         {
			initStrFmtArgList(&(yyval.strfmtArgs));
		}
#line 4868 "src/asm/parser.c"
    break;

  case 296: /* strfmt_va_args: strfmt_va_args "," const_no_str  */
#line 1609 "src/asm/parser.y"
                                                      {
			size_t i = nextStrFmtArgListIndex(&(yyvsp[-2].strfmtArgs));

			(yyvsp[-2].strfmtArgs).args[i].number = (yyvsp[0].constValue);
			(yyvsp[-2].strfmtArgs).args[i].isNumeric = true;
			(yyval.strfmtArgs) = (yyvsp[-2].strfmtArgs);
		}
#line 4880 "src/asm/parser.c"
    break;

  case 297: /* strfmt_va_args: strfmt_va_args "," string  */
#line 1616 "src/asm/parser.y"
                                                {
			size_t i = nextStrFmtArgListIndex(&(yyvsp[-2].strfmtArgs));

			(yyvsp[-2].strfmtArgs).args[i].string = strdup((yyvsp[0].string));
			(yyvsp[-2].strfmtArgs).args[i].isNumeric = false;
			(yyval.strfmtArgs) = (yyvsp[-2].strfmtArgs);
		}
#line 4892 "src/asm/parser.c"
    break;

  case 298: /* section: "SECTION" sectmod string "," sectiontype sectorg sectattrs  */
#line 1625 "src/asm/parser.y"
                                                                                     {
			sect_NewSection((yyvsp[-4].string), (yyvsp[-2].constValue), (yyvsp[-1].constValue), &(yyvsp[0].sectSpec), (yyvsp[-5].sectMod));
		}
#line 4900 "src/asm/parser.c"
    break;

  case 299: /* sectmod: %empty  */
#line 1630 "src/asm/parser.y"
                         { (yyval.sectMod) = SECTION_NORMAL; }
#line 4906 "src/asm/parser.c"
    break;

  case 300: /* sectmod: "UNION"  */
#line 1631 "src/asm/parser.y"
                              { (yyval.sectMod) = SECTION_UNION; }
#line 4912 "src/asm/parser.c"
    break;

  case 301: /* sectmod: "FRAGMENT"  */
#line 1632 "src/asm/parser.y"
                                 { (yyval.sectMod) = SECTION_FRAGMENT; }
#line 4918 "src/asm/parser.c"
    break;

  case 302: /* sectiontype: "WRAM0"  */
#line 1635 "src/asm/parser.y"
                               { (yyval.constValue) = SECTTYPE_WRAM0; }
#line 4924 "src/asm/parser.c"
    break;

  case 303: /* sectiontype: "VRAM"  */
#line 1636 "src/asm/parser.y"
                              { (yyval.constValue) = SECTTYPE_VRAM; }
#line 4930 "src/asm/parser.c"
    break;

  case 304: /* sectiontype: "ROMX"  */
#line 1637 "src/asm/parser.y"
                              { (yyval.constValue) = SECTTYPE_ROMX; }
#line 4936 "src/asm/parser.c"
    break;

  case 305: /* sectiontype: "ROM0"  */
#line 1638 "src/asm/parser.y"
                              { (yyval.constValue) = SECTTYPE_ROM0; }
#line 4942 "src/asm/parser.c"
    break;

  case 306: /* sectiontype: "HRAM"  */
#line 1639 "src/asm/parser.y"
                              { (yyval.constValue) = SECTTYPE_HRAM; }
#line 4948 "src/asm/parser.c"
    break;

  case 307: /* sectiontype: "WRAMX"  */
#line 1640 "src/asm/parser.y"
                               { (yyval.constValue) = SECTTYPE_WRAMX; }
#line 4954 "src/asm/parser.c"
    break;

  case 308: /* sectiontype: "SRAM"  */
#line 1641 "src/asm/parser.y"
                              { (yyval.constValue) = SECTTYPE_SRAM; }
#line 4960 "src/asm/parser.c"
    break;

  case 309: /* sectiontype: "OAM"  */
#line 1642 "src/asm/parser.y"
                             { (yyval.constValue) = SECTTYPE_OAM; }
#line 4966 "src/asm/parser.c"
    break;

  case 310: /* sectorg: %empty  */
#line 1645 "src/asm/parser.y"
                         { (yyval.constValue) = -1; }
#line 4972 "src/asm/parser.c"
    break;

  case 311: /* sectorg: "[" uconst "]"  */
#line 1646 "src/asm/parser.y"
                                           {
			if ((yyvsp[-1].constValue) < 0 || (yyvsp[-1].constValue) >= 0x10000) {
				error("Address $%x is not 16-bit\n", (yyvsp[-1].constValue));
				(yyval.constValue) = -1;
			} else {
				(yyval.constValue) = (yyvsp[-1].constValue);
			}
		}
#line 4985 "src/asm/parser.c"
    break;

  case 312: /* sectattrs: %empty  */
#line 1656 "src/asm/parser.y"
                         {
			(yyval.sectSpec).alignment = 0;
			(yyval.sectSpec).alignOfs = 0;
			(yyval.sectSpec).bank = -1;
		}
#line 4995 "src/asm/parser.c"
    break;

  case 313: /* sectattrs: sectattrs "," "ALIGN" "[" uconst "]"  */
#line 1661 "src/asm/parser.y"
                                                                        {
			(yyval.sectSpec).alignment = (yyvsp[-1].constValue);
		}
#line 5003 "src/asm/parser.c"
    break;

  case 314: /* sectattrs: sectattrs "," "ALIGN" "[" uconst "," uconst "]"  */
#line 1664 "src/asm/parser.y"
                                                                                       {
			(yyval.sectSpec).alignment = (yyvsp[-3].constValue);
			(yyval.sectSpec).alignOfs = (yyvsp[-1].constValue);
		}
#line 5012 "src/asm/parser.c"
    break;

  case 315: /* sectattrs: sectattrs "," "BANK" "[" uconst "]"  */
#line 1668 "src/asm/parser.y"
                                                                       {
			/* We cannot check the validity of this now */
			(yyval.sectSpec).bank = (yyvsp[-1].constValue);
		}
#line 5021 "src/asm/parser.c"
    break;

  case 362: /* z80_adc: "adc" op_a_n  */
#line 1723 "src/asm/parser.y"
                                   {
			sect_AbsByte(0xCE);
			sect_RelByte(&(yyvsp[0].expr), 1);
		}
#line 5030 "src/asm/parser.c"
    break;

  case 363: /* z80_adc: "adc" op_a_r  */
#line 1727 "src/asm/parser.y"
                                   { sect_AbsByte(0x88 | (yyvsp[0].constValue)); }
#line 5036 "src/asm/parser.c"
    break;

  case 364: /* z80_add: "add" op_a_n  */
#line 1730 "src/asm/parser.y"
                                   {
			sect_AbsByte(0xC6);
			sect_RelByte(&(yyvsp[0].expr), 1);
		}
#line 5045 "src/asm/parser.c"
    break;

  case 365: /* z80_add: "add" op_a_r  */
#line 1734 "src/asm/parser.y"
                                   { sect_AbsByte(0x80 | (yyvsp[0].constValue)); }
#line 5051 "src/asm/parser.c"
    break;

  case 366: /* z80_add: "add" "hl" "," reg_ss  */
#line 1735 "src/asm/parser.y"
                                                     { sect_AbsByte(0x09 | ((yyvsp[0].constValue) << 4)); }
#line 5057 "src/asm/parser.c"
    break;

  case 367: /* z80_add: "add" "sp" "," reloc_8bit  */
#line 1736 "src/asm/parser.y"
                                                         {
			sect_AbsByte(0xE8);
			sect_RelByte(&(yyvsp[0].expr), 1);
		}
#line 5066 "src/asm/parser.c"
    break;

  case 368: /* z80_and: "and" op_a_n  */
#line 1743 "src/asm/parser.y"
                                   {
			sect_AbsByte(0xE6);
			sect_RelByte(&(yyvsp[0].expr), 1);
		}
#line 5075 "src/asm/parser.c"
    break;

  case 369: /* z80_and: "and" op_a_r  */
#line 1747 "src/asm/parser.y"
                                   { sect_AbsByte(0xA0 | (yyvsp[0].constValue)); }
#line 5081 "src/asm/parser.c"
    break;

  case 370: /* z80_bit: "bit" const_3bit "," reg_r  */
#line 1750 "src/asm/parser.y"
                                                     {
			sect_AbsByte(0xCB);
			sect_AbsByte(0x40 | ((yyvsp[-2].constValue) << 3) | (yyvsp[0].constValue));
		}
#line 5090 "src/asm/parser.c"
    break;

  case 371: /* z80_call: "call" reloc_16bit  */
#line 1756 "src/asm/parser.y"
                                         {
			sect_AbsByte(0xCD);
			sect_RelWord(&(yyvsp[0].expr), 1);
		}
#line 5099 "src/asm/parser.c"
    break;

  case 372: /* z80_call: "call" ccode "," reloc_16bit  */
#line 1760 "src/asm/parser.y"
                                                       {
			sect_AbsByte(0xC4 | ((yyvsp[-2].constValue) << 3));
			sect_RelWord(&(yyvsp[0].expr), 1);
		}
#line 5108 "src/asm/parser.c"
    break;

  case 373: /* z80_ccf: "ccf"  */
#line 1766 "src/asm/parser.y"
                            { sect_AbsByte(0x3F); }
#line 5114 "src/asm/parser.c"
    break;

  case 374: /* z80_cp: "cp" op_a_n  */
#line 1769 "src/asm/parser.y"
                                  {
			sect_AbsByte(0xFE);
			sect_RelByte(&(yyvsp[0].expr), 1);
		}
#line 5123 "src/asm/parser.c"
    break;

  case 375: /* z80_cp: "cp" op_a_r  */
#line 1773 "src/asm/parser.y"
                                  { sect_AbsByte(0xB8 | (yyvsp[0].constValue)); }
#line 5129 "src/asm/parser.c"
    break;

  case 376: /* z80_cpl: "cpl"  */
#line 1776 "src/asm/parser.y"
                            { sect_AbsByte(0x2F); }
#line 5135 "src/asm/parser.c"
    break;

  case 377: /* z80_daa: "daa"  */
#line 1779 "src/asm/parser.y"
                            { sect_AbsByte(0x27); }
#line 5141 "src/asm/parser.c"
    break;

  case 378: /* z80_dec: "dec" reg_r  */
#line 1782 "src/asm/parser.y"
                                  { sect_AbsByte(0x05 | ((yyvsp[0].constValue) << 3)); }
#line 5147 "src/asm/parser.c"
    break;

  case 379: /* z80_dec: "dec" reg_ss  */
#line 1783 "src/asm/parser.y"
                                   { sect_AbsByte(0x0B | ((yyvsp[0].constValue) << 4)); }
#line 5153 "src/asm/parser.c"
    break;

  case 380: /* z80_di: "di"  */
#line 1786 "src/asm/parser.y"
                           { sect_AbsByte(0xF3); }
#line 5159 "src/asm/parser.c"
    break;

  case 381: /* z80_ei: "ei"  */
#line 1789 "src/asm/parser.y"
                           { sect_AbsByte(0xFB); }
#line 5165 "src/asm/parser.c"
    break;

  case 382: /* z80_halt: "halt"  */
#line 1792 "src/asm/parser.y"
                             {
			sect_AbsByte(0x76);
			if (haltnop)
				sect_AbsByte(0x00);
		}
#line 5175 "src/asm/parser.c"
    break;

  case 383: /* z80_inc: "inc" reg_r  */
#line 1799 "src/asm/parser.y"
                                  { sect_AbsByte(0x04 | ((yyvsp[0].constValue) << 3)); }
#line 5181 "src/asm/parser.c"
    break;

  case 384: /* z80_inc: "inc" reg_ss  */
#line 1800 "src/asm/parser.y"
                                   { sect_AbsByte(0x03 | ((yyvsp[0].constValue) << 4)); }
#line 5187 "src/asm/parser.c"
    break;

  case 385: /* z80_jp: "jp" reloc_16bit  */
#line 1803 "src/asm/parser.y"
                                       {
			sect_AbsByte(0xC3);
			sect_RelWord(&(yyvsp[0].expr), 1);
		}
#line 5196 "src/asm/parser.c"
    break;

  case 386: /* z80_jp: "jp" ccode "," reloc_16bit  */
#line 1807 "src/asm/parser.y"
                                                     {
			sect_AbsByte(0xC2 | ((yyvsp[-2].constValue) << 3));
			sect_RelWord(&(yyvsp[0].expr), 1);
		}
#line 5205 "src/asm/parser.c"
    break;

  case 387: /* z80_jp: "jp" "hl"  */
#line 1811 "src/asm/parser.y"
                                     {
			sect_AbsByte(0xE9);
		}
#line 5213 "src/asm/parser.c"
    break;

  case 388: /* z80_jr: "jr" reloc_16bit  */
#line 1816 "src/asm/parser.y"
                                       {
			sect_AbsByte(0x18);
			sect_PCRelByte(&(yyvsp[0].expr), 1);
		}
#line 5222 "src/asm/parser.c"
    break;

  case 389: /* z80_jr: "jr" ccode "," reloc_16bit  */
#line 1820 "src/asm/parser.y"
                                                     {
			sect_AbsByte(0x20 | ((yyvsp[-2].constValue) << 3));
			sect_PCRelByte(&(yyvsp[0].expr), 1);
		}
#line 5231 "src/asm/parser.c"
    break;

  case 390: /* z80_ldi: "ldi" "[" "hl" "]" "," T_MODE_A  */
#line 1826 "src/asm/parser.y"
                                                                         {
			sect_AbsByte(0x02 | (2 << 4));
		}
#line 5239 "src/asm/parser.c"
    break;

  case 391: /* z80_ldi: "ldi" T_MODE_A "," "[" "hl" "]"  */
#line 1829 "src/asm/parser.y"
                                                                         {
			sect_AbsByte(0x0A | (2 << 4));
		}
#line 5247 "src/asm/parser.c"
    break;

  case 392: /* z80_ldd: "ldd" "[" "hl" "]" "," T_MODE_A  */
#line 1834 "src/asm/parser.y"
                                                                         {
			sect_AbsByte(0x02 | (3 << 4));
		}
#line 5255 "src/asm/parser.c"
    break;

  case 393: /* z80_ldd: "ldd" T_MODE_A "," "[" "hl" "]"  */
#line 1837 "src/asm/parser.y"
                                                                         {
			sect_AbsByte(0x0A | (3 << 4));
		}
#line 5263 "src/asm/parser.c"
    break;

  case 394: /* z80_ldio: "ldh" T_MODE_A "," op_mem_ind  */
#line 1842 "src/asm/parser.y"
                                                        {
			rpn_CheckHRAM(&(yyvsp[0].expr), &(yyvsp[0].expr));

			sect_AbsByte(0xF0);
			sect_RelByte(&(yyvsp[0].expr), 1);
		}
#line 5274 "src/asm/parser.c"
    break;

  case 395: /* z80_ldio: "ldh" op_mem_ind "," T_MODE_A  */
#line 1848 "src/asm/parser.y"
                                                        {
			rpn_CheckHRAM(&(yyvsp[-2].expr), &(yyvsp[-2].expr));

			sect_AbsByte(0xE0);
			sect_RelByte(&(yyvsp[-2].expr), 1);
		}
#line 5285 "src/asm/parser.c"
    break;

  case 396: /* z80_ldio: "ldh" T_MODE_A "," c_ind  */
#line 1854 "src/asm/parser.y"
                                                   {
			sect_AbsByte(0xF2);
		}
#line 5293 "src/asm/parser.c"
    break;

  case 397: /* z80_ldio: "ldh" c_ind "," T_MODE_A  */
#line 1857 "src/asm/parser.y"
                                                   {
			sect_AbsByte(0xE2);
		}
#line 5301 "src/asm/parser.c"
    break;

  case 399: /* c_ind: "[" relocexpr "+" T_MODE_C "]"  */
#line 1863 "src/asm/parser.y"
                                                                {
			if (!rpn_isKnown(&(yyvsp[-3].expr)) || (yyvsp[-3].expr).val != 0xff00)
				error("Expected constant expression equal to $FF00 for \"$ff00+c\"\n");
		}
#line 5310 "src/asm/parser.c"
    break;

  case 408: /* z80_ld_hl: "ld" "hl" "," "sp" reloc_8bit_offset  */
#line 1879 "src/asm/parser.y"
                                                                         {
			sect_AbsByte(0xF8);
			sect_RelByte(&(yyvsp[0].expr), 1);
		}
#line 5319 "src/asm/parser.c"
    break;

  case 409: /* z80_ld_hl: "ld" "hl" "," reloc_16bit  */
#line 1883 "src/asm/parser.y"
                                                         {
			sect_AbsByte(0x01 | (REG_HL << 4));
			sect_RelWord(&(yyvsp[0].expr), 1);
		}
#line 5328 "src/asm/parser.c"
    break;

  case 410: /* z80_ld_sp: "ld" "sp" "," "hl"  */
#line 1889 "src/asm/parser.y"
                                                       { sect_AbsByte(0xF9); }
#line 5334 "src/asm/parser.c"
    break;

  case 411: /* z80_ld_sp: "ld" "sp" "," reloc_16bit  */
#line 1890 "src/asm/parser.y"
                                                         {
			sect_AbsByte(0x01 | (REG_SP << 4));
			sect_RelWord(&(yyvsp[0].expr), 1);
		}
#line 5343 "src/asm/parser.c"
    break;

  case 412: /* z80_ld_mem: "ld" op_mem_ind "," "sp"  */
#line 1896 "src/asm/parser.y"
                                                        {
			sect_AbsByte(0x08);
			sect_RelWord(&(yyvsp[-2].expr), 1);
		}
#line 5352 "src/asm/parser.c"
    break;

  case 413: /* z80_ld_mem: "ld" op_mem_ind "," T_MODE_A  */
#line 1900 "src/asm/parser.y"
                                                       {
			if (optimizeLoads && rpn_isKnown(&(yyvsp[-2].expr))
			 && (yyvsp[-2].expr).val >= 0xFF00) {
				sect_AbsByte(0xE0);
				sect_AbsByte((yyvsp[-2].expr).val & 0xFF);
				rpn_Free(&(yyvsp[-2].expr));
			} else {
				sect_AbsByte(0xEA);
				sect_RelWord(&(yyvsp[-2].expr), 1);
			}
		}
#line 5368 "src/asm/parser.c"
    break;

  case 414: /* z80_ld_cind: "ld" c_ind "," T_MODE_A  */
#line 1913 "src/asm/parser.y"
                                                  {
			sect_AbsByte(0xE2);
		}
#line 5376 "src/asm/parser.c"
    break;

  case 415: /* z80_ld_rr: "ld" reg_rr "," T_MODE_A  */
#line 1918 "src/asm/parser.y"
                                                   {
			sect_AbsByte(0x02 | ((yyvsp[-2].constValue) << 4));
		}
#line 5384 "src/asm/parser.c"
    break;

  case 416: /* z80_ld_r: "ld" reg_r "," reloc_8bit  */
#line 1923 "src/asm/parser.y"
                                                    {
			sect_AbsByte(0x06 | ((yyvsp[-2].constValue) << 3));
			sect_RelByte(&(yyvsp[0].expr), 1);
		}
#line 5393 "src/asm/parser.c"
    break;

  case 417: /* z80_ld_r: "ld" reg_r "," reg_r  */
#line 1927 "src/asm/parser.y"
                                               {
			if (((yyvsp[-2].constValue) == REG_HL_IND) && ((yyvsp[0].constValue) == REG_HL_IND))
				error("LD [HL],[HL] not a valid instruction\n");
			else
				sect_AbsByte(0x40 | ((yyvsp[-2].constValue) << 3) | (yyvsp[0].constValue));
		}
#line 5404 "src/asm/parser.c"
    break;

  case 418: /* z80_ld_a: "ld" reg_r "," c_ind  */
#line 1935 "src/asm/parser.y"
                                               {
			if ((yyvsp[-2].constValue) == REG_A)
				sect_AbsByte(0xF2);
			else
				error("Destination operand must be A\n");
		}
#line 5415 "src/asm/parser.c"
    break;

  case 419: /* z80_ld_a: "ld" reg_r "," reg_rr  */
#line 1941 "src/asm/parser.y"
                                                {
			if ((yyvsp[-2].constValue) == REG_A)
				sect_AbsByte(0x0A | ((yyvsp[0].constValue) << 4));
			else
				error("Destination operand must be A\n");
		}
#line 5426 "src/asm/parser.c"
    break;

  case 420: /* z80_ld_a: "ld" reg_r "," op_mem_ind  */
#line 1947 "src/asm/parser.y"
                                                    {
			if ((yyvsp[-2].constValue) == REG_A) {
				if (optimizeLoads && rpn_isKnown(&(yyvsp[0].expr))
				 && (yyvsp[0].expr).val >= 0xFF00) {
					sect_AbsByte(0xF0);
					sect_AbsByte((yyvsp[0].expr).val & 0xFF);
					rpn_Free(&(yyvsp[0].expr));
				} else {
					sect_AbsByte(0xFA);
					sect_RelWord(&(yyvsp[0].expr), 1);
				}
			} else {
				error("Destination operand must be A\n");
				rpn_Free(&(yyvsp[0].expr));
			}
		}
#line 5447 "src/asm/parser.c"
    break;

  case 421: /* z80_ld_ss: "ld" "bc" "," reloc_16bit  */
#line 1965 "src/asm/parser.y"
                                                         {
			sect_AbsByte(0x01 | (REG_BC << 4));
			sect_RelWord(&(yyvsp[0].expr), 1);
		}
#line 5456 "src/asm/parser.c"
    break;

  case 422: /* z80_ld_ss: "ld" "de" "," reloc_16bit  */
#line 1969 "src/asm/parser.y"
                                                         {
			sect_AbsByte(0x01 | (REG_DE << 4));
			sect_RelWord(&(yyvsp[0].expr), 1);
		}
#line 5465 "src/asm/parser.c"
    break;

  case 423: /* z80_nop: "nop"  */
#line 1979 "src/asm/parser.y"
                            { sect_AbsByte(0x00); }
#line 5471 "src/asm/parser.c"
    break;

  case 424: /* z80_or: "or" op_a_n  */
#line 1982 "src/asm/parser.y"
                                  {
			sect_AbsByte(0xF6);
			sect_RelByte(&(yyvsp[0].expr), 1);
		}
#line 5480 "src/asm/parser.c"
    break;

  case 425: /* z80_or: "or" op_a_r  */
#line 1986 "src/asm/parser.y"
                                  { sect_AbsByte(0xB0 | (yyvsp[0].constValue)); }
#line 5486 "src/asm/parser.c"
    break;

  case 426: /* z80_pop: "pop" reg_tt  */
#line 1989 "src/asm/parser.y"
                                   { sect_AbsByte(0xC1 | ((yyvsp[0].constValue) << 4)); }
#line 5492 "src/asm/parser.c"
    break;

  case 427: /* z80_push: "push" reg_tt  */
#line 1992 "src/asm/parser.y"
                                    { sect_AbsByte(0xC5 | ((yyvsp[0].constValue) << 4)); }
#line 5498 "src/asm/parser.c"
    break;

  case 428: /* z80_res: "res" const_3bit "," reg_r  */
#line 1995 "src/asm/parser.y"
                                                     {
			sect_AbsByte(0xCB);
			sect_AbsByte(0x80 | ((yyvsp[-2].constValue) << 3) | (yyvsp[0].constValue));
		}
#line 5507 "src/asm/parser.c"
    break;

  case 429: /* z80_ret: "ret"  */
#line 2001 "src/asm/parser.y"
                            { sect_AbsByte(0xC9); }
#line 5513 "src/asm/parser.c"
    break;

  case 430: /* z80_ret: "ret" ccode  */
#line 2002 "src/asm/parser.y"
                                  { sect_AbsByte(0xC0 | ((yyvsp[0].constValue) << 3)); }
#line 5519 "src/asm/parser.c"
    break;

  case 431: /* z80_reti: "reti"  */
#line 2005 "src/asm/parser.y"
                             { sect_AbsByte(0xD9); }
#line 5525 "src/asm/parser.c"
    break;

  case 432: /* z80_rl: "rl" reg_r  */
#line 2008 "src/asm/parser.y"
                                 {
			sect_AbsByte(0xCB);
			sect_AbsByte(0x10 | (yyvsp[0].constValue));
		}
#line 5534 "src/asm/parser.c"
    break;

  case 433: /* z80_rla: "rla"  */
#line 2014 "src/asm/parser.y"
                            { sect_AbsByte(0x17); }
#line 5540 "src/asm/parser.c"
    break;

  case 434: /* z80_rlc: "rlc" reg_r  */
#line 2017 "src/asm/parser.y"
                                  {
			sect_AbsByte(0xCB);
			sect_AbsByte(0x00 | (yyvsp[0].constValue));
		}
#line 5549 "src/asm/parser.c"
    break;

  case 435: /* z80_rlca: "rlca"  */
#line 2023 "src/asm/parser.y"
                             { sect_AbsByte(0x07); }
#line 5555 "src/asm/parser.c"
    break;

  case 436: /* z80_rr: "rr" reg_r  */
#line 2026 "src/asm/parser.y"
                                 {
			sect_AbsByte(0xCB);
			sect_AbsByte(0x18 | (yyvsp[0].constValue));
		}
#line 5564 "src/asm/parser.c"
    break;

  case 437: /* z80_rra: "rra"  */
#line 2032 "src/asm/parser.y"
                            { sect_AbsByte(0x1F); }
#line 5570 "src/asm/parser.c"
    break;

  case 438: /* z80_rrc: "rrc" reg_r  */
#line 2035 "src/asm/parser.y"
                                  {
			sect_AbsByte(0xCB);
			sect_AbsByte(0x08 | (yyvsp[0].constValue));
		}
#line 5579 "src/asm/parser.c"
    break;

  case 439: /* z80_rrca: "rrca"  */
#line 2041 "src/asm/parser.y"
                             { sect_AbsByte(0x0F); }
#line 5585 "src/asm/parser.c"
    break;

  case 440: /* z80_rst: "rst" reloc_8bit  */
#line 2044 "src/asm/parser.y"
                                       {
			rpn_CheckRST(&(yyvsp[0].expr), &(yyvsp[0].expr));
			if (!rpn_isKnown(&(yyvsp[0].expr)))
				sect_RelByte(&(yyvsp[0].expr), 0);
			else
				sect_AbsByte(0xC7 | (yyvsp[0].expr).val);
			rpn_Free(&(yyvsp[0].expr));
		}
#line 5598 "src/asm/parser.c"
    break;

  case 441: /* z80_sbc: "sbc" op_a_n  */
#line 2054 "src/asm/parser.y"
                                   {
			sect_AbsByte(0xDE);
			sect_RelByte(&(yyvsp[0].expr), 1);
		}
#line 5607 "src/asm/parser.c"
    break;

  case 442: /* z80_sbc: "sbc" op_a_r  */
#line 2058 "src/asm/parser.y"
                                   { sect_AbsByte(0x98 | (yyvsp[0].constValue)); }
#line 5613 "src/asm/parser.c"
    break;

  case 443: /* z80_scf: "scf"  */
#line 2061 "src/asm/parser.y"
                            { sect_AbsByte(0x37); }
#line 5619 "src/asm/parser.c"
    break;

  case 444: /* z80_set: "SET" const_3bit "," reg_r  */
#line 2064 "src/asm/parser.y"
                                                     {
			sect_AbsByte(0xCB);
			sect_AbsByte(0xC0 | ((yyvsp[-2].constValue) << 3) | (yyvsp[0].constValue));
		}
#line 5628 "src/asm/parser.c"
    break;

  case 445: /* z80_sla: "sla" reg_r  */
#line 2070 "src/asm/parser.y"
                                  {
			sect_AbsByte(0xCB);
			sect_AbsByte(0x20 | (yyvsp[0].constValue));
		}
#line 5637 "src/asm/parser.c"
    break;

  case 446: /* z80_sra: "sra" reg_r  */
#line 2076 "src/asm/parser.y"
                                  {
			sect_AbsByte(0xCB);
			sect_AbsByte(0x28 | (yyvsp[0].constValue));
		}
#line 5646 "src/asm/parser.c"
    break;

  case 447: /* z80_srl: "srl" reg_r  */
#line 2082 "src/asm/parser.y"
                                  {
			sect_AbsByte(0xCB);
			sect_AbsByte(0x38 | (yyvsp[0].constValue));
		}
#line 5655 "src/asm/parser.c"
    break;

  case 448: /* z80_stop: "stop"  */
#line 2088 "src/asm/parser.y"
                             {
			sect_AbsByte(0x10);
			sect_AbsByte(0x00);
		}
#line 5664 "src/asm/parser.c"
    break;

  case 449: /* z80_stop: "stop" reloc_8bit  */
#line 2092 "src/asm/parser.y"
                                        {
			sect_AbsByte(0x10);
			sect_RelByte(&(yyvsp[0].expr), 1);
		}
#line 5673 "src/asm/parser.c"
    break;

  case 450: /* z80_sub: "sub" op_a_n  */
#line 2098 "src/asm/parser.y"
                                   {
			sect_AbsByte(0xD6);
			sect_RelByte(&(yyvsp[0].expr), 1);
		}
#line 5682 "src/asm/parser.c"
    break;

  case 451: /* z80_sub: "sub" op_a_r  */
#line 2102 "src/asm/parser.y"
                                   { sect_AbsByte(0x90 | (yyvsp[0].constValue)); }
#line 5688 "src/asm/parser.c"
    break;

  case 452: /* z80_swap: "swap" reg_r  */
#line 2105 "src/asm/parser.y"
                                   {
			sect_AbsByte(0xCB);
			sect_AbsByte(0x30 | (yyvsp[0].constValue));
		}
#line 5697 "src/asm/parser.c"
    break;

  case 453: /* z80_xor: "xor" op_a_n  */
#line 2111 "src/asm/parser.y"
                                   {
			sect_AbsByte(0xEE);
			sect_RelByte(&(yyvsp[0].expr), 1);
		}
#line 5706 "src/asm/parser.c"
    break;

  case 454: /* z80_xor: "xor" op_a_r  */
#line 2115 "src/asm/parser.y"
                                   { sect_AbsByte(0xA8 | (yyvsp[0].constValue)); }
#line 5712 "src/asm/parser.c"
    break;

  case 455: /* op_mem_ind: "[" reloc_16bit "]"  */
#line 2118 "src/asm/parser.y"
                                                { (yyval.expr) = (yyvsp[-1].expr); }
#line 5718 "src/asm/parser.c"
    break;

  case 457: /* op_a_r: T_MODE_A "," reg_r  */
#line 2122 "src/asm/parser.y"
                                         { (yyval.constValue) = (yyvsp[0].constValue); }
#line 5724 "src/asm/parser.c"
    break;

  case 459: /* op_a_n: T_MODE_A "," reloc_8bit  */
#line 2126 "src/asm/parser.y"
                                              { (yyval.expr) = (yyvsp[0].expr); }
#line 5730 "src/asm/parser.c"
    break;

  case 474: /* ccode: "nz"  */
#line 2157 "src/asm/parser.y"
                          { (yyval.constValue) = CC_NZ; }
#line 5736 "src/asm/parser.c"
    break;

  case 475: /* ccode: "z"  */
#line 2158 "src/asm/parser.y"
                         { (yyval.constValue) = CC_Z; }
#line 5742 "src/asm/parser.c"
    break;

  case 476: /* ccode: "nc"  */
#line 2159 "src/asm/parser.y"
                          { (yyval.constValue) = CC_NC; }
#line 5748 "src/asm/parser.c"
    break;

  case 477: /* ccode: "c"  */
#line 2160 "src/asm/parser.y"
                            { (yyval.constValue) = CC_C; }
#line 5754 "src/asm/parser.c"
    break;

  case 478: /* reg_r: T_MODE_B  */
#line 2163 "src/asm/parser.y"
                           { (yyval.constValue) = REG_B; }
#line 5760 "src/asm/parser.c"
    break;

  case 479: /* reg_r: T_MODE_C  */
#line 2164 "src/asm/parser.y"
                           { (yyval.constValue) = REG_C; }
#line 5766 "src/asm/parser.c"
    break;

  case 480: /* reg_r: T_MODE_D  */
#line 2165 "src/asm/parser.y"
                           { (yyval.constValue) = REG_D; }
#line 5772 "src/asm/parser.c"
    break;

  case 481: /* reg_r: T_MODE_E  */
#line 2166 "src/asm/parser.y"
                           { (yyval.constValue) = REG_E; }
#line 5778 "src/asm/parser.c"
    break;

  case 482: /* reg_r: T_MODE_H  */
#line 2167 "src/asm/parser.y"
                           { (yyval.constValue) = REG_H; }
#line 5784 "src/asm/parser.c"
    break;

  case 483: /* reg_r: T_MODE_L  */
#line 2168 "src/asm/parser.y"
                           { (yyval.constValue) = REG_L; }
#line 5790 "src/asm/parser.c"
    break;

  case 484: /* reg_r: "[" "hl" "]"  */
#line 2169 "src/asm/parser.y"
                                              { (yyval.constValue) = REG_HL_IND; }
#line 5796 "src/asm/parser.c"
    break;

  case 485: /* reg_r: T_MODE_A  */
#line 2170 "src/asm/parser.y"
                           { (yyval.constValue) = REG_A; }
#line 5802 "src/asm/parser.c"
    break;

  case 486: /* reg_tt: "bc"  */
#line 2173 "src/asm/parser.y"
                            { (yyval.constValue) = REG_BC; }
#line 5808 "src/asm/parser.c"
    break;

  case 487: /* reg_tt: "de"  */
#line 2174 "src/asm/parser.y"
                            { (yyval.constValue) = REG_DE; }
#line 5814 "src/asm/parser.c"
    break;

  case 488: /* reg_tt: "hl"  */
#line 2175 "src/asm/parser.y"
                            { (yyval.constValue) = REG_HL; }
#line 5820 "src/asm/parser.c"
    break;

  case 489: /* reg_tt: "af"  */
#line 2176 "src/asm/parser.y"
                            { (yyval.constValue) = REG_AF; }
#line 5826 "src/asm/parser.c"
    break;

  case 490: /* reg_ss: "bc"  */
#line 2179 "src/asm/parser.y"
                            { (yyval.constValue) = REG_BC; }
#line 5832 "src/asm/parser.c"
    break;

  case 491: /* reg_ss: "de"  */
#line 2180 "src/asm/parser.y"
                            { (yyval.constValue) = REG_DE; }
#line 5838 "src/asm/parser.c"
    break;

  case 492: /* reg_ss: "hl"  */
#line 2181 "src/asm/parser.y"
                            { (yyval.constValue) = REG_HL; }
#line 5844 "src/asm/parser.c"
    break;

  case 493: /* reg_ss: "sp"  */
#line 2182 "src/asm/parser.y"
                            { (yyval.constValue) = REG_SP; }
#line 5850 "src/asm/parser.c"
    break;

  case 494: /* reg_rr: "[" "bc" "]"  */
#line 2185 "src/asm/parser.y"
                                              { (yyval.constValue) = REG_BC_IND; }
#line 5856 "src/asm/parser.c"
    break;

  case 495: /* reg_rr: "[" "de" "]"  */
#line 2186 "src/asm/parser.y"
                                              { (yyval.constValue) = REG_DE_IND; }
#line 5862 "src/asm/parser.c"
    break;

  case 496: /* reg_rr: hl_ind_inc  */
#line 2187 "src/asm/parser.y"
                             { (yyval.constValue) = REG_HL_INDINC; }
#line 5868 "src/asm/parser.c"
    break;

  case 497: /* reg_rr: hl_ind_dec  */
#line 2188 "src/asm/parser.y"
                             { (yyval.constValue) = REG_HL_INDDEC; }
#line 5874 "src/asm/parser.c"
    break;


#line 5878 "src/asm/parser.c"

        default: break;
      }
    if (yychar_backup != yychar)
      YY_LAC_DISCARD ("yychar change");
  }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      {
        yypcontext_t yyctx
          = {yyssp, yyesa, &yyes, &yyes_capacity, yytoken};
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        if (yychar != YYEMPTY)
          YY_LAC_ESTABLISH;
        yysyntax_error_status = yysyntax_error (&yymsg_alloc, &yymsg, &yyctx);
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == -1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = YY_CAST (char *,
                             YYSTACK_ALLOC (YY_CAST (YYSIZE_T, yymsg_alloc)));
            if (yymsg)
              {
                yysyntax_error_status
                  = yysyntax_error (&yymsg_alloc, &yymsg, &yyctx);
                yymsgp = yymsg;
              }
            else
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = YYENOMEM;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == YYENOMEM)
          goto yyexhaustedlab;
      }
    }

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= T_EOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == T_EOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  /* If the stack popping above didn't lose the initial context for the
     current lookahead token, the shift below will for sure.  */
  YY_LAC_DISCARD ("error recovery");

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;


#if 1
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturn;
#endif


/*-------------------------------------------------------.
| yyreturn -- parsing is finished, clean up and return.  |
`-------------------------------------------------------*/
yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  if (yyes != yyesa)
    YYSTACK_FREE (yyes);
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
  return yyresult;
}

#line 2199 "src/asm/parser.y"

